!-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for GLUT software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------

C  GLUT Fortran program to render simple red scene.

c This is a fortran 90 program in fixed source form.
c In a risky move, this program assumes that the default kind of
C integer is the same as f90glint and f90glsizei and also that the
c default real is the same kind as f90glfloat

        subroutine display
        use f90gl
        use f90glu
        use f90glut
        call f90glclear(GL_COLOR_BUFFER_BIT + GL_DEPTH_BUFFER_BIT)
        call f90glpushmatrix
        call f90glscalef(1.3, 1.3, 1.3)
        call f90glrotatef(20.0, 1.0, 0.0, 0.0)

        call f90glpushmatrix
        call f90gltranslatef(-0.75, 0.5, 0.0)
        call f90glrotatef(90.0, 1.0, 0.0, 0.0)
        call f90glutsolidtorus(0.275_f90gldouble, 0.85_f90gldouble,
     2                      10, 15)
        call f90glpopmatrix

        call f90glpushmatrix
        call f90gltranslatef(-0.75, -0.5, 0.0)
        call f90glrotatef(270.0, 1.0, 0.0, 0.0)
        call f90glutsolidtetrahedron
        call f90glpopmatrix

        call f90glpushmatrix
        call f90gltranslatef(0.75, 0.0, -1.0)
        call f90glutsolidicosahedron
        call f90glpopmatrix

        call f90glpopmatrix
        call f90glflush
        end

        subroutine reshape(w,h)
        use f90gl
        use f90glu
        use f90glut
        integer w,h
        real(f90gldouble) wr,hr
        double precision d
        call f90glviewport(0, 0, w, h)
        call f90glmatrixmode(GL_PROJECTION)
        call f90glloadidentity
        wr = w
        hr = h
        d = 1.0d0
        if ( w .le. h ) then
           call f90glortho(-2.5_f90gldouble, 2.5_f90gldouble,
     2       -2.5_f90gldouble * hr/wr, 2.5_f90gldouble * hr/wr,
     3       -10.0_f90gldouble, 10.0_f90gldouble)
        else
           call f90glortho(-2.5_f90gldouble * hr/wr,
     1        2.5_f90gldouble * hr/wr,
     2       -2.5_f90gldouble, 2.5_f90gldouble, -10.0_f90gldouble,
     3       10.0_f90gldouble)
        end if
        call f90glmatrixmode(GL_MODELVIEW)
        end
        
        subroutine submenu(value)
        use f90gl
        use f90glu
        use f90glut
        integer value
        if ( value .eq. 1 ) then
          call f90glenable(GL_DEPTH_TEST)
          call f90glenable(GL_LIGHTING)
          call f90gldisable(GL_BLEND)
          call f90glpolygonmode(GL_FRONT_AND_BACK, GL_FILL)
        else
          call f90gldisable(GL_DEPTH_TEST)
          call f90gldisable(GL_LIGHTING)
          call f90glcolor3f(1.0, 1.0, 1.0)
          call f90glpolygonmode(GL_FRONT_AND_BACK, GL_LINE)
          call f90glenable(GL_LINE_SMOOTH)
          call f90glenable(GL_BLEND)
          call f90glblendfunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
        end if
        call f90glutpostredisplay
        end

        subroutine mainmenu(value)
        integer value
        if (value == 666) stop
        end

        subroutine myinit
        use f90gl
        use f90glu
        use f90glut
        real lambient(4), ldiffuse(4), lspecular(4), lposition(4)
        data lambient /0.0, 0.0, 0.0, 1.0/
        data ldiffuse /1.0, 0.0, 0.0, 1.0/
        data lspecular /1.0, 1.0, 1.0, 1.0/
        data lposition /1.0, 1.0, 1.0, 0.0/

        call f90gllightfv(GL_LIGHT0, GL_AMBIENT, lambient)
        call f90gllightfv(GL_LIGHT0, GL_DIFFUSE, ldiffuse)
        call f90gllightfv(GL_LIGHT0, GL_SPECULAR, lspecular)
        call f90gllightfv(GL_LIGHT0, GL_POSITION, lposition)
        call f90glenable(GL_LIGHT0)
        call f90gldepthfunc(GL_LESS)
        call f90glenable(GL_DEPTH_TEST)
        call f90glenable(GL_LIGHTING)
        end

        program main
        use f90gl
        use f90glu
        use f90glut
        external display
        external reshape
        external submenu
        external mainmenu
        call f90glutinitwindowposition(500,500)
        call f90glutinitwindowsize(500,500)
        call f90glutinit
        i = f90glutcreatewindow('Fortran GLUT program')
        call myinit
        call f90glutdisplayfunc(display)
        call f90glutreshapefunc(reshape)
        i = f90glutcreatemenu(submenu)
        call f90glutaddmenuentry('Filled', 1)
        call f90glutaddmenuentry('Outline', 2)
        j = f90glutcreatemenu(mainmenu)
        call f90glutaddsubmenu('Polygon mode', i)
        call f90glutaddmenuentry('Quit', 666)
        call f90glutattachmenu(GLUT_RIGHT_BUTTON)
        call f90glutmainloop
        end

