!-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for GLUT software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------

C  GLUT Fortran 90 program to draw red light sphere.

        subroutine display
        use f90gl
        use f90glut
        call f90glclear(GL_COLOR_BUFFER_BIT + GL_DEPTH_BUFFER_BIT)
        call f90glcalllist(1)
        call f90glutswapbuffers
        end

        subroutine gfxinit
        use f90gl
        use f90glu
        use f90glut
        real(f90glfloat) :: diffuse(4) = (/1.0, 0.0, 0.0, 1.0/), 
     2                      pos(4)     = (/1.0, 1.0, 1.0, 0.0/)
        call f90glnewlist(1, GL_COMPILE)
        call f90glutsolidsphere(1.0_f90gldouble, 20, 20)
        call f90glendlist
        call f90gllightfv(GL_LIGHT0, GL_DIFFUSE, diffuse)
        call f90gllightfv(GL_LIGHT0, GL_POSITION, pos)
        call f90glenable(GL_LIGHTING)
        call f90glenable(GL_LIGHT0)
        call f90glenable(GL_DEPTH_TEST)
        call f90glmatrixmode(GL_PROJECTION)
        call f90gluperspective(40.0_f90gldouble, 1.0_f90gldouble,
     2                       1.0_f90gldouble, 10.0_f90gldouble)
        call f90glmatrixmode(GL_MODELVIEW)
        call f90glulookat(
     1            0.0_f90gldouble, 0.0_f90gldouble, 5.0_f90gldouble,
     2            0.0_f90gldouble, 0.0_f90gldouble, 0.0_f90gldouble,
     3            0.0_f90gldouble, 1.0_f90gldouble, 1.0_f90gldouble)
        call f90gltranslatef(0.0, 0.0, -1.0)
        end

        program main
        use f90glut
        external display
        call f90glutinit
        call f90glutinitdisplaymode(GLUT_DOUBLE+GLUT_RGB+GLUT_DEPTH)
        i = f90glutcreatewindow('Fortran GLUT sphere')
        call gfxinit
        call f90glutdisplayfunc(display)
        call f90glutmainloop
        end

