/*-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------*/

#ifdef FBIND


#include <string.h>
#include <GL/gl.h>
#define MIN2( A, B )   ( (A)<(B) ? (A) : (B) )

/* equalence of types

 OpenGL          description              C     extended fortan 77

GLboolean   8-bit unsigned integer  unsigned char  logical*1
GLbyte      8-bit integer           signed char    integer*1
GLubyte     8-bit unsigned integer  unsigned char  integer*1
GLshort    16-bit integer           short          integer*2
GLushort   16-bit unsigned integer  unsigned short integer*2
GLint      32-bit integer           long           integer*4
GLuint     32-bit unsigned integer  unsigned long  integer*4
GLenum     32-bit unsigned integer  unsigned long  integer*4
GLbitfield 32-bit unsigned integer  unsigned long  integer*4
GLsizei    32-bit integer           long           integer*4
GLfloat    32-bit floating point    float          real*4
GLclampf   32-bit floating point    float          real*4
GLdouble   64-bit floating point    double         real*8
GLclampd   64-bit floating point    double         real*8
GLvoid     generic pointer GLvoid*  void           any array


   f90gl            fortran 90

f90glboolean    logical(kind=k) where k gives a 1 byte logical, if possible
f90glbyte       selected_int_kind(2)
f90glubyte      selected_int_kind(2)
f90glshort      selected_int_kind(4)
f90glushort     selected_int_kind(4)
f90glint        selected_int_kind(9)
f90gluint       selected_int_kind(9)
f90glenum       selected_int_kind(9)
f90glbitfield   selected_int_kind(9)
f90glsizei      selected_int_kind(9)
f90glfloat      selected_real_kind(6)
f90glclampf     selected_real_kind(6)
f90gldouble     selected_real_kind(15)
f90glclampd     selected_real_kind(15)
f90glvoid       any array

*/

/*
 * Mapping of Fortran types to C types:
 */

#define f90glboolean  unsigned char *
#define f90glbyte     signed char *
#define f90glubyte    unsigned char *
#define f90glshort    short *
#define f90glushort   unsigned short *
#define f90glint      long *
#define f90gluint     unsigned long *
#define f90glenum     unsigned long *
#define f90glbitfield unsigned long *
#define f90glsizei    long *
#define f90glfloat    float *
#define f90glclampf   float *
#define f90gldouble   double *
#define f90glclampd   double *
#define f90glvoid     long *

/* procedure name mangling */

#if FBIND==1
#define f9eglColorMask                 f9eglcolormask
#define f9aglLineStipple               f9agllinestipple
#define f9bglPolygonStipple            f9bglpolygonstipple
#define f9cglPolygonStipple            f9cglpolygonstipple
#define f9bglGetPolygonStipple         f9bglgetpolygonstipple
#define f9cglGetPolygonStipple         f9cglgetpolygonstipple
#define f9eglEdgeFlag                  f9egledgeflag
#define f9eglEdgeFlagv                 f9egledgeflagv
#define f9eglIsEnabled                 f9eglisenabled
#define f9eglGetBooleanv               f9eglgetbooleanv
#define f9yglGetString                 f9yglgetstring
#define f9eglDepthMask                 f9egldepthmask
#define f9eglIsList                    f9eglislist
#define f9aglVertex2s                  f9aglvertex2s
#define f9aglVertex3s                  f9aglvertex3s
#define f9aglVertex4s                  f9aglvertex4s
#define f9aglVertex2sv                 f9aglvertex2sv
#define f9aglVertex3sv                 f9aglvertex3sv
#define f9aglVertex4sv                 f9aglvertex4sv
#define f9bglNormal3b                  f9bglnormal3b
#define f9cglNormal3b                  f9cglnormal3b
#define f9aglNormal3s                  f9aglnormal3s
#define f9bglNormal3bv                 f9bglnormal3bv
#define f9cglNormal3bv                 f9cglnormal3bv
#define f9aglNormal3sv                 f9aglnormal3sv
#define f9aglIndexs                    f9aglindexs
#define f9aglIndexsv                   f9aglindexsv
#define f9bglColor3b                   f9bglcolor3b
#define f9cglColor3b                   f9cglcolor3b
#define f9aglColor3s                   f9aglcolor3s
#define f9bglColor3ub                  f9bglcolor3ub
#define f9cglColor3ub                  f9cglcolor3ub
#define f9aglColor3us                  f9aglcolor3us
#define f9bglColor4b                   f9bglcolor4b
#define f9cglColor4b                   f9cglcolor4b
#define f9aglColor4s                   f9aglcolor4s
#define f9bglColor4ub                  f9bglcolor4ub
#define f9cglColor4ub                  f9cglcolor4ub
#define f9aglColor4us                  f9aglcolor4us
#define f9bglColor3bv                  f9bglcolor3bv
#define f9cglColor3bv                  f9cglcolor3bv
#define f9aglColor3sv                  f9aglcolor3sv
#define f9bglColor3ubv                 f9bglcolor3ubv
#define f9cglColor3ubv                 f9cglcolor3ubv
#define f9aglColor3usv                 f9aglcolor3usv
#define f9bglColor4bv                  f9bglcolor4bv
#define f9cglColor4bv                  f9cglcolor4bv
#define f9aglColor4sv                  f9aglcolor4sv
#define f9bglColor4ubv                 f9bglcolor4ubv
#define f9cglColor4ubv                 f9cglcolor4ubv
#define f9aglColor4usv                 f9aglcolor4usv
#define f9aglTexCoord1s                f9agltexcoord1s
#define f9aglTexCoord2s                f9agltexcoord2s
#define f9aglTexCoord3s                f9agltexcoord3s
#define f9aglTexCoord4s                f9agltexcoord4s
#define f9aglTexCoord1sv               f9agltexcoord1sv
#define f9aglTexCoord2sv               f9agltexcoord2sv
#define f9aglTexCoord3sv               f9agltexcoord3sv
#define f9aglTexCoord4sv               f9agltexcoord4sv
#define f9aglRasterPos2s               f9aglrasterpos2s
#define f9aglRasterPos3s               f9aglrasterpos3s
#define f9aglRasterPos4s               f9aglrasterpos4s
#define f9aglRasterPos2sv              f9aglrasterpos2sv
#define f9aglRasterPos3sv              f9aglrasterpos3sv
#define f9aglRasterPos4sv              f9aglrasterpos4sv
#define f9aglRects                     f9aglrects
#define f9aglRectsv                    f9aglrectsv
#define f9aglPixelMapusv               f9aglpixelmapusv
#define f9aglGetPixelMapusv            f9aglgetpixelmapusv
#define f9bglBitmap                    f9bglbitmap
#define f9cglBitmap                    f9cglbitmap
#define f9aglWindowPos2sMESA           f9aglwindowpos2smesa
#define f9aglWindowPos2svMESA          f9aglwindowpos2svmesa
#define f9aglWindowPos3sMESA           f9aglwindowpos3smesa
#define f9aglWindowPos3svMESA          f9aglwindowpos3svmesa
#define f9aglWindowPos4sMESA           f9aglwindowpos4smesa
#define f9aglWindowPos4svMESA          f9aglwindowpos4svmesa
#define f9y0glCallLists                f9y0glcalllists
#define f9y1glCallLists                f9y1glcalllists
#define f9y2glCallLists                f9y2glcalllists
#define f9y3glCallLists                f9y3glcalllists
#define f9y4glCallLists                f9y4glcalllists
#define f9y5glCallLists                f9y5glcalllists
#define f9y6glCallLists                f9y6glcalllists
#define f9y0glReadPixels               f9y0glreadpixels
#define f9y1glReadPixels               f9y1glreadpixels
#define f9y2glReadPixels               f9y2glreadpixels
#define f9y3glReadPixels               f9y3glreadpixels
#define f9y4glReadPixels               f9y4glreadpixels
#define f9y5glReadPixels               f9y5glreadpixels
#define f9y6glReadPixels               f9y6glreadpixels
#define f9y0glDrawPixels               f9y0gldrawpixels
#define f9y1glDrawPixels               f9y1gldrawpixels
#define f9y2glDrawPixels               f9y2gldrawpixels
#define f9y3glDrawPixels               f9y3gldrawpixels
#define f9y4glDrawPixels               f9y4gldrawpixels
#define f9y5glDrawPixels               f9y5gldrawpixels
#define f9y6glDrawPixels               f9y6gldrawpixels
#define f9y0glTexImage1D               f9y0glteximage1d
#define f9y1glTexImage1D               f9y1glteximage1d
#define f9y2glTexImage1D               f9y2glteximage1d
#define f9y3glTexImage1D               f9y3glteximage1d
#define f9y4glTexImage1D               f9y4glteximage1d
#define f9y5glTexImage1D               f9y5glteximage1d
#define f9y6glTexImage1D               f9y6glteximage1d
#define f9y0glTexImage2D               f9y0glteximage2d
#define f9y1glTexImage2D               f9y1glteximage2d
#define f9y2glTexImage2D               f9y2glteximage2d
#define f9y3glTexImage2D               f9y3glteximage2d
#define f9y4glTexImage2D               f9y4glteximage2d
#define f9y5glTexImage2D               f9y5glteximage2d
#define f9y6glTexImage2D               f9y6glteximage2d
#define f9y0glGetTexImage              f9y0glgetteximage
#define f9y1glGetTexImage              f9y1glgetteximage
#define f9y2glGetTexImage              f9y2glgetteximage
#define f9y3glGetTexImage              f9y3glgetteximage
#define f9y4glGetTexImage              f9y4glgetteximage
#define f9y5glGetTexImage              f9y5glgetteximage
#define f9y6glGetTexImage              f9y6glgetteximage
#elif FBIND==2
#define f9eglColorMask                 f9eglcolormask_
#define f9aglLineStipple               f9agllinestipple_
#define f9bglPolygonStipple            f9bglpolygonstipple_
#define f9cglPolygonStipple            f9cglpolygonstipple_
#define f9bglGetPolygonStipple         f9bglgetpolygonstipple_
#define f9cglGetPolygonStipple         f9cglgetpolygonstipple_
#define f9eglEdgeFlag                  f9egledgeflag_
#define f9eglEdgeFlagv                 f9egledgeflagv_
#define f9eglIsEnabled                 f9eglisenabled_
#define f9eglGetBooleanv               f9eglgetbooleanv_
#define f9yglGetString                 f9yglgetstring_
#define f9eglDepthMask                 f9egldepthmask_
#define f9eglIsList                    f9eglislist_
#define f9aglVertex2s                  f9aglvertex2s_
#define f9aglVertex3s                  f9aglvertex3s_
#define f9aglVertex4s                  f9aglvertex4s_
#define f9aglVertex2sv                 f9aglvertex2sv_
#define f9aglVertex3sv                 f9aglvertex3sv_
#define f9aglVertex4sv                 f9aglvertex4sv_
#define f9bglNormal3b                  f9bglnormal3b_
#define f9cglNormal3b                  f9cglnormal3b_
#define f9aglNormal3s                  f9aglnormal3s_
#define f9bglNormal3bv                 f9bglnormal3bv_
#define f9cglNormal3bv                 f9cglnormal3bv_
#define f9aglNormal3sv                 f9aglnormal3sv_
#define f9aglIndexs                    f9aglindexs_
#define f9aglIndexsv                   f9aglindexsv_
#define f9bglColor3b                   f9bglcolor3b_
#define f9cglColor3b                   f9cglcolor3b_
#define f9aglColor3s                   f9aglcolor3s_
#define f9bglColor3ub                  f9bglcolor3ub_
#define f9cglColor3ub                  f9cglcolor3ub_
#define f9aglColor3us                  f9aglcolor3us_
#define f9bglColor4b                   f9bglcolor4b_
#define f9cglColor4b                   f9cglcolor4b_
#define f9aglColor4s                   f9aglcolor4s_
#define f9bglColor4ub                  f9bglcolor4ub_
#define f9cglColor4ub                  f9cglcolor4ub_
#define f9aglColor4us                  f9aglcolor4us_
#define f9bglColor3bv                  f9bglcolor3bv_
#define f9cglColor3bv                  f9cglcolor3bv_
#define f9aglColor3sv                  f9aglcolor3sv_
#define f9bglColor3ubv                 f9bglcolor3ubv_
#define f9cglColor3ubv                 f9cglcolor3ubv_
#define f9aglColor3usv                 f9aglcolor3usv_
#define f9bglColor4bv                  f9bglcolor4bv_
#define f9cglColor4bv                  f9cglcolor4bv_
#define f9aglColor4sv                  f9aglcolor4sv_
#define f9bglColor4ubv                 f9bglcolor4ubv_
#define f9cglColor4ubv                 f9cglcolor4ubv_
#define f9aglColor4usv                 f9aglcolor4usv_
#define f9aglTexCoord1s                f9agltexcoord1s_
#define f9aglTexCoord2s                f9agltexcoord2s_
#define f9aglTexCoord3s                f9agltexcoord3s_
#define f9aglTexCoord4s                f9agltexcoord4s_
#define f9aglTexCoord1sv               f9agltexcoord1sv_
#define f9aglTexCoord2sv               f9agltexcoord2sv_
#define f9aglTexCoord3sv               f9agltexcoord3sv_
#define f9aglTexCoord4sv               f9agltexcoord4sv_
#define f9aglRasterPos2s               f9aglrasterpos2s_
#define f9aglRasterPos3s               f9aglrasterpos3s_
#define f9aglRasterPos4s               f9aglrasterpos4s_
#define f9aglRasterPos2sv              f9aglrasterpos2sv_
#define f9aglRasterPos3sv              f9aglrasterpos3sv_
#define f9aglRasterPos4sv              f9aglrasterpos4sv_
#define f9aglRects                     f9aglrects_
#define f9aglRectsv                    f9aglrectsv_
#define f9aglPixelMapusv               f9aglpixelmapusv_
#define f9aglGetPixelMapusv            f9aglgetpixelmapusv_
#define f9bglBitmap                    f9bglbitmap_
#define f9cglBitmap                    f9cglbitmap_
#define f9aglWindowPos2sMESA           f9aglwindowpos2smesa_
#define f9aglWindowPos2svMESA          f9aglwindowpos2svmesa_
#define f9aglWindowPos3sMESA           f9aglwindowpos3smesa_
#define f9aglWindowPos3svMESA          f9aglwindowpos3svmesa_
#define f9aglWindowPos4sMESA           f9aglwindowpos4smesa_
#define f9aglWindowPos4svMESA          f9aglwindowpos4svmesa_
#define f9y0glCallLists                f9y0glcalllists_
#define f9y1glCallLists                f9y1glcalllists_
#define f9y2glCallLists                f9y2glcalllists_
#define f9y3glCallLists                f9y3glcalllists_
#define f9y4glCallLists                f9y4glcalllists_
#define f9y5glCallLists                f9y5glcalllists_
#define f9y6glCallLists                f9y6glcalllists_
#define f9y0glReadPixels               f9y0glreadpixels_
#define f9y1glReadPixels               f9y1glreadpixels_
#define f9y2glReadPixels               f9y2glreadpixels_
#define f9y3glReadPixels               f9y3glreadpixels_
#define f9y4glReadPixels               f9y4glreadpixels_
#define f9y5glReadPixels               f9y5glreadpixels_
#define f9y6glReadPixels               f9y6glreadpixels_
#define f9y0glDrawPixels               f9y0gldrawpixels_
#define f9y1glDrawPixels               f9y1gldrawpixels_
#define f9y2glDrawPixels               f9y2gldrawpixels_
#define f9y3glDrawPixels               f9y3gldrawpixels_
#define f9y4glDrawPixels               f9y4gldrawpixels_
#define f9y5glDrawPixels               f9y5gldrawpixels_
#define f9y6glDrawPixels               f9y6gldrawpixels_
#define f9y0glTexImage1D               f9y0glteximage1d_
#define f9y1glTexImage1D               f9y1glteximage1d_
#define f9y2glTexImage1D               f9y2glteximage1d_
#define f9y3glTexImage1D               f9y3glteximage1d_
#define f9y4glTexImage1D               f9y4glteximage1d_
#define f9y5glTexImage1D               f9y5glteximage1d_
#define f9y6glTexImage1D               f9y6glteximage1d_
#define f9y0glTexImage2D               f9y0glteximage2d_
#define f9y1glTexImage2D               f9y1glteximage2d_
#define f9y2glTexImage2D               f9y2glteximage2d_
#define f9y3glTexImage2D               f9y3glteximage2d_
#define f9y4glTexImage2D               f9y4glteximage2d_
#define f9y5glTexImage2D               f9y5glteximage2d_
#define f9y6glTexImage2D               f9y6glteximage2d_
#define f9y0glGetTexImage              f9y0glgetteximage_
#define f9y1glGetTexImage              f9y1glgetteximage_
#define f9y2glGetTexImage              f9y2glgetteximage_
#define f9y3glGetTexImage              f9y3glgetteximage_
#define f9y4glGetTexImage              f9y4glgetteximage_
#define f9y5glGetTexImage              f9y5glgetteximage_
#define f9y6glGetTexImage              f9y6glgetteximage_
#elif FBIND==3
#define f9eglColorMask                 F9EGLCOLORMASK
#define f9aglLineStipple               F9AGLLINESTIPPLE
#define f9bglPolygonStipple            F9BGLPOLYGONSTIPPLE
#define f9cglPolygonStipple            F9CGLPOLYGONSTIPPLE
#define f9bglGetPolygonStipple         F9BGLGETPOLYGONSTIPPLE
#define f9cglGetPolygonStipple         F9CGLGETPOLYGONSTIPPLE
#define f9eglEdgeFlag                  F9EGLEDGEFLAG
#define f9eglEdgeFlagv                 F9EGLEDGEFLAGV
#define f9eglIsEnabled                 F9EGLISENABLED
#define f9eglGetBooleanv               F9EGLGETBOOLEANV
#define f9yglGetString                 F9YGLGETSTRING
#define f9eglDepthMask                 F9EGLDEPTHMASK
#define f9eglIsList                    F9EGLISLIST
#define f9aglVertex2s                  F9AGLVERTEX2S
#define f9aglVertex3s                  F9AGLVERTEX3S
#define f9aglVertex4s                  F9AGLVERTEX4S
#define f9aglVertex2sv                 F9AGLVERTEX2SV
#define f9aglVertex3sv                 F9AGLVERTEX3SV
#define f9aglVertex4sv                 F9AGLVERTEX4SV
#define f9bglNormal3b                  F9BGLNORMAL3B
#define f9cglNormal3b                  F9CGLNORMAL3B
#define f9aglNormal3s                  F9AGLNORMAL3S
#define f9bglNormal3bv                 F9BGLNORMAL3BV
#define f9cglNormal3bv                 F9CGLNORMAL3BV
#define f9aglNormal3sv                 F9AGLNORMAL3SV
#define f9aglIndexs                    F9AGLINDEXS
#define f9aglIndexsv                   F9AGLINDEXSV
#define f9bglColor3b                   F9BGLCOLOR3B
#define f9cglColor3b                   F9CGLCOLOR3B
#define f9aglColor3s                   F9AGLCOLOR3S
#define f9bglColor3ub                  F9BGLCOLOR3UB
#define f9cglColor3ub                  F9CGLCOLOR3UB
#define f9aglColor3us                  F9AGLCOLOR3US
#define f9bglColor4b                   F9BGLCOLOR4B
#define f9cglColor4b                   F9CGLCOLOR4B
#define f9aglColor4s                   F9AGLCOLOR4S
#define f9bglColor4ub                  F9BGLCOLOR4UB
#define f9cglColor4ub                  F9CGLCOLOR4UB
#define f9aglColor4us                  F9AGLCOLOR4US
#define f9bglColor3bv                  F9BGLCOLOR3BV
#define f9cglColor3bv                  F9CGLCOLOR3BV
#define f9aglColor3sv                  F9AGLCOLOR3SV
#define f9bglColor3ubv                 F9BGLCOLOR3UBV
#define f9cglColor3ubv                 F9CGLCOLOR3UBV
#define f9aglColor3usv                 F9AGLCOLOR3USV
#define f9bglColor4bv                  F9BGLCOLOR4BV
#define f9cglColor4bv                  F9CGLCOLOR4BV
#define f9aglColor4sv                  F9AGLCOLOR4SV
#define f9bglColor4ubv                 F9BGLCOLOR4UBV
#define f9cglColor4ubv                 F9CGLCOLOR4UBV
#define f9aglColor4usv                 F9AGLCOLOR4USV
#define f9aglTexCoord1s                F9AGLTEXCOORD1S
#define f9aglTexCoord2s                F9AGLTEXCOORD2S
#define f9aglTexCoord3s                F9AGLTEXCOORD3S
#define f9aglTexCoord4s                F9AGLTEXCOORD4S
#define f9aglTexCoord1sv               F9AGLTEXCOORD1SV
#define f9aglTexCoord2sv               F9AGLTEXCOORD2SV
#define f9aglTexCoord3sv               F9AGLTEXCOORD3SV
#define f9aglTexCoord4sv               F9AGLTEXCOORD4SV
#define f9aglRasterPos2s               F9AGLRASTERPOS2S
#define f9aglRasterPos3s               F9AGLRASTERPOS3S
#define f9aglRasterPos4s               F9AGLRASTERPOS4S
#define f9aglRasterPos2sv              F9AGLRASTERPOS2SV
#define f9aglRasterPos3sv              F9AGLRASTERPOS3SV
#define f9aglRasterPos4sv              F9AGLRASTERPOS4SV
#define f9aglRects                     F9AGLRECTS
#define f9aglRectsv                    F9AGLRECTSV
#define f9aglPixelMapusv               F9AGLPIXELMAPUSV
#define f9aglGetPixelMapusv            F9AGLGETPIXELMAPUSV
#define f9bglBitmap                    F9BGLBITMAP
#define f9cglBitmap                    F9CGLBITMAP
#define f9aglWindowPos2sMESA           F9AGLWINDOWPOS2SMESA
#define f9aglWindowPos2svMESA          F9AGLWINDOWPOS2SVMESA
#define f9aglWindowPos3sMESA           F9AGLWINDOWPOS3SMESA
#define f9aglWindowPos3svMESA          F9AGLWINDOWPOS3SVMESA
#define f9aglWindowPos4sMESA           F9AGLWINDOWPOS4SMESA
#define f9aglWindowPos4svMESA          F9AGLWINDOWPOS4SVMESA
#define f9y0glCallLists                F9Y0GLCALLLISTS
#define f9y1glCallLists                F9Y1GLCALLLISTS
#define f9y2glCallLists                F9Y2GLCALLLISTS
#define f9y3glCallLists                F9Y3glCALLLISTS
#define f9y4glCallLists                F9Y4glCALLLISTS
#define f9y5glCallLists                F9Y5GLCALLLISTS
#define f9y6glCallLists                F9Y6GLCALLLISTS
#define f9y0glReadPixels               F9Y0glREADPIXELS
#define f9y1glReadPixels               F9Y1glREADPIXELS
#define f9y2glReadPixels               F9Y2glREADPIXELS
#define f9y3glReadPixels               F9Y3glREADPIXELS
#define f9y4glReadPixels               F9Y4glREADPIXELS
#define f9y5glReadPixels               F9Y5glREADPIXELS
#define f9y6glReadPixels               F9Y6glREADPIXELS
#define f9y0glDrawPixels               F9Y0glDRAWPIXELS
#define f9y1glDrawPixels               F9Y1glDRAWPIXELS
#define f9y2glDrawPixels               F9Y2glDRAWPIXELS
#define f9y3glDrawPixels               F9Y3glDRAWPIXELS
#define f9y4glDrawPixels               F9Y4glDRAWPIXELS
#define f9y5glDrawPixels               F9Y5glDRAWPIXELS
#define f9y6glDrawPixels               F9Y6glDRAWPIXELS
#define f9y0glTexImage1D               F9Y0glTEXIMAGE1D
#define f9y1glTexImage1D               F9Y1glTEXIMAGE1D
#define f9y2glTexImage1D               F9Y2glTEXIMAGE1D
#define f9y3glTexImage1D               F9Y3glTEXIMAGE1D
#define f9y4glTexImage1D               F9Y4glTEXIMAGE1D
#define f9y5glTexImage1D               F9Y5glTEXIMAGE1D
#define f9y6glTexImage1D               F9Y6glTEXIMAGE1D
#define f9y0glTexImage2D               F9Y0glTEXIMAGE2D
#define f9y1glTexImage2D               F9Y1glTEXIMAGE2D
#define f9y2glTexImage2D               F9Y2glTEXIMAGE2D
#define f9y3glTexImage2D               F9Y3glTEXIMAGE2D
#define f9y4glTexImage2D               F9Y4glTEXIMAGE2D
#define f9y5glTexImage2D               F9Y5glTEXIMAGE2D
#define f9y6glTexImage2D               F9Y6glTEXIMAGE2D
#define f9y0glGetTexImage              F9Y0glGETTEXIMAGE
#define f9y1glGetTexImage              F9Y1glGETTEXIMAGE
#define f9y2glGetTexImage              F9Y2glGETTEXIMAGE
#define f9y3glGetTexImage              F9Y3glGETTEXIMAGE
#define f9y4glGetTexImage              F9Y4glGETTEXIMAGE
#define f9y5glGetTexImage              F9Y5glGETTEXIMAGE
#define f9y6glGetTexImage              F9Y6glGETTEXIMAGE
#endif

/* wrapper functions that change types */

void f9eglColorMask(f90glint red,f90glint green,f90glint blue,
   f90glint alpha )
{
   glColorMask( (GLboolean) *red, (GLboolean) *green, (GLboolean) *blue,
    (GLboolean) *alpha);
}

void f9aglLineStipple(f90glint factor,f90gluint pattern )
{
   glLineStipple( (GLint) *factor, (GLushort) *pattern);
}

void f9bglPolygonStipple(f90gluint mask )
{
   GLubyte byte_mask[128];
   int i;
   for (i=0;i<128;i++) byte_mask[i]=(GLubyte) mask[i];
   glPolygonStipple( byte_mask);
}

void f9cglPolygonStipple(f90glushort mask )
{
   GLubyte byte_mask[128];
   int i;
   for (i=0;i<128;i++) byte_mask[i]=(GLubyte) mask[i];
   glPolygonStipple( byte_mask);
}

void f9bglGetPolygonStipple(f90gluint mask )
{
   GLubyte byte_mask[128];
   int i;
   for (i=0;i<128;i++) byte_mask[i]=(GLubyte) mask[i];
   glGetPolygonStipple( byte_mask);
   for (i=0;i<128;i++) mask[i]=(GLuint) byte_mask[i];
}

void f9cglGetPolygonStipple(f90glushort mask )
{
   GLubyte byte_mask[128];
   int i;
   for (i=0;i<128;i++) byte_mask[i]=(GLubyte) mask[i];
   glGetPolygonStipple( byte_mask);
   for (i=0;i<128;i++) mask[i]=(GLushort) byte_mask[i];
}

void f9eglEdgeFlag(f90glint flag )
{
   glEdgeFlag( (GLboolean) *flag);
}

void f9eglEdgeFlagv(f90glint flag )
{
   GLboolean boolean_flag[1];
   int i;
   for (i=0;i<1;i++) boolean_flag[i]=(GLboolean) flag[i];
   glEdgeFlagv( boolean_flag);
}

GLint f9eglIsEnabled(f90glenum cap)
{
   GLboolean temp;
   temp = glIsEnabled( (GLenum) *cap);
   return (GLint) temp;
}

void f9eglGetBooleanv(f90glenum pname,f90glint params )
{
   GLboolean boolean_params[1];
   int i;
   for (i=0;i<1;i++) boolean_params[i]=(GLboolean) params[i];
   glGetBooleanv( (GLenum) *pname, boolean_params);
   for (i=0;i<1;i++) params[i]=(GLint) boolean_params[i];
}

void f9yglGetString(f90gluint temp, f90glint length, f90glenum name)
{
   int i;
   unsigned char *str;
   str = (unsigned char *) glGetString( (GLenum) *name);
   *length = 0;
   if (str) {
      *length = strlen(str);
      if (*length > 256) *length = 256;
      for (i=0;i<*length;i++) temp[i] = (GLuint) str[i];
   }
}

void f9eglDepthMask(f90glint flag )
{
   glDepthMask( (GLboolean) *flag);
}

GLint f9eglIsList(f90gluint list)
{
   GLboolean temp;
   temp = glIsList( (GLuint) *list);
   return (GLint) temp;
}

void f9aglVertex2s(f90glint x,f90glint y )
{
   glVertex2s( (GLshort) *x, (GLshort) *y);
}

void f9aglVertex3s(f90glint x,f90glint y,f90glint z )
{
   glVertex3s( (GLshort) *x, (GLshort) *y, (GLshort) *z);
}

void f9aglVertex4s(f90glint x,f90glint y,f90glint z,f90glint w )
{
   glVertex4s( (GLshort) *x, (GLshort) *y, (GLshort) *z, (GLshort) *w);
}

void f9aglVertex2sv(f90glint v )
{
   GLshort short_v[2];
   int i;
   for (i=0;i<2;i++) short_v[i]=(GLshort) v[i];
   glVertex2sv( short_v);
}

void f9aglVertex3sv(f90glint v )
{
   GLshort short_v[3];
   int i;
   for (i=0;i<3;i++) short_v[i]=(GLshort) v[i];
   glVertex3sv( short_v);
}

void f9aglVertex4sv(f90glint v )
{
   GLshort short_v[4];
   int i;
   for (i=0;i<4;i++) short_v[i]=(GLshort) v[i];
   glVertex4sv( short_v);
}

void f9bglNormal3b(f90glint nx,f90glint ny,f90glint nz )
{
   glNormal3b( (GLbyte) *nx, (GLbyte) *ny, (GLbyte) *nz);
}

void f9cglNormal3b(f90glshort nx,f90glshort ny,f90glshort nz )
{
   glNormal3b( (GLbyte) *nx, (GLbyte) *ny, (GLbyte) *nz);
}

void f9aglNormal3s(f90glint nx,f90glint ny,f90glint nz )
{
   glNormal3s( (GLshort) *nx, (GLshort) *ny, (GLshort) *nz);
}

void f9bglNormal3bv(f90glint v )
{
   GLbyte byte_v[3];
   int i;
   for (i=0;i<3;i++) byte_v[i]=(GLbyte) v[i];
   glNormal3bv( byte_v);
}

void f9cglNormal3bv(f90glshort v )
{
   GLbyte byte_v[3];
   int i;
   for (i=0;i<3;i++) byte_v[i]=(GLbyte) v[i];
   glNormal3bv( byte_v);
}

void f9aglNormal3sv(f90glint v )
{
   GLshort short_v[3];
   int i;
   for (i=0;i<3;i++) short_v[i]=(GLshort) v[i];
   glNormal3sv( short_v);
}

void f9aglIndexs(f90glint c )
{
   glIndexs( (GLshort) *c);
}

void f9aglIndexsv(f90glint c )
{
   GLshort short_c[1];
   int i;
   for (i=0;i<1;i++) short_c[i]=(GLshort) c[i];
   glIndexsv( short_c);
}

void f9bglColor3b(f90glint red,f90glint green,f90glint blue )
{
   glColor3b( (GLbyte) *red, (GLbyte) *green, (GLbyte) *blue);
}

void f9cglColor3b(f90glshort red,f90glshort green,f90glshort blue )
{
   glColor3b( (GLbyte) *red, (GLbyte) *green, (GLbyte) *blue);
}

void f9aglColor3s(f90glint red,f90glint green,f90glint blue )
{
   glColor3s( (GLshort) *red, (GLshort) *green, (GLshort) *blue);
}

void f9bglColor3ub(f90gluint red,f90gluint green,f90gluint blue )
{
   glColor3ub( (GLubyte) *red, (GLubyte) *green, (GLubyte) *blue);
}

void f9cglColor3ub(f90glushort red,f90glushort green,f90glushort blue )
{
   glColor3ub( (GLubyte) *red, (GLubyte) *green, (GLubyte) *blue);
}

void f9aglColor3us(f90gluint red,f90gluint green,f90gluint blue )
{
   glColor3us( (GLushort) *red, (GLushort) *green, (GLushort) *blue);
}

void f9bglColor4b(f90glint red,f90glint green,f90glint blue,f90glint alpha )
{
   glColor4b( (GLbyte) *red, (GLbyte) *green, (GLbyte) *blue,
    (GLbyte) *alpha);
}

void f9cglColor4b(f90glshort red,f90glshort green,f90glshort blue,
   f90glshort alpha )
{
   glColor4b( (GLbyte) *red, (GLbyte) *green, (GLbyte) *blue,
    (GLbyte) *alpha);
}

void f9aglColor4s(f90glint red,f90glint green,f90glint blue,f90glint alpha )
{
   glColor4s( (GLshort) *red, (GLshort) *green, (GLshort) *blue,
    (GLshort) *alpha);
}

void f9bglColor4ub(f90gluint red,f90gluint green,f90gluint blue,
   f90gluint alpha )
{
   glColor4ub( (GLubyte) *red, (GLubyte) *green, (GLubyte) *blue,
    (GLubyte) *alpha);
}

void f9cglColor4ub(f90glushort red,f90glushort green,f90glushort blue,
   f90glushort alpha )
{
   glColor4ub( (GLubyte) *red, (GLubyte) *green, (GLubyte) *blue,
    (GLubyte) *alpha);
}

void f9aglColor4us(f90gluint red,f90gluint green,f90gluint blue,
   f90gluint alpha )
{
   glColor4us( (GLushort) *red, (GLushort) *green, (GLushort) *blue,
    (GLushort) *alpha);
}

void f9bglColor3bv(f90glint v )
{
   GLbyte byte_v[3];
   int i;
   for (i=0;i<3;i++) byte_v[i]=(GLbyte) v[i];
   glColor3bv( byte_v);
}

void f9cglColor3bv(f90glshort v )
{
   GLbyte byte_v[3];
   int i;
   for (i=0;i<3;i++) byte_v[i]=(GLbyte) v[i];
   glColor3bv( byte_v);
}

void f9aglColor3sv(f90glint v )
{
   GLshort short_v[3];
   int i;
   for (i=0;i<3;i++) short_v[i]=(GLshort) v[i];
   glColor3sv( short_v);
}

void f9bglColor3ubv(f90gluint v )
{
   GLubyte byte_v[3];
   int i;
   for (i=0;i<3;i++) byte_v[i]=(GLubyte) v[i];
   glColor3ubv( byte_v);
}

void f9cglColor3ubv(f90glushort v )
{
   GLubyte byte_v[3];
   int i;
   for (i=0;i<3;i++) byte_v[i]=(GLubyte) v[i];
   glColor3ubv( byte_v);
}

void f9aglColor3usv(f90gluint v )
{
   GLushort short_v[3];
   int i;
   for (i=0;i<3;i++) short_v[i]=(GLushort) v[i];
   glColor3usv( short_v);
}

void f9bglColor4bv(f90glint v )
{
   GLbyte byte_v[4];
   int i;
   for (i=0;i<4;i++) byte_v[i]=(GLbyte) v[i];
   glColor4bv( byte_v);
}

void f9cglColor4bv(f90glshort v )
{
   GLbyte byte_v[4];
   int i;
   for (i=0;i<4;i++) byte_v[i]=(GLbyte) v[i];
   glColor4bv( byte_v);
}

void f9aglColor4sv(f90glint v )
{
   GLshort short_v[4];
   int i;
   for (i=0;i<4;i++) short_v[i]=(GLshort) v[i];
   glColor4sv( short_v);
}

void f9bglColor4ubv(f90gluint v )
{
   GLubyte byte_v[4];
   int i;
   for (i=0;i<4;i++) byte_v[i]=(GLubyte) v[i];
   glColor4ubv( byte_v);
}

void f9cglColor4ubv(f90glushort v )
{
   GLubyte byte_v[4];
   int i;
   for (i=0;i<4;i++) byte_v[i]=(GLubyte) v[i];
   glColor4ubv( byte_v);
}

void f9aglColor4usv(f90gluint v )
{
   GLushort short_v[4];
   int i;
   for (i=0;i<4;i++) short_v[i]=(GLushort) v[i];
   glColor4usv( short_v);
}

void f9aglTexCoord1s(f90glint s )
{
   glTexCoord1s( (GLshort) *s);
}

void f9aglTexCoord2s(f90glint s,f90glint t )
{
   glTexCoord2s( (GLshort) *s, (GLshort) *t);
}

void f9aglTexCoord3s(f90glint s,f90glint t,f90glint r )
{
   glTexCoord3s( (GLshort) *s, (GLshort) *t, (GLshort) *r);
}

void f9aglTexCoord4s(f90glint s,f90glint t,f90glint r,f90glint q )
{
   glTexCoord4s( (GLshort) *s, (GLshort) *t, (GLshort) *r, (GLshort) *q);
}

void f9aglTexCoord1sv(f90glint v )
{
   GLshort short_v[1];
   int i;
   for (i=0;i<1;i++) short_v[i]=(GLshort) v[i];
   glTexCoord1sv( short_v);
}

void f9aglTexCoord2sv(f90glint v )
{
   GLshort short_v[2];
   int i;
   for (i=0;i<2;i++) short_v[i]=(GLshort) v[i];
   glTexCoord2sv( short_v);
}

void f9aglTexCoord3sv(f90glint v )
{
   GLshort short_v[3];
   int i;
   for (i=0;i<3;i++) short_v[i]=(GLshort) v[i];
   glTexCoord3sv( short_v);
}

void f9aglTexCoord4sv(f90glint v )
{
   GLshort short_v[4];
   int i;
   for (i=0;i<4;i++) short_v[i]=(GLshort) v[i];
   glTexCoord4sv( short_v);
}

void f9aglRasterPos2s(f90glint x,f90glint y )
{
   glRasterPos2s( (GLshort) *x, (GLshort) *y);
}

void f9aglRasterPos3s(f90glint x,f90glint y,f90glint z )
{
   glRasterPos3s( (GLshort) *x, (GLshort) *y, (GLshort) *z);
}

void f9aglRasterPos4s(f90glint x,f90glint y,f90glint z,f90glint w )
{
   glRasterPos4s( (GLshort) *x, (GLshort) *y, (GLshort) *z, (GLshort) *w);
}

void f9aglRasterPos2sv(f90glint v )
{
   GLshort short_v[2];
   int i;
   for (i=0;i<2;i++) short_v[i]=(GLshort) v[i];
   glRasterPos2sv( short_v);
}

void f9aglRasterPos3sv(f90glint v )
{
   GLshort short_v[3];
   int i;
   for (i=0;i<3;i++) short_v[i]=(GLshort) v[i];
   glRasterPos3sv( short_v);
}

void f9aglRasterPos4sv(f90glint v )
{
   GLshort short_v[4];
   int i;
   for (i=0;i<4;i++) short_v[i]=(GLshort) v[i];
   glRasterPos4sv( short_v);
}

void f9aglRects(f90glint x1,f90glint y1,f90glint x2,f90glint y2 )
{
   glRects( (GLshort) *x1, (GLshort) *y1, (GLshort) *x2, (GLshort) *y2);
}

void f9aglRectsv(f90glint v1,f90glint v2 )
{
   GLshort short_v1[2];
   GLshort short_v2[2];
   int i;
   for (i=0;i<2;i++) short_v1[i]=(GLshort) v1[i];
   for (i=0;i<2;i++) short_v2[i]=(GLshort) v2[i];
   glRectsv( short_v1, short_v2);
}

void f9aglPixelMapusv(f90glenum map,f90glint mapsize,f90gluint values )
{
   GLushort *short_values;
   int i;
   short_values = (GLushort *) malloc(*mapsize*sizeof(GLushort));
   for (i=0;i<*mapsize;i++) short_values[i]=(GLushort) values[i];
   glPixelMapusv( (GLenum) *map, (GLint) *mapsize, short_values);
   free(short_values);
}

void f9aglGetPixelMapusv(f90glenum map,f90gluint values )
{
   GLushort *short_values;
   GLint size[1];
   int i;
   glGetIntegerv((GLenum) *map + GL_PIXEL_MAP_I_TO_I - GL_PIXEL_MAP_I_TO_I_SIZE,size);
   short_values = (GLushort *) malloc(size[0]*sizeof(GLushort));
   for (i=0;i<size[0];i++) short_values[i]=(GLushort) values[i];
   glGetPixelMapusv( (GLenum) *map, short_values);
   for (i=0;i<size[0];i++) values[i]=(GLuint) short_values[i];
   free(short_values);
}

void f9bglBitmap(f90glsizei width,f90glsizei height,f90glfloat xorig,
   f90glfloat yorig,f90glfloat xmove,f90glfloat ymove,f90gluint bitmap )
{
   GLubyte *byte_bitmap;
   int i;
   int size = *height*((int)ceil(((float)*width)/8.));
   byte_bitmap = (GLubyte *) malloc(size*sizeof(GLushort));
   for (i=0;i<size;i++) byte_bitmap[i]=(GLubyte) bitmap[i];
   glBitmap( (GLsizei) *width, (GLsizei) *height, (GLfloat) *xorig,
    (GLfloat) *yorig, (GLfloat) *xmove, (GLfloat) *ymove, byte_bitmap);
   free(byte_bitmap);
}

void f9cglBitmap(f90glsizei width,f90glsizei height,f90glfloat xorig,
   f90glfloat yorig,f90glfloat xmove,f90glfloat ymove,f90glushort bitmap )
{
   GLubyte *byte_bitmap;
   int i;
   int size = *height*((int)ceil(((float)*width)/8.));
   byte_bitmap = (GLubyte *) malloc(size*sizeof(GLushort));
   for (i=0;i<size;i++) byte_bitmap[i]=(GLubyte) bitmap[i];
   glBitmap( (GLsizei) *width, (GLsizei) *height, (GLfloat) *xorig,
    (GLfloat) *yorig, (GLfloat) *xmove, (GLfloat) *ymove, byte_bitmap);
   free(byte_bitmap);
}

void f9aglWindowPos2sMESA(f90glint x,f90glint y )
{
   glWindowPos2sMESA( (GLshort) *x, (GLshort) *y);
}
 
void f9aglWindowPos2svMESA(f90glint p )
{
   GLshort short_p[2];
   int i;
   for (i=0;i<2;i++) short_p[i]=(GLshort) p[i];
   glWindowPos2svMESA( short_p);
}

void f9aglWindowPos3sMESA(f90glint x,f90glint y,f90glint z )
{
   glWindowPos3sMESA( (GLshort) *x, (GLshort) *y, (GLshort) *z);
}

void f9aglWindowPos3svMESA(f90glint p )
{
   GLshort short_p[3];
   int i;
   for (i=0;i<3;i++) short_p[i]=(GLshort) p[i];
   glWindowPos3svMESA( short_p);
}

void f9aglWindowPos4sMESA(f90glint x,f90glint y,f90glint z,f90glint w
)
{
   glWindowPos4sMESA( (GLshort) *x, (GLshort) *y, (GLshort) *z,
    (GLshort) *w);
}

void f9aglWindowPos4svMESA(f90glint p )
{
   GLshort short_p[4];
   int i;
   for (i=0;i<4;i++) short_p[i]=(GLshort) p[i];
   glWindowPos4svMESA( short_p);
}

void f9y0glCallLists( f90glsizei n, f90glenum type, f90glvoid lists )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newlists;
   int i;
   newlists = (GLubyte *) malloc((*n)*sizeof(GLubyte));
   for (i=0;i<(*n);i++) newlists[i]=(GLubyte)lists[i];
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) newlists );
   free(newlists);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newlists;
   int i;
   newlists = (GLbyte *) malloc((*n)*sizeof(GLbyte));
   for (i=0;i<(*n);i++) newlists[i]=(GLbyte)lists[i];
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) newlists );
   free(newlists);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newlists;
   int i;
   newlists = (GLushort *) malloc((*n)*sizeof(GLushort));
   for (i=0;i<(*n);i++) newlists[i]=(GLushort)lists[i];
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) newlists );
   free(newlists);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newlists;
   int i;
   newlists = (GLshort *) malloc((*n)*sizeof(GLshort));
   for (i=0;i<(*n);i++) newlists[i]=(GLshort)lists[i];
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) newlists );
   free(newlists);
   break;
  }
 default:
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) lists );
   break;
}
}

void f9y1glCallLists( f90glsizei n, f90glenum type, f90glvoid lists )
{
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) lists );
}

void f9y2glCallLists( f90glsizei n, f90glenum type, f90glvoid lists )
{
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) lists );
}

void f9y3glCallLists( f90glsizei n, f90glenum type, f90glvoid lists )
{
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) lists );
}

void f9y4glCallLists( f90glsizei n, f90glenum type, f90gluint temp, f90glint nbytes )
{
   GLvoid *lists;
   unsigned char *p;
   int i;
   p = (unsigned char *) &lists;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) lists );
}

void f9y5glCallLists( f90glsizei n, f90glenum type, f90glvoid lists )
{
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) lists );
}

void f9y6glCallLists( f90glsizei n, f90glenum type, f90glvoid lists )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newlists;
   int i;
   newlists = (GLubyte *) malloc((*n)*sizeof(GLubyte));
   for (i=0;i<(*n);i++) newlists[i]=(GLubyte)lists[i];
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) newlists );
   free(newlists);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newlists;
   int i;
   newlists = (GLbyte *) malloc((*n)*sizeof(GLbyte));
   for (i=0;i<(*n);i++) newlists[i]=(GLbyte)lists[i];
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) newlists );
   free(newlists);
   break;
  }
 default:
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) lists );
   break;
}
}

void f9y0glReadPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum format, f90glenum type, f90glvoid pixels )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((*width)*(*height)*sizeof(GLubyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLubyte)pixels[i];
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((*width)*(*height)*sizeof(GLbyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLbyte)pixels[i];
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newpixels;
   int i;
   newpixels = (GLushort *) malloc((*width)*(*height)*sizeof(GLushort));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLushort)pixels[i];
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newpixels;
   int i;
   newpixels = (GLshort *) malloc((*width)*(*height)*sizeof(GLshort));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLshort)pixels[i];
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 default:
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) pixels );
   break;
}
}

void f9y1glReadPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum format, f90glenum type, f90glvoid pixels )
{
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) pixels );
}

void f9y2glReadPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum format, f90glenum type, f90glvoid pixels )
{
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) pixels );
}

void f9y3glReadPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum format, f90glenum type, f90glvoid pixels )
{
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) pixels );
}

void f9y4glReadPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum format, f90glenum type, f90gluint temp, f90glint nbytes )
{
   GLvoid *pixels; 
   unsigned char *p; 
   int i;
   p = (unsigned char *) &pixels; 
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) pixels );
}

void f9y5glReadPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum format, f90glenum type, f90glvoid pixels )
{
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) pixels );
}

void f9y6glReadPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum format, f90glenum type, f90glvoid pixels )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((*width)*(*height)*sizeof(GLubyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLubyte)pixels[i];
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((*width)*(*height)*sizeof(GLbyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLbyte)pixels[i];
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 default:
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) pixels );
   break;
}
}

void f9y0glDrawPixels( f90glsizei width, f90glsizei height, f90glenum format,
    f90glenum type, f90glvoid pixels )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((*width)*(*height)*sizeof(GLubyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLubyte)pixels[i];
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((*width)*(*height)*sizeof(GLbyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLbyte)pixels[i];
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newpixels;
   int i;
   newpixels = (GLushort *) malloc((*width)*(*height)*sizeof(GLushort));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLushort)pixels[i];
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newpixels;
   int i;
   newpixels = (GLshort *) malloc((*width)*(*height)*sizeof(GLshort));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLshort)pixels[i];
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 default:
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
   break;
}
}

void f9y1glDrawPixels( f90glsizei width, f90glsizei height, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y2glDrawPixels( f90glsizei width, f90glsizei height, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y3glDrawPixels( f90glsizei width, f90glsizei height, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y5glDrawPixels( f90glsizei width, f90glsizei height, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y6glDrawPixels( f90glsizei width, f90glsizei height, f90glenum format,
    f90glenum type, f90glvoid pixels )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((*width)*(*height)*sizeof(GLubyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLubyte)pixels[i];
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((*width)*(*height)*sizeof(GLbyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLbyte)pixels[i];
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 default:
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
   break;
}
}

void f9y4glDrawPixels( f90glsizei width, f90glsizei height, f90glenum format,
    f90glenum type, f90gluint temp, f90glint nbytes )
{
   GLvoid *pixels; 
   unsigned char *p; 
   int i;
   p = (unsigned char *) &pixels; 
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y0glTexImage1D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glint border, f90glenum format, f90glenum type,
    f90glvoid pixels )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((*width)*sizeof(GLubyte));
   for (i=0;i<(*width);i++) newpixels[i]=(GLubyte)pixels[i];
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((*width)*sizeof(GLbyte));
   for (i=0;i<(*width);i++) newpixels[i]=(GLbyte)pixels[i];
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newpixels;
   int i;
   newpixels = (GLushort *) malloc((*width)*sizeof(GLushort));
   for (i=0;i<(*width);i++) newpixels[i]=(GLushort)pixels[i];
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newpixels;
   int i;
   newpixels = (GLshort *) malloc((*width)*sizeof(GLshort));
   for (i=0;i<(*width);i++) newpixels[i]=(GLshort)pixels[i];
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 default:
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) pixels );
   break;
}
}
 
void f9y1glTexImage1D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glint border, f90glenum format, f90glenum type,
    f90glvoid pixels )
{
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) pixels );
}
 
void f9y2glTexImage1D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glint border, f90glenum format, f90glenum type,
    f90glvoid pixels )
{
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) pixels );
}
 
void f9y3glTexImage1D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glint border, f90glenum format, f90glenum type,
    f90glvoid pixels )
{
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) pixels );
}
 
void f9y4glTexImage1D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glint border, f90glenum format, f90glenum type,
    f90gluint temp, f90glint nbytes)
{
   GLvoid *pixels;
   unsigned char *p; 
   int i;
   p = (unsigned char *) &pixels;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) pixels );
}
 
void f9y5glTexImage1D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glint border, f90glenum format, f90glenum type,
    f90glvoid pixels )
{
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) pixels );
}
 
void f9y6glTexImage1D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glint border, f90glenum format, f90glenum type,
    f90glvoid pixels )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((*width)*sizeof(GLubyte));
   for (i=0;i<(*width);i++) newpixels[i]=(GLubyte)pixels[i];
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((*width)*sizeof(GLbyte));
   for (i=0;i<(*width);i++) newpixels[i]=(GLbyte)pixels[i];
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 default:
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) pixels );
   break;
}
}
 
void f9y0glTexImage2D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glsizei height, f90glint border, f90glenum format,
    f90glenum type, f90glvoid pixels )
{

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((*width)*(*height)*sizeof(GLubyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLubyte)pixels[i];
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((*width)*(*height)*sizeof(GLbyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLbyte)pixels[i];
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newpixels;
   int i;
   newpixels = (GLushort *) malloc((*width)*(*height)*sizeof(GLushort));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLushort)pixels[i];
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newpixels;
   int i;
   newpixels = (GLshort *) malloc((*width)*(*height)*sizeof(GLshort));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLshort)pixels[i];
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 default:
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
   break;
}
}
 
void f9y1glTexImage2D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glsizei height, f90glint border, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}
 
void f9y2glTexImage2D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glsizei height, f90glint border, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   f9y0glTexImage2D( target, level, components, width, height, border, format,
    type, pixels );
}
 
void f9y3glTexImage2D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glsizei height, f90glint border, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}
 
void f9y4glTexImage2D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glsizei height, f90glint border, f90glenum format,
    f90glenum type, f90gluint temp, f90glint nbytes)
{
   GLvoid *pixels;
   unsigned char *p; 
   int i;
   p = (unsigned char *) &pixels;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}
 
void f9y5glTexImage2D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glsizei height, f90glint border, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}
 
void f9y6glTexImage2D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glsizei height, f90glint border, f90glenum format,
    f90glenum type, f90glvoid pixels )
{

switch (*type) {
 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((*width)*(*height)*sizeof(GLubyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLubyte)pixels[i];
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((*width)*(*height)*sizeof(GLbyte));
   for (i=0;i<(*width)*(*height);i++) newpixels[i]=(GLbyte)pixels[i];
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   free(newpixels);
   break;
  }
 default:
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
   break;
}
}
 
void f9y0glGetTexImage( f90glenum target, f90glint level, f90glenum format,
    f90glenum type, f90glvoid pixels )
{

GLint width, height;
glGetTexLevelParameteriv((GLenum) *target, (GLint) *level, GL_TEXTURE_WIDTH,
   &width);
glGetTexLevelParameteriv((GLenum) *target, (GLint) *level, GL_TEXTURE_HEIGHT,
   &height);

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((width)*(height)*sizeof(GLubyte));
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   for (i=0;i<(width)*(height);i++) pixels[i]=(GLint)newpixels[i];
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((width)*(height)*sizeof(GLbyte));
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   for (i=0;i<(width)*(height);i++) pixels[i]=(GLint)newpixels[i];
   free(newpixels);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newpixels;
   int i;
   newpixels = (GLushort *) malloc((width)*(height)*sizeof(GLushort));
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   for (i=0;i<(width)*(height);i++) pixels[i]=(GLint)newpixels[i];
   free(newpixels);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newpixels;
   int i;
   newpixels = (GLshort *) malloc((width)*(height)*sizeof(GLshort));
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   for (i=0;i<(width)*(height);i++) pixels[i]=(GLshort)newpixels[i];
   free(newpixels);
   break;
  }
 default:
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
   break;
}
}

void f9y1glGetTexImage( f90glenum target, f90glint level, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y2glGetTexImage( f90glenum target, f90glint level, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y3glGetTexImage( f90glenum target, f90glint level, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y4glGetTexImage( f90glenum target, f90glint level, f90glenum format,
    f90glenum type, f90gluint temp, f90glint nbytes)
{
   GLvoid *pixels;
   unsigned char *p; 
   int i;
   p = (unsigned char *) &pixels;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y5glGetTexImage( f90glenum target, f90glint level, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void f9y6glGetTexImage( f90glenum target, f90glint level, f90glenum format,
    f90glenum type, f90glvoid pixels )
{

GLint width, height;
glGetTexLevelParameteriv((GLenum) *target, (GLint) *level, GL_TEXTURE_WIDTH,
   &width);
glGetTexLevelParameteriv((GLenum) *target, (GLint) *level, GL_TEXTURE_HEIGHT,
   &height);

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newpixels;
   int i;
   newpixels = (GLubyte *) malloc((width)*(height)*sizeof(GLubyte));
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   for (i=0;i<(width)*(height);i++) pixels[i]=(GLshort)newpixels[i];
   free(newpixels);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newpixels;
   int i;
   newpixels = (GLbyte *) malloc((width)*(height)*sizeof(GLbyte));
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) newpixels );
   for (i=0;i<(width)*(height);i++) pixels[i]=(GLshort)newpixels[i];
   free(newpixels);
   break;
  }
 default:
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
   break;
}
}

#else /*ifdef FBIND*/



/* If FBIND is not defined, Fortran bindings aren't made.  Need this
 * dummy function for some picky compilers.
 */
static void dummy()
{
   return;
}

 
 
#endif /*ifdef FBIND*/
