!-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------

module f90gl

use f90gl_kinds

! Constants

integer(f90glbitfield), parameter :: GL_CURRENT_BIT = 1
integer(f90glbitfield), parameter :: GL_POINT_BIT = 2
integer(f90glbitfield), parameter :: GL_LINE_BIT = 4
integer(f90glbitfield), parameter :: GL_POLYGON_BIT = 8
integer(f90glbitfield), parameter :: GL_POLYGON_STIPPLE_BIT = 16
integer(f90glbitfield), parameter :: GL_PIXEL_MODE_BIT = 32
integer(f90glbitfield), parameter :: GL_LIGHTING_BIT = 64
integer(f90glbitfield), parameter :: GL_FOG_BIT = 128
integer(f90glbitfield), parameter :: GL_DEPTH_BUFFER_BIT = 256
integer(f90glbitfield), parameter :: GL_ACCUM_BUFFER_BIT = 512
integer(f90glbitfield), parameter :: GL_STENCIL_BUFFER_BIT = 1024
integer(f90glbitfield), parameter :: GL_VIEWPORT_BIT = 2048
integer(f90glbitfield), parameter :: GL_TRANSFORM_BIT = 4096
integer(f90glbitfield), parameter :: GL_ENABLE_BIT = 8192
integer(f90glbitfield), parameter :: GL_COLOR_BUFFER_BIT = 16384
integer(f90glbitfield), parameter :: GL_HINT_BIT = 32768
integer(f90glbitfield), parameter :: GL_EVAL_BIT = 65536
integer(f90glbitfield), parameter :: GL_LIST_BIT = 131072
integer(f90glbitfield), parameter :: GL_TEXTURE_BIT = 262144
integer(f90glbitfield), parameter :: GL_SCISSOR_BIT = 524288
integer(f90glbitfield), parameter :: GL_ALL_ATTRIB_BITS = 1048575
integer(f90glenum), parameter :: GL_FALSE = 0
integer(f90glenum), parameter :: GL_TRUE = 1
integer(f90glenum), parameter :: GL_POINTS = 0
integer(f90glenum), parameter :: GL_LINES = 1
integer(f90glenum), parameter :: GL_LINE_LOOP = 2
integer(f90glenum), parameter :: GL_LINE_STRIP = 3
integer(f90glenum), parameter :: GL_TRIANGLES = 4
integer(f90glenum), parameter :: GL_TRIANGLE_STRIP = 5
integer(f90glenum), parameter :: GL_TRIANGLE_FAN = 6
integer(f90glenum), parameter :: GL_QUADS = 7
integer(f90glenum), parameter :: GL_QUAD_STRIP = 8
integer(f90glenum), parameter :: GL_POLYGON = 9
integer(f90glenum), parameter :: GL_ACCUM = 256
integer(f90glenum), parameter :: GL_LOAD = 257
integer(f90glenum), parameter :: GL_RETURN = 258
integer(f90glenum), parameter :: GL_MULT = 259
integer(f90glenum), parameter :: GL_ADD = 260
integer(f90glenum), parameter :: GL_NEVER = 512
integer(f90glenum), parameter :: GL_LESS = 513
integer(f90glenum), parameter :: GL_EQUAL = 514
integer(f90glenum), parameter :: GL_LEQUAL = 515
integer(f90glenum), parameter :: GL_GREATER = 516
integer(f90glenum), parameter :: GL_NOTEQUAL = 517
integer(f90glenum), parameter :: GL_GEQUAL = 518
integer(f90glenum), parameter :: GL_ALWAYS = 519
integer(f90glenum), parameter :: GL_ZERO = 0
integer(f90glenum), parameter :: GL_ONE = 1
integer(f90glenum), parameter :: GL_SRC_COLOR = 768
integer(f90glenum), parameter :: GL_ONE_MINUS_SRC_COLOR = 769
integer(f90glenum), parameter :: GL_SRC_ALPHA = 770
integer(f90glenum), parameter :: GL_ONE_MINUS_SRC_ALPHA = 771
integer(f90glenum), parameter :: GL_DST_ALPHA = 772
integer(f90glenum), parameter :: GL_ONE_MINUS_DST_ALPHA = 773
integer(f90glenum), parameter :: GL_DST_COLOR = 774
integer(f90glenum), parameter :: GL_ONE_MINUS_DST_COLOR = 775
integer(f90glenum), parameter :: GL_SRC_ALPHA_SATURATE = 776
integer(f90glenum), parameter :: GL_NONE = 0
integer(f90glenum), parameter :: GL_FRONT_LEFT = 1024
integer(f90glenum), parameter :: GL_FRONT_RIGHT = 1025
integer(f90glenum), parameter :: GL_BACK_LEFT = 1026
integer(f90glenum), parameter :: GL_BACK_RIGHT = 1027
integer(f90glenum), parameter :: GL_FRONT = 1028
integer(f90glenum), parameter :: GL_BACK = 1029
integer(f90glenum), parameter :: GL_LEFT = 1030
integer(f90glenum), parameter :: GL_RIGHT = 1031
integer(f90glenum), parameter :: GL_FRONT_AND_BACK = 1032
integer(f90glenum), parameter :: GL_AUX0 = 1033
integer(f90glenum), parameter :: GL_AUX1 = 1034
integer(f90glenum), parameter :: GL_AUX2 = 1035
integer(f90glenum), parameter :: GL_AUX3 = 1036
integer(f90glenum), parameter :: GL_NO_ERROR = 0
integer(f90glenum), parameter :: GL_INVALID_ENUM = 1280
integer(f90glenum), parameter :: GL_INVALID_VALUE = 1281
integer(f90glenum), parameter :: GL_INVALID_OPERATION = 1282
integer(f90glenum), parameter :: GL_STACK_OVERFLOW = 1283
integer(f90glenum), parameter :: GL_STACK_UNDERFLOW = 1284
integer(f90glenum), parameter :: GL_OUT_OF_MEMORY = 1285
integer(f90glenum), parameter :: GL_2D = 1536
integer(f90glenum), parameter :: GL_3D = 1537
integer(f90glenum), parameter :: GL_3D_COLOR = 1538
integer(f90glenum), parameter :: GL_3D_COLOR_TEXTURE = 1539
integer(f90glenum), parameter :: GL_4D_COLOR_TEXTURE = 1540
integer(f90glenum), parameter :: GL_PASS_THROUGH_TOKEN = 1792
integer(f90glenum), parameter :: GL_POINT_TOKEN = 1793
integer(f90glenum), parameter :: GL_LINE_TOKEN = 1794
integer(f90glenum), parameter :: GL_POLYGON_TOKEN = 1795
integer(f90glenum), parameter :: GL_BITMAP_TOKEN = 1796
integer(f90glenum), parameter :: GL_DRAW_PIXEL_TOKEN = 1797
integer(f90glenum), parameter :: GL_COPY_PIXEL_TOKEN = 1798
integer(f90glenum), parameter :: GL_LINE_RESET_TOKEN = 1799
integer(f90glenum), parameter :: GL_EXP = 2048
integer(f90glenum), parameter :: GL_EXP2 = 2049
integer(f90glenum), parameter :: GL_CW = 2304
integer(f90glenum), parameter :: GL_CCW = 2305
integer(f90glenum), parameter :: GL_COEFF = 2560
integer(f90glenum), parameter :: GL_ORDER = 2561
integer(f90glenum), parameter :: GL_DOMAIN = 2562
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_I = 3184
integer(f90glenum), parameter :: GL_PIXEL_MAP_S_TO_S = 3185
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_R = 3186
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_G = 3187
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_B = 3188
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_A = 3189
integer(f90glenum), parameter :: GL_PIXEL_MAP_R_TO_R = 3190
integer(f90glenum), parameter :: GL_PIXEL_MAP_G_TO_G = 3191
integer(f90glenum), parameter :: GL_PIXEL_MAP_B_TO_B = 3192
integer(f90glenum), parameter :: GL_PIXEL_MAP_A_TO_A = 3193
integer(f90glenum), parameter :: GL_CURRENT_COLOR = 2816
integer(f90glenum), parameter :: GL_CURRENT_INDEX = 2817
integer(f90glenum), parameter :: GL_CURRENT_NORMAL = 2818
integer(f90glenum), parameter :: GL_CURRENT_TEXTURE_COORDS = 2819
integer(f90glenum), parameter :: GL_CURRENT_RASTER_COLOR = 2820
integer(f90glenum), parameter :: GL_CURRENT_RASTER_INDEX = 2821
integer(f90glenum), parameter :: GL_CURRENT_RASTER_TEXTURE_COORD = 2822
integer(f90glenum), parameter :: GL_CURRENT_RASTER_POSITION = 2823
integer(f90glenum), parameter :: GL_CURRENT_RASTER_POSITION_VALI = 2824
integer(f90glenum), parameter :: GL_CURRENT_RASTER_DISTANCE = 2825
integer(f90glenum), parameter :: GL_POINT_SMOOTH = 2832
integer(f90glenum), parameter :: GL_POINT_SIZE = 2833
integer(f90glenum), parameter :: GL_POINT_SIZE_RANGE = 2834
integer(f90glenum), parameter :: GL_POINT_SIZE_GRANULARITY = 2835
integer(f90glenum), parameter :: GL_LINE_SMOOTH = 2848
integer(f90glenum), parameter :: GL_LINE_WIDTH = 2849
integer(f90glenum), parameter :: GL_LINE_WIDTH_RANGE = 2850
integer(f90glenum), parameter :: GL_LINE_WIDTH_GRANULARITY = 2851
integer(f90glenum), parameter :: GL_LINE_STIPPLE = 2852
integer(f90glenum), parameter :: GL_LINE_STIPPLE_PATTERN = 2853
integer(f90glenum), parameter :: GL_LINE_STIPPLE_REPEAT = 2854
integer(f90glenum), parameter :: GL_LIST_MODE = 2864
integer(f90glenum), parameter :: GL_MAX_LIST_NESTING = 2865
integer(f90glenum), parameter :: GL_LIST_BASE = 2866
integer(f90glenum), parameter :: GL_LIST_INDEX = 2867
integer(f90glenum), parameter :: GL_POLYGON_MODE = 2880
integer(f90glenum), parameter :: GL_POLYGON_SMOOTH = 2881
integer(f90glenum), parameter :: GL_POLYGON_STIPPLE = 2882
integer(f90glenum), parameter :: GL_EDGE_FLAG = 2883
integer(f90glenum), parameter :: GL_CULL_FACE = 2884
integer(f90glenum), parameter :: GL_CULL_FACE_MODE = 2885
integer(f90glenum), parameter :: GL_FRONT_FACE = 2886
integer(f90glenum), parameter :: GL_LIGHTING = 2896
integer(f90glenum), parameter :: GL_LIGHT_MODEL_LOCAL_VIEWER = 2897
integer(f90glenum), parameter :: GL_LIGHT_MODEL_TWO_SIDE = 2898
integer(f90glenum), parameter :: GL_LIGHT_MODEL_AMBIENT = 2899
integer(f90glenum), parameter :: GL_SHADE_MODEL = 2900
integer(f90glenum), parameter :: GL_COLOR_MATERIAL_FACE = 2901
integer(f90glenum), parameter :: GL_COLOR_MATERIAL_PARAMETER = 2902
integer(f90glenum), parameter :: GL_COLOR_MATERIAL = 2903
integer(f90glenum), parameter :: GL_FOG = 2912
integer(f90glenum), parameter :: GL_FOG_INDEX = 2913
integer(f90glenum), parameter :: GL_FOG_DENSITY = 2914
integer(f90glenum), parameter :: GL_FOG_START = 2915
integer(f90glenum), parameter :: GL_FOG_END = 2916
integer(f90glenum), parameter :: GL_FOG_MODE = 2917
integer(f90glenum), parameter :: GL_FOG_COLOR = 2918
integer(f90glenum), parameter :: GL_DEPTH_RANGE = 2928
integer(f90glenum), parameter :: GL_DEPTH_TEST = 2929
integer(f90glenum), parameter :: GL_DEPTH_WRITEMASK = 2930
integer(f90glenum), parameter :: GL_DEPTH_CLEAR_VALUE = 2931
integer(f90glenum), parameter :: GL_DEPTH_FUNC = 2932
integer(f90glenum), parameter :: GL_ACCUM_CLEAR_VALUE = 2944
integer(f90glenum), parameter :: GL_STENCIL_TEST = 2960
integer(f90glenum), parameter :: GL_STENCIL_CLEAR_VALUE = 2961
integer(f90glenum), parameter :: GL_STENCIL_FUNC = 2962
integer(f90glenum), parameter :: GL_STENCIL_VALUE_MASK = 2963
integer(f90glenum), parameter :: GL_STENCIL_FAIL = 2964
integer(f90glenum), parameter :: GL_STENCIL_PASS_DEPTH_FAIL = 2965
integer(f90glenum), parameter :: GL_STENCIL_PASS_DEPTH_PASS = 2966
integer(f90glenum), parameter :: GL_STENCIL_REF = 2967
integer(f90glenum), parameter :: GL_STENCIL_WRITEMASK = 2968
integer(f90glenum), parameter :: GL_MATRIX_MODE = 2976
integer(f90glenum), parameter :: GL_NORMALIZE = 2977
integer(f90glenum), parameter :: GL_VIEWPORT = 2978
integer(f90glenum), parameter :: GL_MODELVIEW_STACK_DEPTH = 2979
integer(f90glenum), parameter :: GL_PROJECTION_STACK_DEPTH = 2980
integer(f90glenum), parameter :: GL_TEXTURE_STACK_DEPTH = 2981
integer(f90glenum), parameter :: GL_MODELVIEW_MATRIX = 2982
integer(f90glenum), parameter :: GL_PROJECTION_MATRIX = 2983
integer(f90glenum), parameter :: GL_TEXTURE_MATRIX = 2984
integer(f90glenum), parameter :: GL_ATTRIB_STACK_DEPTH = 2992
integer(f90glenum), parameter :: GL_ALPHA_TEST = 3008
integer(f90glenum), parameter :: GL_ALPHA_TEST_FUNC = 3009
integer(f90glenum), parameter :: GL_ALPHA_TEST_REF = 3010
integer(f90glenum), parameter :: GL_DITHER = 3024
integer(f90glenum), parameter :: GL_BLEND_DST = 3040
integer(f90glenum), parameter :: GL_BLEND_SRC = 3041
integer(f90glenum), parameter :: GL_BLEND = 3042
integer(f90glenum), parameter :: GL_LOGIC_OP_MODE = 3056
integer(f90glenum), parameter :: GL_LOGIC_OP = 3057
integer(f90glenum), parameter :: GL_AUX_BUFFERS = 3072
integer(f90glenum), parameter :: GL_DRAW_BUFFER = 3073
integer(f90glenum), parameter :: GL_READ_BUFFER = 3074
integer(f90glenum), parameter :: GL_SCISSOR_BOX = 3088
integer(f90glenum), parameter :: GL_SCISSOR_TEST = 3089
integer(f90glenum), parameter :: GL_INDEX_CLEAR_VALUE = 3104
integer(f90glenum), parameter :: GL_INDEX_WRITEMASK = 3105
integer(f90glenum), parameter :: GL_COLOR_CLEAR_VALUE = 3106
integer(f90glenum), parameter :: GL_COLOR_WRITEMASK = 3107
integer(f90glenum), parameter :: GL_INDEX_MODE = 3120
integer(f90glenum), parameter :: GL_RGBA_MODE = 3121
integer(f90glenum), parameter :: GL_DOUBLEBUFFER = 3122
integer(f90glenum), parameter :: GL_STEREO = 3123
integer(f90glenum), parameter :: GL_RENDER_MODE = 3136
integer(f90glenum), parameter :: GL_PERSPECTIVE_CORRECTION_HINT = 3152
integer(f90glenum), parameter :: GL_POINT_SMOOTH_HINT = 3153
integer(f90glenum), parameter :: GL_LINE_SMOOTH_HINT = 3154
integer(f90glenum), parameter :: GL_POLYGON_SMOOTH_HINT = 3155
integer(f90glenum), parameter :: GL_FOG_HINT = 3156
integer(f90glenum), parameter :: GL_TEXTURE_GEN_S = 3168
integer(f90glenum), parameter :: GL_TEXTURE_GEN_T = 3169
integer(f90glenum), parameter :: GL_TEXTURE_GEN_R = 3170
integer(f90glenum), parameter :: GL_TEXTURE_GEN_Q = 3171
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_I_SIZE = 3248
integer(f90glenum), parameter :: GL_PIXEL_MAP_S_TO_S_SIZE = 3249
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_R_SIZE = 3250
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_G_SIZE = 3251
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_B_SIZE = 3252
integer(f90glenum), parameter :: GL_PIXEL_MAP_I_TO_A_SIZE = 3253
integer(f90glenum), parameter :: GL_PIXEL_MAP_R_TO_R_SIZE = 3254
integer(f90glenum), parameter :: GL_PIXEL_MAP_G_TO_G_SIZE = 3255
integer(f90glenum), parameter :: GL_PIXEL_MAP_B_TO_B_SIZE = 3256
integer(f90glenum), parameter :: GL_PIXEL_MAP_A_TO_A_SIZE = 3257
integer(f90glenum), parameter :: GL_UNPACK_SWAP_BYTES = 3312
integer(f90glenum), parameter :: GL_UNPACK_LSB_FIRST = 3313
integer(f90glenum), parameter :: GL_UNPACK_ROW_LENGTH = 3314
integer(f90glenum), parameter :: GL_UNPACK_SKIP_ROWS = 3315
integer(f90glenum), parameter :: GL_UNPACK_SKIP_PIXELS = 3316
integer(f90glenum), parameter :: GL_UNPACK_ALIGNMENT = 3317
integer(f90glenum), parameter :: GL_PACK_SWAP_BYTES = 3328
integer(f90glenum), parameter :: GL_PACK_LSB_FIRST = 3329
integer(f90glenum), parameter :: GL_PACK_ROW_LENGTH = 3330
integer(f90glenum), parameter :: GL_PACK_SKIP_ROWS = 3331
integer(f90glenum), parameter :: GL_PACK_SKIP_PIXELS = 3332
integer(f90glenum), parameter :: GL_PACK_ALIGNMENT = 3333
integer(f90glenum), parameter :: GL_MAP_COLOR = 3344
integer(f90glenum), parameter :: GL_MAP_STENCIL = 3345
integer(f90glenum), parameter :: GL_INDEX_SHIFT = 3346
integer(f90glenum), parameter :: GL_INDEX_OFFSET = 3347
integer(f90glenum), parameter :: GL_RED_SCALE = 3348
integer(f90glenum), parameter :: GL_RED_BIAS = 3349
integer(f90glenum), parameter :: GL_ZOOM_X = 3350
integer(f90glenum), parameter :: GL_ZOOM_Y = 3351
integer(f90glenum), parameter :: GL_GREEN_SCALE = 3352
integer(f90glenum), parameter :: GL_GREEN_BIAS = 3353
integer(f90glenum), parameter :: GL_BLUE_SCALE = 3354
integer(f90glenum), parameter :: GL_BLUE_BIAS = 3355
integer(f90glenum), parameter :: GL_ALPHA_SCALE = 3356
integer(f90glenum), parameter :: GL_ALPHA_BIAS = 3357
integer(f90glenum), parameter :: GL_DEPTH_SCALE = 3358
integer(f90glenum), parameter :: GL_DEPTH_BIAS = 3359
integer(f90glenum), parameter :: GL_MAX_EVAL_ORDER = 3376
integer(f90glenum), parameter :: GL_MAX_LIGHTS = 3377
integer(f90glenum), parameter :: GL_MAX_CLIP_PLANES = 3378
integer(f90glenum), parameter :: GL_MAX_TEXTURE_SIZE = 3379
integer(f90glenum), parameter :: GL_MAX_PIXEL_MAP_TABLE = 3380
integer(f90glenum), parameter :: GL_MAX_ATTRIB_STACK_DEPTH = 3381
integer(f90glenum), parameter :: GL_MAX_MODELVIEW_STACK_DEPTH = 3382
integer(f90glenum), parameter :: GL_MAX_NAME_STACK_DEPTH = 3383
integer(f90glenum), parameter :: GL_MAX_PROJECTION_STACK_DEPTH = 3384
integer(f90glenum), parameter :: GL_MAX_TEXTURE_STACK_DEPTH = 3385
integer(f90glenum), parameter :: GL_MAX_VIEWPORT_DIMS = 3386
integer(f90glenum), parameter :: GL_SUBPIXEL_BITS = 3408
integer(f90glenum), parameter :: GL_INDEX_BITS = 3409
integer(f90glenum), parameter :: GL_RED_BITS = 3410
integer(f90glenum), parameter :: GL_GREEN_BITS = 3411
integer(f90glenum), parameter :: GL_BLUE_BITS = 3412
integer(f90glenum), parameter :: GL_ALPHA_BITS = 3413
integer(f90glenum), parameter :: GL_DEPTH_BITS = 3414
integer(f90glenum), parameter :: GL_STENCIL_BITS = 3415
integer(f90glenum), parameter :: GL_ACCUM_RED_BITS = 3416
integer(f90glenum), parameter :: GL_ACCUM_GREEN_BITS = 3417
integer(f90glenum), parameter :: GL_ACCUM_BLUE_BITS = 3418
integer(f90glenum), parameter :: GL_ACCUM_ALPHA_BITS = 3419
integer(f90glenum), parameter :: GL_NAME_STACK_DEPTH = 3440
integer(f90glenum), parameter :: GL_AUTO_NORMAL = 3456
integer(f90glenum), parameter :: GL_MAP1_COLOR_4 = 3472
integer(f90glenum), parameter :: GL_MAP1_INDEX = 3473
integer(f90glenum), parameter :: GL_MAP1_NORMAL = 3474
integer(f90glenum), parameter :: GL_MAP1_TEXTURE_COORD_1 = 3475
integer(f90glenum), parameter :: GL_MAP1_TEXTURE_COORD_2 = 3476
integer(f90glenum), parameter :: GL_MAP1_TEXTURE_COORD_3 = 3477
integer(f90glenum), parameter :: GL_MAP1_TEXTURE_COORD_4 = 3478
integer(f90glenum), parameter :: GL_MAP1_VERTEX_3 = 3479
integer(f90glenum), parameter :: GL_MAP1_VERTEX_4 = 3480
integer(f90glenum), parameter :: GL_MAP2_COLOR_4 = 3504
integer(f90glenum), parameter :: GL_MAP2_INDEX = 3505
integer(f90glenum), parameter :: GL_MAP2_NORMAL = 3506
integer(f90glenum), parameter :: GL_MAP2_TEXTURE_COORD_1 = 3507
integer(f90glenum), parameter :: GL_MAP2_TEXTURE_COORD_2 = 3508
integer(f90glenum), parameter :: GL_MAP2_TEXTURE_COORD_3 = 3509
integer(f90glenum), parameter :: GL_MAP2_TEXTURE_COORD_4 = 3510
integer(f90glenum), parameter :: GL_MAP2_VERTEX_3 = 3511
integer(f90glenum), parameter :: GL_MAP2_VERTEX_4 = 3512
integer(f90glenum), parameter :: GL_MAP1_GRID_DOMAIN = 3536
integer(f90glenum), parameter :: GL_MAP1_GRID_SEGMENTS = 3537
integer(f90glenum), parameter :: GL_MAP2_GRID_DOMAIN = 3538
integer(f90glenum), parameter :: GL_MAP2_GRID_SEGMENTS = 3539
integer(f90glenum), parameter :: GL_TEXTURE_1D = 3552
integer(f90glenum), parameter :: GL_TEXTURE_2D = 3553
integer(f90glenum), parameter :: GL_TEXTURE_WIDTH = 4096
integer(f90glenum), parameter :: GL_TEXTURE_HEIGHT = 4097
integer(f90glenum), parameter :: GL_TEXTURE_COMPONENTS = 4099
integer(f90glenum), parameter :: GL_TEXTURE_BORDER_COLOR = 4100
integer(f90glenum), parameter :: GL_TEXTURE_BORDER = 4101
integer(f90glenum), parameter :: GL_DONT_CARE = 4352
integer(f90glenum), parameter :: GL_FASTEST = 4353
integer(f90glenum), parameter :: GL_NICEST = 4354
integer(f90glenum), parameter :: GL_AMBIENT = 4608
integer(f90glenum), parameter :: GL_DIFFUSE = 4609
integer(f90glenum), parameter :: GL_SPECULAR = 4610
integer(f90glenum), parameter :: GL_POSITION = 4611
integer(f90glenum), parameter :: GL_SPOT_DIRECTION = 4612
integer(f90glenum), parameter :: GL_SPOT_EXPONENT = 4613
integer(f90glenum), parameter :: GL_SPOT_CUTOFF = 4614
integer(f90glenum), parameter :: GL_CONSTANT_ATTENUATION = 4615
integer(f90glenum), parameter :: GL_LINEAR_ATTENUATION = 4616
integer(f90glenum), parameter :: GL_QUADRATIC_ATTENUATION = 4617
integer(f90glenum), parameter :: GL_COMPILE = 4864
integer(f90glenum), parameter :: GL_COMPILE_AND_EXECUTE = 4865
integer(f90glenum), parameter :: GL_BYTE = 5120
integer(f90glenum), parameter :: GL_UNSIGNED_BYTE = 5121
integer(f90glenum), parameter :: GL_SHORT = 5122
integer(f90glenum), parameter :: GL_UNSIGNED_SHORT = 5123
integer(f90glenum), parameter :: GL_INT = 5124
integer(f90glenum), parameter :: GL_UNSIGNED_INT = 5125
integer(f90glenum), parameter :: GL_FLOAT = 5126
integer(f90glenum), parameter :: GL_2_BYTES = 5127
integer(f90glenum), parameter :: GL_3_BYTES = 5128
integer(f90glenum), parameter :: GL_4_BYTES = 5129
integer(f90glenum), parameter :: GL_CLEAR = 5376
integer(f90glenum), parameter :: GL_AND = 5377
integer(f90glenum), parameter :: GL_AND_REVERSE = 5378
integer(f90glenum), parameter :: GL_COPY = 5379
integer(f90glenum), parameter :: GL_AND_INVERTED = 5380
integer(f90glenum), parameter :: GL_NOOP = 5381
integer(f90glenum), parameter :: GL_XOR = 5382
integer(f90glenum), parameter :: GL_OR = 5383
integer(f90glenum), parameter :: GL_NOR = 5384
integer(f90glenum), parameter :: GL_EQUIV = 5385
integer(f90glenum), parameter :: GL_INVERT = 5386
integer(f90glenum), parameter :: GL_OR_REVERSE = 5387
integer(f90glenum), parameter :: GL_COPY_INVERTED = 5388
integer(f90glenum), parameter :: GL_OR_INVERTED = 5389
integer(f90glenum), parameter :: GL_NAND = 5390
integer(f90glenum), parameter :: GL_SET = 5391
integer(f90glenum), parameter :: GL_EMISSION = 5632
integer(f90glenum), parameter :: GL_SHININESS = 5633
integer(f90glenum), parameter :: GL_AMBIENT_AND_DIFFUSE = 5634
integer(f90glenum), parameter :: GL_COLOR_INDEXES = 5635
integer(f90glenum), parameter :: GL_MODELVIEW = 5888
integer(f90glenum), parameter :: GL_PROJECTION = 5889
integer(f90glenum), parameter :: GL_TEXTURE = 5890
integer(f90glenum), parameter :: GL_COLOR = 6144
integer(f90glenum), parameter :: GL_DEPTH = 6145
integer(f90glenum), parameter :: GL_STENCIL = 6146
integer(f90glenum), parameter :: GL_COLOR_INDEX = 6400
integer(f90glenum), parameter :: GL_STENCIL_INDEX = 6401
integer(f90glenum), parameter :: GL_DEPTH_COMPONENT = 6402
integer(f90glenum), parameter :: GL_RED = 6403
integer(f90glenum), parameter :: GL_GREEN = 6404
integer(f90glenum), parameter :: GL_BLUE = 6405
integer(f90glenum), parameter :: GL_ALPHA = 6406
integer(f90glenum), parameter :: GL_RGB = 6407
integer(f90glenum), parameter :: GL_RGBA = 6408
integer(f90glenum), parameter :: GL_LUMINANCE = 6409
integer(f90glenum), parameter :: GL_LUMINANCE_ALPHA = 6410
integer(f90glenum), parameter :: GL_BITMAP = 6656
integer(f90glenum), parameter :: GL_POINT = 6912
integer(f90glenum), parameter :: GL_LINE = 6913
integer(f90glenum), parameter :: GL_FILL = 6914
integer(f90glenum), parameter :: GL_RENDER = 7168
integer(f90glenum), parameter :: GL_FEEDBACK = 7169
integer(f90glenum), parameter :: GL_SELECT = 7170
integer(f90glenum), parameter :: GL_FLAT = 7424
integer(f90glenum), parameter :: GL_SMOOTH = 7425
integer(f90glenum), parameter :: GL_KEEP = 7680
integer(f90glenum), parameter :: GL_REPLACE = 7681
integer(f90glenum), parameter :: GL_INCR = 7682
integer(f90glenum), parameter :: GL_DECR = 7683
integer(f90glenum), parameter :: GL_VENDOR = 7936
integer(f90glenum), parameter :: GL_RENDERER = 7937
integer(f90glenum), parameter :: GL_VERSION = 7938
integer(f90glenum), parameter :: GL_EXTENSIONS = 7939
integer(f90glenum), parameter :: GL_S = 8192
integer(f90glenum), parameter :: GL_T = 8193
integer(f90glenum), parameter :: GL_R = 8194
integer(f90glenum), parameter :: GL_Q = 8195
integer(f90glenum), parameter :: GL_MODULATE = 8448
integer(f90glenum), parameter :: GL_DECAL = 8449
integer(f90glenum), parameter :: GL_TEXTURE_ENV_MODE = 8704
integer(f90glenum), parameter :: GL_TEXTURE_ENV_COLOR = 8705
integer(f90glenum), parameter :: GL_TEXTURE_ENV = 8960
integer(f90glenum), parameter :: GL_EYE_LINEAR = 9216
integer(f90glenum), parameter :: GL_OBJECT_LINEAR = 9217
integer(f90glenum), parameter :: GL_SPHERE_MAP = 9218
integer(f90glenum), parameter :: GL_TEXTURE_GEN_MODE = 9472
integer(f90glenum), parameter :: GL_OBJECT_PLANE = 9473
integer(f90glenum), parameter :: GL_EYE_PLANE = 9474
integer(f90glenum), parameter :: GL_NEAREST = 9728
integer(f90glenum), parameter :: GL_LINEAR = 9729
integer(f90glenum), parameter :: GL_NEAREST_MIPMAP_NEAREST = 9984
integer(f90glenum), parameter :: GL_LINEAR_MIPMAP_NEAREST = 9985
integer(f90glenum), parameter :: GL_NEAREST_MIPMAP_LINEAR = 9986
integer(f90glenum), parameter :: GL_LINEAR_MIPMAP_LINEAR = 9987
integer(f90glenum), parameter :: GL_TEXTURE_MAG_FILTER = 10240
integer(f90glenum), parameter :: GL_TEXTURE_MIN_FILTER = 10241
integer(f90glenum), parameter :: GL_TEXTURE_WRAP_S = 10242
integer(f90glenum), parameter :: GL_TEXTURE_WRAP_T = 10243
integer(f90glenum), parameter :: GL_CLAMP = 10496
integer(f90glenum), parameter :: GL_REPEAT = 10497
integer(f90glenum), parameter :: GL_CLIP_PLANE0 = 12288
integer(f90glenum), parameter :: GL_CLIP_PLANE1 = 12289
integer(f90glenum), parameter :: GL_CLIP_PLANE2 = 12290
integer(f90glenum), parameter :: GL_CLIP_PLANE3 = 12291
integer(f90glenum), parameter :: GL_CLIP_PLANE4 = 12292
integer(f90glenum), parameter :: GL_CLIP_PLANE5 = 12293
integer(f90glenum), parameter :: GL_LIGHT0 = 16384
integer(f90glenum), parameter :: GL_LIGHT1 = 16385
integer(f90glenum), parameter :: GL_LIGHT2 = 16386
integer(f90glenum), parameter :: GL_LIGHT3 = 16387
integer(f90glenum), parameter :: GL_LIGHT4 = 16388
integer(f90glenum), parameter :: GL_LIGHT5 = 16389
integer(f90glenum), parameter :: GL_LIGHT6 = 16390
integer(f90glenum), parameter :: GL_LIGHT7 = 16391
integer(f90glenum), parameter :: GL_EXT_abgr = 1
integer(f90glenum), parameter :: GL_EXT_blend_color = 1
integer(f90glenum), parameter :: GL_EXT_blend_logic_op = 1
integer(f90glenum), parameter :: GL_EXT_blend_minmax = 1
integer(f90glenum), parameter :: GL_EXT_blend_subtract = 1
integer(f90glenum), parameter :: GL_EXT_convolution = 1
integer(f90glenum), parameter :: GL_EXT_histogram = 1
integer(f90glenum), parameter :: GL_EXT_polygon_offset = 1
integer(f90glenum), parameter :: GL_EXT_subtexture = 1
integer(f90glenum), parameter :: GL_EXT_texture = 1
integer(f90glenum), parameter :: GL_EXT_texture3D = 1
integer(f90glenum), parameter :: GL_SGIS_detail_texture = 1
integer(f90glenum), parameter :: GL_SGIS_multisample = 1
integer(f90glenum), parameter :: GL_SGIS_sharpen_texture = 1
integer(f90glenum), parameter :: GL_ABGR_EXT = 32768
integer(f90glenum), parameter :: GL_CONSTANT_COLOR_EXT = 32769
integer(f90glenum), parameter :: GL_ONE_MINUS_CONSTANT_COLOR_EXT = 32770
integer(f90glenum), parameter :: GL_CONSTANT_ALPHA_EXT = 32771
integer(f90glenum), parameter :: GL_ONE_MINUS_CONSTANT_ALPHA_EXT = 32772
integer(f90glenum), parameter :: GL_BLEND_COLOR_EXT = 32773
integer(f90glenum), parameter :: GL_FUNC_ADD_EXT = 32774
integer(f90glenum), parameter :: GL_MIN_EXT = 32775
integer(f90glenum), parameter :: GL_MAX_EXT = 32776
integer(f90glenum), parameter :: GL_BLEND_EQUATION_EXT = 32777
integer(f90glenum), parameter :: GL_FUNC_SUBTRACT_EXT = 32778
integer(f90glenum), parameter :: GL_FUNC_REVERSE_SUBTRACT_EXT = 32779
integer(f90glenum), parameter :: GL_CONVOLUTION_1D_EXT = 32784
integer(f90glenum), parameter :: GL_CONVOLUTION_2D_EXT = 32785
integer(f90glenum), parameter :: GL_SEPARABLE_2D_EXT = 32786
integer(f90glenum), parameter :: GL_CONVOLUTION_BORDER_MODE_EXT = 32787
integer(f90glenum), parameter :: GL_CONVOLUTION_FILTER_SCALE_EXT = 32788
integer(f90glenum), parameter :: GL_CONVOLUTION_FILTER_BIAS_EXT = 32789
integer(f90glenum), parameter :: GL_REDUCE_EXT = 32790
integer(f90glenum), parameter :: GL_CONVOLUTION_FORMAT_EXT = 32791
integer(f90glenum), parameter :: GL_CONVOLUTION_WIDTH_EXT = 32792
integer(f90glenum), parameter :: GL_CONVOLUTION_HEIGHT_EXT = 32793
integer(f90glenum), parameter :: GL_MAX_CONVOLUTION_WIDTH_EXT = 32794
integer(f90glenum), parameter :: GL_MAX_CONVOLUTION_HEIGHT_EXT = 32795
integer(f90glenum), parameter :: GL_POST_CONVOLUTION_RED_SCALE_E = 32796
integer(f90glenum), parameter :: GL_POST_CONVOLUTION_GREEN_SCALE = 32797
integer(f90glenum), parameter :: GL_POST_CONVOLUTION_BLUE_SCALE_ = 32798
integer(f90glenum), parameter :: GL_POST_CONVOLUTION_ALPHA_SCALE = 32799
integer(f90glenum), parameter :: GL_POST_CONVOLUTION_RED_BIAS_EX = 32800
integer(f90glenum), parameter :: GL_POST_CONVOLUTION_GREEN_BIAS_ = 32801
integer(f90glenum), parameter :: GL_POST_CONVOLUTION_BLUE_BIAS_E = 32802
integer(f90glenum), parameter :: GL_POST_CONVOLUTION_ALPHA_BIAS_ = 32803
integer(f90glenum), parameter :: GL_HISTOGRAM_EXT = 32804
integer(f90glenum), parameter :: GL_PROXY_HISTOGRAM_EXT = 32805
integer(f90glenum), parameter :: GL_HISTOGRAM_WIDTH_EXT = 32806
integer(f90glenum), parameter :: GL_HISTOGRAM_FORMAT_EXT = 32807
integer(f90glenum), parameter :: GL_HISTOGRAM_RED_SIZE_EXT = 32808
integer(f90glenum), parameter :: GL_HISTOGRAM_GREEN_SIZE_EXT = 32809
integer(f90glenum), parameter :: GL_HISTOGRAM_BLUE_SIZE_EXT = 32810
integer(f90glenum), parameter :: GL_HISTOGRAM_ALPHA_SIZE_EXT = 32811
integer(f90glenum), parameter :: GL_HISTOGRAM_LUMINANCE_SIZE_EXT = 32812
integer(f90glenum), parameter :: GL_HISTOGRAM_SINK_EXT = 32813
integer(f90glenum), parameter :: GL_MINMAX_EXT = 32814
integer(f90glenum), parameter :: GL_MINMAX_FORMAT_EXT = 32815
integer(f90glenum), parameter :: GL_MINMAX_SINK_EXT = 32816
integer(f90glenum), parameter :: GL_TABLE_TOO_LARGE_EXT = 32817
integer(f90glenum), parameter :: GL_POLYGON_OFFSET_EXT = 32823
integer(f90glenum), parameter :: GL_POLYGON_OFFSET_FACTOR_EXT = 32824
integer(f90glenum), parameter :: GL_POLYGON_OFFSET_BIAS_EXT = 32825
integer(f90glenum), parameter :: GL_ALPHA4_EXT = 32827
integer(f90glenum), parameter :: GL_ALPHA8_EXT = 32828
integer(f90glenum), parameter :: GL_ALPHA12_EXT = 32829
integer(f90glenum), parameter :: GL_ALPHA16_EXT = 32830
integer(f90glenum), parameter :: GL_LUMINANCE4_EXT = 32831
integer(f90glenum), parameter :: GL_LUMINANCE8_EXT = 32832
integer(f90glenum), parameter :: GL_LUMINANCE12_EXT = 32833
integer(f90glenum), parameter :: GL_LUMINANCE16_EXT = 32834
integer(f90glenum), parameter :: GL_LUMINANCE4_ALPHA4_EXT = 32835
integer(f90glenum), parameter :: GL_LUMINANCE6_ALPHA2_EXT = 32836
integer(f90glenum), parameter :: GL_LUMINANCE8_ALPHA8_EXT = 32837
integer(f90glenum), parameter :: GL_LUMINANCE12_ALPHA4_EXT = 32838
integer(f90glenum), parameter :: GL_LUMINANCE12_ALPHA12_EXT = 32839
integer(f90glenum), parameter :: GL_LUMINANCE16_ALPHA16_EXT = 32840
integer(f90glenum), parameter :: GL_INTENSITY_EXT = 32841
integer(f90glenum), parameter :: GL_INTENSITY4_EXT = 32842
integer(f90glenum), parameter :: GL_INTENSITY8_EXT = 32843
integer(f90glenum), parameter :: GL_INTENSITY12_EXT = 32844
integer(f90glenum), parameter :: GL_INTENSITY16_EXT = 32845
integer(f90glenum), parameter :: GL_RGB2_EXT = 32846
integer(f90glenum), parameter :: GL_RGB4_EXT = 32847
integer(f90glenum), parameter :: GL_RGB5_EXT = 32848
integer(f90glenum), parameter :: GL_RGB8_EXT = 32849
integer(f90glenum), parameter :: GL_RGB10_EXT = 32850
integer(f90glenum), parameter :: GL_RGB12_EXT = 32851
integer(f90glenum), parameter :: GL_RGB16_EXT = 32852
integer(f90glenum), parameter :: GL_RGBA2_EXT = 32853
integer(f90glenum), parameter :: GL_RGBA4_EXT = 32854
integer(f90glenum), parameter :: GL_RGB5_A1_EXT = 32855
integer(f90glenum), parameter :: GL_RGBA8_EXT = 32856
integer(f90glenum), parameter :: GL_RGB10_A2_EXT = 32857
integer(f90glenum), parameter :: GL_RGBA12_EXT = 32858
integer(f90glenum), parameter :: GL_RGBA16_EXT = 32859
integer(f90glenum), parameter :: GL_TEXTURE_RED_SIZE_EXT = 32860
integer(f90glenum), parameter :: GL_TEXTURE_GREEN_SIZE_EXT = 32861
integer(f90glenum), parameter :: GL_TEXTURE_BLUE_SIZE_EXT = 32862
integer(f90glenum), parameter :: GL_TEXTURE_ALPHA_SIZE_EXT = 32863
integer(f90glenum), parameter :: GL_TEXTURE_LUMINANCE_SIZE_EXT = 32864
integer(f90glenum), parameter :: GL_TEXTURE_INTENSITY_SIZE_EXT = 32865
integer(f90glenum), parameter :: GL_REPLACE_EXT = 32866
integer(f90glenum), parameter :: GL_PROXY_TEXTURE_1D_EXT = 32867
integer(f90glenum), parameter :: GL_PROXY_TEXTURE_2D_EXT = 32868
integer(f90glenum), parameter :: GL_TEXTURE_TOO_LARGE_EXT = 32869
integer(f90glenum), parameter :: GL_PACK_SKIP_IMAGES_EXT = 32875
integer(f90glenum), parameter :: GL_PACK_IMAGE_HEIGHT_EXT = 32876
integer(f90glenum), parameter :: GL_UNPACK_SKIP_IMAGES_EXT = 32877
integer(f90glenum), parameter :: GL_UNPACK_IMAGE_HEIGHT_EXT = 32878
integer(f90glenum), parameter :: GL_TEXTURE_3D_EXT = 32879
integer(f90glenum), parameter :: GL_PROXY_TEXTURE_3D_EXT = 32880
integer(f90glenum), parameter :: GL_TEXTURE_DEPTH_EXT = 32881
integer(f90glenum), parameter :: GL_TEXTURE_WRAP_R_EXT = 32882
integer(f90glenum), parameter :: GL_MAX_3D_TEXTURE_SIZE_EXT = 32883
integer(f90glenum), parameter :: GL_DETAIL_TEXTURE_2D_SGIS = 32917
integer(f90glenum), parameter :: GL_DETAIL_TEXTURE_2D_BINDING_SG = 32918
integer(f90glenum), parameter :: GL_LINEAR_DETAIL_SGIS = 32919
integer(f90glenum), parameter :: GL_LINEAR_DETAIL_ALPHA_SGIS = 32920
integer(f90glenum), parameter :: GL_LINEAR_DETAIL_COLOR_SGIS = 32921
integer(f90glenum), parameter :: GL_DETAIL_TEXTURE_LEVEL_SGIS = 32922
integer(f90glenum), parameter :: GL_DETAIL_TEXTURE_MODE_SGIS = 32923
integer(f90glenum), parameter :: GL_DETAIL_TEXTURE_FUNC_POINTS_S = 32924
integer(f90glenum), parameter :: GL_MULTISAMPLE_BIT_EXT = 536870912
integer(f90glenum), parameter :: GL_MULTISAMPLE_SGIS = 32925
integer(f90glenum), parameter :: GL_SAMPLE_ALPHA_TO_MASK_SGIS = 32926
integer(f90glenum), parameter :: GL_SAMPLE_ALPHA_TO_ONE_SGIS = 32927
integer(f90glenum), parameter :: GL_SAMPLE_MASK_SGIS = 32928
integer(f90glenum), parameter :: GL_1PASS_SGIS = 32929
integer(f90glenum), parameter :: GL_2PASS_0_SGIS = 32930
integer(f90glenum), parameter :: GL_2PASS_1_SGIS = 32931
integer(f90glenum), parameter :: GL_4PASS_0_SGIS = 32932
integer(f90glenum), parameter :: GL_4PASS_1_SGIS = 32933
integer(f90glenum), parameter :: GL_4PASS_2_SGIS = 32934
integer(f90glenum), parameter :: GL_4PASS_3_SGIS = 32935
integer(f90glenum), parameter :: GL_SAMPLE_BUFFERS_SGIS = 32936
integer(f90glenum), parameter :: GL_SAMPLES_SGIS = 32937
integer(f90glenum), parameter :: GL_SAMPLE_MASK_VALUE_SGIS = 32938
integer(f90glenum), parameter :: GL_SAMPLE_MASK_INVERT_SGIS = 32939
integer(f90glenum), parameter :: GL_SAMPLE_PATTERN_SGIS = 32940
integer(f90glenum), parameter :: GL_LINEAR_SHARPEN_SGIS = 32941
integer(f90glenum), parameter :: GL_LINEAR_SHARPEN_ALPHA_SGIS = 32942
integer(f90glenum), parameter :: GL_LINEAR_SHARPEN_COLOR_SGIS = 32943
integer(f90glenum), parameter :: GL_SHARPEN_TEXTURE_FUNC_POINTS_ = 32944

! interface blocks

interface f90glclearindex                
   subroutine fglclearindex(c)
   use f90gl_kinds
   real(f90glfloat) c
   end subroutine
end interface

interface f90glclearcolor                
   subroutine fglclearcolor(red,green,blue,alpha)
   use f90gl_kinds
   real(f90glclampf) red, green, blue, alpha
   end subroutine
end interface

interface f90glclear                     
   subroutine fglclear(mask)
   use f90gl_kinds
   integer(f90glbitfield) mask
   end subroutine
end interface

interface f90glindexmask                 
   subroutine fglindexmask(mask)
   use f90gl_kinds
   integer(f90gluint) mask
   end subroutine
end interface

interface f90glcolormask                 
   module procedure f9xglcolormask
end interface

interface f90glalphafunc                 
   subroutine fglalphafunc(func,ref)
   use f90gl_kinds
   integer(f90glenum) func
   real(f90glclampf) ref
   end subroutine
end interface

interface f90glblendfunc                 
   subroutine fglblendfunc(sfactor,dfactor)
   use f90gl_kinds
   integer(f90glenum) sfactor, dfactor
   end subroutine
end interface

interface f90gllogicop                   
   subroutine fgllogicop(opcode)
   use f90gl_kinds
   integer(f90glenum) opcode
   end subroutine
end interface

interface f90glcullface                  
   subroutine fglcullface(mode)
   use f90gl_kinds
   integer(f90glenum) mode
   end subroutine
end interface

interface f90glfrontface                 
   subroutine fglfrontface(mode)
   use f90gl_kinds
   integer(f90glenum) mode
   end subroutine
end interface

interface f90glpointsize                 
   subroutine fglpointsize(size)
   use f90gl_kinds
   real(f90glfloat) size
   end subroutine
end interface

interface f90gllinewidth                 
   subroutine fgllinewidth(width)
   use f90gl_kinds
   real(f90glfloat) width
   end subroutine
end interface

interface f90gllinestipple               
   module procedure f9xgllinestipple
end interface

interface f90glpolygonmode               
   subroutine fglpolygonmode(face,mode)
   use f90gl_kinds
   integer(f90glenum) face, mode
   end subroutine
end interface

interface f90glpolygonstipple            
   module procedure f9xglpolygonstipple
end interface

interface f90glgetpolygonstipple         
   module procedure f9xglgetpolygonstipple
end interface

interface f90gledgeflag                  
   module procedure f9xgledgeflag
end interface

interface f90gledgeflagv                 
   module procedure f9xgledgeflagv
end interface

interface f90glscissor                   
   subroutine fglscissor(x,y,width,height)
   use f90gl_kinds
   integer(f90glint) x, y
   integer(f90glsizei) width, height
   end subroutine
end interface

interface f90glclipplane                 
   subroutine fglclipplane(plane,equation)
   use f90gl_kinds
   integer(f90glenum) plane
   real(f90gldouble) equation(*)
   end subroutine
end interface

interface f90glgetclipplane              
   subroutine fglgetclipplane(plane,equation)
   use f90gl_kinds
   integer(f90glenum) plane
   real(f90gldouble) equation(*)
   end subroutine
end interface

interface f90gldrawbuffer                
   subroutine fgldrawbuffer(mode)
   use f90gl_kinds
   integer(f90glenum) mode
   end subroutine
end interface

interface f90glreadbuffer                
   subroutine fglreadbuffer(mode)
   use f90gl_kinds
   integer(f90glenum) mode
   end subroutine
end interface

interface f90glenable                    
   subroutine fglenable(cap)
   use f90gl_kinds
   integer(f90glenum) cap
   end subroutine
end interface

interface f90gldisable                   
   subroutine fgldisable(cap)
   use f90gl_kinds
   integer(f90glenum) cap
   end subroutine
end interface

interface f90glisenabled                 
   module procedure f9xglisenabled
end interface

interface f90glgetbooleanv               
   module procedure f9xglgetbooleanv
end interface

interface f90glgetdoublev                
   subroutine fglgetdoublev(pname,params)
   use f90gl_kinds
   integer(f90glenum) pname
   real(f90gldouble) params(*)
   end subroutine
end interface

interface f90glgetfloatv                 
   subroutine fglgetfloatv(pname,params)
   use f90gl_kinds
   integer(f90glenum) pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glgetintegerv               
   subroutine fglgetintegerv(pname,params)
   use f90gl_kinds
   integer(f90glenum) pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glpushattrib                
   subroutine fglpushattrib(mask)
   use f90gl_kinds
   integer(f90glbitfield) mask
   end subroutine
end interface

interface f90glpopattrib                 
   subroutine fglpopattrib()
   use f90gl_kinds
   end subroutine
end interface

interface f90glrendermode                
   function fglrendermode(mode)
   use f90gl_kinds
   integer(f90glint) fglrendermode
   integer(f90glenum) mode
   end function
end interface

interface f90glgeterror                  
   function fglgeterror()
   use f90gl_kinds
   integer(f90glenum) fglgeterror
   end function
end interface

interface f90glgetstring                 
   module procedure f9xglgetstring
end interface

interface f90glfinish                    
   subroutine fglfinish()
   use f90gl_kinds
   end subroutine
end interface

interface f90glflush                     
   subroutine fglflush()
   use f90gl_kinds
   end subroutine
end interface

interface f90glhint                      
   subroutine fglhint(target,mode)
   use f90gl_kinds
   integer(f90glenum) target, mode
   end subroutine
end interface

interface f90glcleardepth                
   subroutine fglcleardepth(depth)
   use f90gl_kinds
   real(f90glclampd) depth
   end subroutine
end interface

interface f90gldepthfunc                 
   subroutine fgldepthfunc(func)
   use f90gl_kinds
   integer(f90glenum) func
   end subroutine
end interface

interface f90gldepthmask                 
   module procedure f9xgldepthmask
end interface

interface f90gldepthrange                
   subroutine fgldepthrange(near_val,far_val)
   use f90gl_kinds
   real(f90glclampd) near_val, far_val
   end subroutine
end interface

interface f90glclearaccum                
   subroutine fglclearaccum(red,green,blue,alpha)
   use f90gl_kinds
   real(f90glfloat) red, green, blue, alpha
   end subroutine
end interface

interface f90glaccum                     
   subroutine fglaccum(op,value)
   use f90gl_kinds
   integer(f90glenum) op
   real(f90glfloat) value
   end subroutine
end interface

interface f90glmatrixmode                
   subroutine fglmatrixmode(mode)
   use f90gl_kinds
   integer(f90glenum) mode
   end subroutine
end interface

interface f90glortho                     
   subroutine fglortho(left,right,bottom,top,near_val,far_val)
   use f90gl_kinds
   real(f90gldouble) left, right, bottom, top, near_val, far_val
   end subroutine
end interface

interface f90glfrustum                   
   subroutine fglfrustum(left,right,bottom,top,near_val,far_val)
   use f90gl_kinds
   real(f90gldouble) left, right, bottom, top, near_val, far_val
   end subroutine
end interface

interface f90glviewport                  
   subroutine fglviewport(x,y,width,height)
   use f90gl_kinds
   integer(f90glint) x, y
   integer(f90glsizei) width, height
   end subroutine
end interface

interface f90glpushmatrix                
   subroutine fglpushmatrix()
   use f90gl_kinds
   end subroutine
end interface

interface f90glpopmatrix                 
   subroutine fglpopmatrix()
   use f90gl_kinds
   end subroutine
end interface

interface f90glloadidentity              
   subroutine fglloadidentity()
   use f90gl_kinds
   end subroutine
end interface

interface f90glloadmatrixd               
   subroutine fglloadmatrixd(m)
   use f90gl_kinds
   real(f90gldouble) m(4,4)
   end subroutine
end interface

interface f90glloadmatrixf               
   subroutine fglloadmatrixf(m)
   use f90gl_kinds
   real(f90glfloat) m(4,4)
   end subroutine
end interface

interface f90glmultmatrixd               
   subroutine fglmultmatrixd(m)
   use f90gl_kinds
   real(f90gldouble) m(4,4)
   end subroutine
end interface

interface f90glmultmatrixf               
   subroutine fglmultmatrixf(m)
   use f90gl_kinds
   real(f90glfloat) m(4,4)
   end subroutine
end interface

interface f90glrotated                   
   subroutine fglrotated(angle,x,y,z)
   use f90gl_kinds
   real(f90gldouble) angle, x, y, z
   end subroutine
end interface

interface f90glrotatef                   
   subroutine fglrotatef(angle,x,y,z)
   use f90gl_kinds
   real(f90glfloat) angle, x, y, z
   end subroutine
end interface

interface f90glscaled                    
   subroutine fglscaled(x,y,z)
   use f90gl_kinds
   real(f90gldouble) x, y, z
   end subroutine
end interface

interface f90glscalef                    
   subroutine fglscalef(x,y,z)
   use f90gl_kinds
   real(f90glfloat) x, y, z
   end subroutine
end interface

interface f90gltranslated                
   subroutine fgltranslated(x,y,z)
   use f90gl_kinds
   real(f90gldouble) x, y, z
   end subroutine
end interface

interface f90gltranslatef                
   subroutine fgltranslatef(x,y,z)
   use f90gl_kinds
   real(f90glfloat) x, y, z
   end subroutine
end interface

interface f90glislist                    
   module procedure f9xglislist
end interface

interface f90gldeletelists               
   subroutine fgldeletelists(list,range)
   use f90gl_kinds
   integer(f90gluint) list
   integer(f90glsizei) range
   end subroutine
end interface

interface f90glgenlists                  
   function fglgenlists(range)
   use f90gl_kinds
   integer(f90gluint) fglgenlists
   integer(f90glsizei) range
   end function
end interface

interface f90glnewlist                   
   subroutine fglnewlist(list,mode)
   use f90gl_kinds
   integer(f90gluint) list
   integer(f90glenum) mode
   end subroutine
end interface

interface f90glendlist                   
   subroutine fglendlist()
   use f90gl_kinds
   end subroutine
end interface

interface f90glcalllist                  
   subroutine fglcalllist(list)
   use f90gl_kinds
   integer(f90gluint) list
   end subroutine
end interface

interface f90glcalllists                 
   subroutine f9y0glcalllists(n,type,lists)
   use f90gl_kinds
   integer(f90glsizei) n
   integer(f90glenum) type
   integer(f90glint) lists(*)
   end subroutine
   subroutine f9y1glcalllists(n,type,lists)
   use f90gl_kinds
   integer(f90glsizei) n
   integer(f90glenum) type
   real(f90glfloat) lists(*)
   end subroutine
   subroutine f9y2glcalllists(n,type,lists)
   use f90gl_kinds
   integer(f90glsizei) n
   integer(f90glenum) type
   integer(f90glint) lists
   end subroutine
   subroutine f9y3glcalllists(n,type,lists)
   use f90gl_kinds
   integer(f90glsizei) n
   integer(f90glenum) type
   real(f90glfloat) lists
   end subroutine
   module procedure f9xglcalllists
end interface

interface f90gllistbase                  
   subroutine fgllistbase(base)
   use f90gl_kinds
   integer(f90gluint) base
   end subroutine
end interface

interface f90glbegin                     
   subroutine fglbegin(mode)
   use f90gl_kinds
   integer(f90glenum) mode
   end subroutine
end interface

interface f90glend                       
   subroutine fglend()
   use f90gl_kinds
   end subroutine
end interface

interface f90glvertex2d                  
   subroutine fglvertex2d(x,y)
   use f90gl_kinds
   real(f90gldouble) x, y
   end subroutine
end interface

interface f90glvertex2f                  
   subroutine fglvertex2f(x,y)
   use f90gl_kinds
   real(f90glfloat) x, y
   end subroutine
end interface

interface f90glvertex2i                  
   subroutine fglvertex2i(x,y)
   use f90gl_kinds
   integer(f90glint) x, y
   end subroutine
end interface

interface f90glvertex2s                  
   module procedure f9xglvertex2s
end interface

interface f90glvertex3d                  
   subroutine fglvertex3d(x,y,z)
   use f90gl_kinds
   real(f90gldouble) x, y, z
   end subroutine
end interface

interface f90glvertex3f                  
   subroutine fglvertex3f(x,y,z)
   use f90gl_kinds
   real(f90glfloat) x, y, z
   end subroutine
end interface

interface f90glvertex3i                  
   subroutine fglvertex3i(x,y,z)
   use f90gl_kinds
   integer(f90glint) x, y, z
   end subroutine
end interface

interface f90glvertex3s                  
   module procedure f9xglvertex3s
end interface

interface f90glvertex4d                  
   subroutine fglvertex4d(x,y,z,w)
   use f90gl_kinds
   real(f90gldouble) x, y, z, w
   end subroutine
end interface

interface f90glvertex4f                  
   subroutine fglvertex4f(x,y,z,w)
   use f90gl_kinds
   real(f90glfloat) x, y, z, w
   end subroutine
end interface

interface f90glvertex4i                  
   subroutine fglvertex4i(x,y,z,w)
   use f90gl_kinds
   integer(f90glint) x, y, z, w
   end subroutine
end interface

interface f90glvertex4s                  
   module procedure f9xglvertex4s
end interface

interface f90glvertex2dv                 
   subroutine fglvertex2dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glvertex2fv                 
   subroutine fglvertex2fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glvertex2iv                 
   subroutine fglvertex2iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glvertex2sv                 
   module procedure f9xglvertex2sv
end interface

interface f90glvertex3dv                 
   subroutine fglvertex3dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glvertex3fv                 
   subroutine fglvertex3fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glvertex3iv                 
   subroutine fglvertex3iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glvertex3sv                 
   module procedure f9xglvertex3sv
end interface

interface f90glvertex4dv                 
   subroutine fglvertex4dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glvertex4fv                 
   subroutine fglvertex4fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glvertex4iv                 
   subroutine fglvertex4iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glvertex4sv                 
   module procedure f9xglvertex4sv
end interface

interface f90glnormal3b                  
   module procedure f9xglnormal3b
end interface

interface f90glnormal3d                  
   subroutine fglnormal3d(nx,ny,nz)
   use f90gl_kinds
   real(f90gldouble) nx, ny, nz
   end subroutine
end interface

interface f90glnormal3f                  
   subroutine fglnormal3f(nx,ny,nz)
   use f90gl_kinds
   real(f90glfloat) nx, ny, nz
   end subroutine
end interface

interface f90glnormal3i                  
   subroutine fglnormal3i(nx,ny,nz)
   use f90gl_kinds
   integer(f90glint) nx, ny, nz
   end subroutine
end interface

interface f90glnormal3s                  
   module procedure f9xglnormal3s
end interface

interface f90glnormal3bv                 
   module procedure f9xglnormal3bv
end interface

interface f90glnormal3dv                 
   subroutine fglnormal3dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glnormal3fv                 
   subroutine fglnormal3fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glnormal3iv                 
   subroutine fglnormal3iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glnormal3sv                 
   module procedure f9xglnormal3sv
end interface

interface f90glindexd                    
   subroutine fglindexd(c)
   use f90gl_kinds
   real(f90gldouble) c
   end subroutine
end interface

interface f90glindexf                    
   subroutine fglindexf(c)
   use f90gl_kinds
   real(f90glfloat) c
   end subroutine
end interface

interface f90glindexi                    
   subroutine fglindexi(c)
   use f90gl_kinds
   integer(f90glint) c
   end subroutine
end interface

interface f90glindexs                    
   module procedure f9xglindexs
end interface

interface f90glindexdv                   
   subroutine fglindexdv(c)
   use f90gl_kinds
   real(f90gldouble) c(*)
   end subroutine
end interface

interface f90glindexfv                   
   subroutine fglindexfv(c)
   use f90gl_kinds
   real(f90glfloat) c(*)
   end subroutine
end interface

interface f90glindexiv                   
   subroutine fglindexiv(c)
   use f90gl_kinds
   integer(f90glint) c(*)
   end subroutine
end interface

interface f90glindexsv                   
   module procedure f9xglindexsv
end interface

interface f90glcolor3b                   
   module procedure f9xglcolor3b
end interface

interface f90glcolor3d                   
   subroutine fglcolor3d(red,green,blue)
   use f90gl_kinds
   real(f90gldouble) red, green, blue
   end subroutine
end interface

interface f90glcolor3f                   
   subroutine fglcolor3f(red,green,blue)
   use f90gl_kinds
   real(f90glfloat) red, green, blue
   end subroutine
end interface

interface f90glcolor3i                   
   subroutine fglcolor3i(red,green,blue)
   use f90gl_kinds
   integer(f90glint) red, green, blue
   end subroutine
end interface

interface f90glcolor3s                   
   module procedure f9xglcolor3s
end interface

interface f90glcolor3ub                  
   module procedure f9xglcolor3ub
end interface

interface f90glcolor3ui                  
   subroutine fglcolor3ui(red,green,blue)
   use f90gl_kinds
   integer(f90gluint) red, green, blue
   end subroutine
end interface

interface f90glcolor3us                  
   module procedure f9xglcolor3us
end interface

interface f90glcolor4b                   
   module procedure f9xglcolor4b
end interface

interface f90glcolor4d                   
   subroutine fglcolor4d(red,green,blue,alpha)
   use f90gl_kinds
   real(f90gldouble) red, green, blue, alpha
   end subroutine
end interface

interface f90glcolor4f                   
   subroutine fglcolor4f(red,green,blue,alpha)
   use f90gl_kinds
   real(f90glfloat) red, green, blue, alpha
   end subroutine
end interface

interface f90glcolor4i                   
   subroutine fglcolor4i(red,green,blue,alpha)
   use f90gl_kinds
   integer(f90glint) red, green, blue, alpha
   end subroutine
end interface

interface f90glcolor4s                   
   module procedure f9xglcolor4s
end interface

interface f90glcolor4ub                  
   module procedure f9xglcolor4ub
end interface

interface f90glcolor4ui                  
   subroutine fglcolor4ui(red,green,blue,alpha)
   use f90gl_kinds
   integer(f90gluint) red, green, blue, alpha
   end subroutine
end interface

interface f90glcolor4us                  
   module procedure f9xglcolor4us
end interface

interface f90glcolor3bv                  
   module procedure f9xglcolor3bv
end interface

interface f90glcolor3dv                  
   subroutine fglcolor3dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glcolor3fv                  
   subroutine fglcolor3fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glcolor3iv                  
   subroutine fglcolor3iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glcolor3sv                  
   module procedure f9xglcolor3sv
end interface

interface f90glcolor3ubv                 
   module procedure f9xglcolor3ubv
end interface

interface f90glcolor3uiv                 
   subroutine fglcolor3uiv(v)
   use f90gl_kinds
   integer(f90gluint) v(*)
   end subroutine
end interface

interface f90glcolor3usv                 
   module procedure f9xglcolor3usv
end interface

interface f90glcolor4bv                  
   module procedure f9xglcolor4bv
end interface

interface f90glcolor4dv                  
   subroutine fglcolor4dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glcolor4fv                  
   subroutine fglcolor4fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glcolor4iv                  
   subroutine fglcolor4iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glcolor4sv                  
   module procedure f9xglcolor4sv
end interface

interface f90glcolor4ubv                 
   module procedure f9xglcolor4ubv
end interface

interface f90glcolor4uiv                 
   subroutine fglcolor4uiv(v)
   use f90gl_kinds
   integer(f90gluint) v(*)
   end subroutine
end interface

interface f90glcolor4usv                 
   module procedure f9xglcolor4usv
end interface

interface f90gltexcoord1d                
   subroutine fgltexcoord1d(s)
   use f90gl_kinds
   real(f90gldouble) s
   end subroutine
end interface

interface f90gltexcoord1f                
   subroutine fgltexcoord1f(s)
   use f90gl_kinds
   real(f90glfloat) s
   end subroutine
end interface

interface f90gltexcoord1i                
   subroutine fgltexcoord1i(s)
   use f90gl_kinds
   integer(f90glint) s
   end subroutine
end interface

interface f90gltexcoord1s                
   module procedure f9xgltexcoord1s
end interface

interface f90gltexcoord2d                
   subroutine fgltexcoord2d(s,t)
   use f90gl_kinds
   real(f90gldouble) s, t
   end subroutine
end interface

interface f90gltexcoord2f                
   subroutine fgltexcoord2f(s,t)
   use f90gl_kinds
   real(f90glfloat) s, t
   end subroutine
end interface

interface f90gltexcoord2i                
   subroutine fgltexcoord2i(s,t)
   use f90gl_kinds
   integer(f90glint) s, t
   end subroutine
end interface

interface f90gltexcoord2s                
   module procedure f9xgltexcoord2s
end interface

interface f90gltexcoord3d                
   subroutine fgltexcoord3d(s,t,r)
   use f90gl_kinds
   real(f90gldouble) s, t, r
   end subroutine
end interface

interface f90gltexcoord3f                
   subroutine fgltexcoord3f(s,t,r)
   use f90gl_kinds
   real(f90glfloat) s, t, r
   end subroutine
end interface

interface f90gltexcoord3i                
   subroutine fgltexcoord3i(s,t,r)
   use f90gl_kinds
   integer(f90glint) s, t, r
   end subroutine
end interface

interface f90gltexcoord3s                
   module procedure f9xgltexcoord3s
end interface

interface f90gltexcoord4d                
   subroutine fgltexcoord4d(s,t,r,q)
   use f90gl_kinds
   real(f90gldouble) s, t, r, q
   end subroutine
end interface

interface f90gltexcoord4f                
   subroutine fgltexcoord4f(s,t,r,q)
   use f90gl_kinds
   real(f90glfloat) s, t, r, q
   end subroutine
end interface

interface f90gltexcoord4i                
   subroutine fgltexcoord4i(s,t,r,q)
   use f90gl_kinds
   integer(f90glint) s, t, r, q
   end subroutine
end interface

interface f90gltexcoord4s                
   module procedure f9xgltexcoord4s
end interface

interface f90gltexcoord1dv               
   subroutine fgltexcoord1dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90gltexcoord1fv               
   subroutine fgltexcoord1fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90gltexcoord1iv               
   subroutine fgltexcoord1iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90gltexcoord1sv               
   module procedure f9xgltexcoord1sv
end interface

interface f90gltexcoord2dv               
   subroutine fgltexcoord2dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90gltexcoord2fv               
   subroutine fgltexcoord2fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90gltexcoord2iv               
   subroutine fgltexcoord2iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90gltexcoord2sv               
   module procedure f9xgltexcoord2sv
end interface

interface f90gltexcoord3dv               
   subroutine fgltexcoord3dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90gltexcoord3fv               
   subroutine fgltexcoord3fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90gltexcoord3iv               
   subroutine fgltexcoord3iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90gltexcoord3sv               
   module procedure f9xgltexcoord3sv
end interface

interface f90gltexcoord4dv               
   subroutine fgltexcoord4dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90gltexcoord4fv               
   subroutine fgltexcoord4fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90gltexcoord4iv               
   subroutine fgltexcoord4iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90gltexcoord4sv               
   module procedure f9xgltexcoord4sv
end interface

interface f90glrasterpos2d               
   subroutine fglrasterpos2d(x,y)
   use f90gl_kinds
   real(f90gldouble) x, y
   end subroutine
end interface

interface f90glrasterpos2f               
   subroutine fglrasterpos2f(x,y)
   use f90gl_kinds
   real(f90glfloat) x, y
   end subroutine
end interface

interface f90glrasterpos2i               
   subroutine fglrasterpos2i(x,y)
   use f90gl_kinds
   integer(f90glint) x, y
   end subroutine
end interface

interface f90glrasterpos2s               
   module procedure f9xglrasterpos2s
end interface

interface f90glrasterpos3d               
   subroutine fglrasterpos3d(x,y,z)
   use f90gl_kinds
   real(f90gldouble) x, y, z
   end subroutine
end interface

interface f90glrasterpos3f               
   subroutine fglrasterpos3f(x,y,z)
   use f90gl_kinds
   real(f90glfloat) x, y, z
   end subroutine
end interface

interface f90glrasterpos3i               
   subroutine fglrasterpos3i(x,y,z)
   use f90gl_kinds
   integer(f90glint) x, y, z
   end subroutine
end interface

interface f90glrasterpos3s               
   module procedure f9xglrasterpos3s
end interface

interface f90glrasterpos4d               
   subroutine fglrasterpos4d(x,y,z,w)
   use f90gl_kinds
   real(f90gldouble) x, y, z, w
   end subroutine
end interface

interface f90glrasterpos4f               
   subroutine fglrasterpos4f(x,y,z,w)
   use f90gl_kinds
   real(f90glfloat) x, y, z, w
   end subroutine
end interface

interface f90glrasterpos4i               
   subroutine fglrasterpos4i(x,y,z,w)
   use f90gl_kinds
   integer(f90glint) x, y, z, w
   end subroutine
end interface

interface f90glrasterpos4s               
   module procedure f9xglrasterpos4s
end interface

interface f90glrasterpos2dv              
   subroutine fglrasterpos2dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glrasterpos2fv              
   subroutine fglrasterpos2fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glrasterpos2iv              
   subroutine fglrasterpos2iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glrasterpos2sv              
   module procedure f9xglrasterpos2sv
end interface

interface f90glrasterpos3dv              
   subroutine fglrasterpos3dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glrasterpos3fv              
   subroutine fglrasterpos3fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glrasterpos3iv              
   subroutine fglrasterpos3iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glrasterpos3sv              
   module procedure f9xglrasterpos3sv
end interface

interface f90glrasterpos4dv              
   subroutine fglrasterpos4dv(v)
   use f90gl_kinds
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glrasterpos4fv              
   subroutine fglrasterpos4fv(v)
   use f90gl_kinds
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glrasterpos4iv              
   subroutine fglrasterpos4iv(v)
   use f90gl_kinds
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glrasterpos4sv              
   module procedure f9xglrasterpos4sv
end interface

interface f90glrectd                     
   subroutine fglrectd(x1,y1,x2,y2)
   use f90gl_kinds
   real(f90gldouble) x1, y1, x2, y2
   end subroutine
end interface

interface f90glrectf                     
   subroutine fglrectf(x1,y1,x2,y2)
   use f90gl_kinds
   real(f90glfloat) x1, y1, x2, y2
   end subroutine
end interface

interface f90glrecti                     
   subroutine fglrecti(x1,y1,x2,y2)
   use f90gl_kinds
   integer(f90glint) x1, y1, x2, y2
   end subroutine
end interface

interface f90glrects                     
   module procedure f9xglrects
end interface

interface f90glrectdv                    
   subroutine fglrectdv(v1,v2)
   use f90gl_kinds
   real(f90gldouble) v1(*), v2(*)
   end subroutine
end interface

interface f90glrectfv                    
   subroutine fglrectfv(v1,v2)
   use f90gl_kinds
   real(f90glfloat) v1(*), v2(*)
   end subroutine
end interface

interface f90glrectiv                    
   subroutine fglrectiv(v1,v2)
   use f90gl_kinds
   integer(f90glint) v1(*), v2(*)
   end subroutine
end interface

interface f90glrectsv                    
   module procedure f9xglrectsv
end interface

interface f90glshademodel                
   subroutine fglshademodel(mode)
   use f90gl_kinds
   integer(f90glenum) mode
   end subroutine
end interface

interface f90gllightf                    
   subroutine fgllightf(light,pname,param)
   use f90gl_kinds
   integer(f90glenum) light, pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90gllighti                    
   subroutine fgllighti(light,pname,param)
   use f90gl_kinds
   integer(f90glenum) light, pname
   integer(f90glint) param
   end subroutine
end interface

interface f90gllightfv                   
   subroutine fgllightfv(light,pname,params)
   use f90gl_kinds
   integer(f90glenum) light, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90gllightiv                   
   subroutine fgllightiv(light,pname,params)
   use f90gl_kinds
   integer(f90glenum) light, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glgetlightfv                
   subroutine fglgetlightfv(light,pname,params)
   use f90gl_kinds
   integer(f90glenum) light, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glgetlightiv                
   subroutine fglgetlightiv(light,pname,params)
   use f90gl_kinds
   integer(f90glenum) light, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90gllightmodelf               
   subroutine fgllightmodelf(pname,param)
   use f90gl_kinds
   integer(f90glenum) pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90gllightmodeli               
   subroutine fgllightmodeli(pname,param)
   use f90gl_kinds
   integer(f90glenum) pname
   integer(f90glint) param
   end subroutine
end interface

interface f90gllightmodelfv              
   subroutine fgllightmodelfv(pname,params)
   use f90gl_kinds
   integer(f90glenum) pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90gllightmodeliv              
   subroutine fgllightmodeliv(pname,params)
   use f90gl_kinds
   integer(f90glenum) pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glmaterialf                 
   subroutine fglmaterialf(face,pname,param)
   use f90gl_kinds
   integer(f90glenum) face, pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90glmateriali                 
   subroutine fglmateriali(face,pname,param)
   use f90gl_kinds
   integer(f90glenum) face, pname
   integer(f90glint) param
   end subroutine
end interface

interface f90glmaterialfv                
   subroutine fglmaterialfv(face,pname,params)
   use f90gl_kinds
   integer(f90glenum) face, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glmaterialiv                
   subroutine fglmaterialiv(face,pname,params)
   use f90gl_kinds
   integer(f90glenum) face, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glgetmaterialfv             
   subroutine fglgetmaterialfv(face,pname,params)
   use f90gl_kinds
   integer(f90glenum) face, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glgetmaterialiv             
   subroutine fglgetmaterialiv(face,pname,params)
   use f90gl_kinds
   integer(f90glenum) face, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glcolormaterial             
   subroutine fglcolormaterial(face,mode)
   use f90gl_kinds
   integer(f90glenum) face, mode
   end subroutine
end interface

interface f90glpixelzoom                 
   subroutine fglpixelzoom(xfactor,yfactor)
   use f90gl_kinds
   real(f90glfloat) xfactor, yfactor
   end subroutine
end interface

interface f90glpixelstoref               
   subroutine fglpixelstoref(pname,param)
   use f90gl_kinds
   integer(f90glenum) pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90glpixelstorei               
   subroutine fglpixelstorei(pname,param)
   use f90gl_kinds
   integer(f90glenum) pname
   integer(f90glint) param
   end subroutine
end interface

interface f90glpixeltransferf            
   subroutine fglpixeltransferf(pname,param)
   use f90gl_kinds
   integer(f90glenum) pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90glpixeltransferi            
   subroutine fglpixeltransferi(pname,param)
   use f90gl_kinds
   integer(f90glenum) pname
   integer(f90glint) param
   end subroutine
end interface

interface f90glpixelmapfv                
   subroutine fglpixelmapfv(map,mapsize,values)
   use f90gl_kinds
   integer(f90glenum) map
   integer(f90glint) mapsize
   real(f90glfloat) values(*)
   end subroutine
end interface

interface f90glpixelmapuiv               
   subroutine fglpixelmapuiv(map,mapsize,values)
   use f90gl_kinds
   integer(f90glenum) map
   integer(f90glint) mapsize
   integer(f90gluint) values(*)
   end subroutine
end interface

interface f90glpixelmapusv               
   module procedure f9xglpixelmapusv
end interface

interface f90glgetpixelmapfv             
   subroutine fglgetpixelmapfv(map,values)
   use f90gl_kinds
   integer(f90glenum) map
   real(f90glfloat) values(*)
   end subroutine
end interface

interface f90glgetpixelmapuiv            
   subroutine fglgetpixelmapuiv(map,values)
   use f90gl_kinds
   integer(f90glenum) map
   integer(f90gluint) values(*)
   end subroutine
end interface

interface f90glgetpixelmapusv            
   module procedure f9xglgetpixelmapusv
end interface

interface f90glbitmap                    
   module procedure f9xglbitmap
end interface

interface f90glreadpixels                
   subroutine f9y0glreadpixels(x,y,width,height,format,type,pixels)
   use f90gl_kinds
   integer(f90glint) x, y
   integer(f90glsizei) width, height
   integer(f90glenum) format, type
   integer(f90glint) pixels(*)
   end subroutine
   subroutine f9y1glreadpixels(x,y,width,height,format,type,pixels)
   use f90gl_kinds
   integer(f90glint) x, y
   integer(f90glsizei) width, height
   integer(f90glenum) format, type
   real(f90glfloat) pixels(*)
   end subroutine
   subroutine f9y2glreadpixels(x,y,width,height,format,type,pixels)
   use f90gl_kinds
   integer(f90glint) x, y
   integer(f90glsizei) width, height
   integer(f90glenum) format, type
   integer(f90glint) pixels
   end subroutine
   subroutine f9y3glreadpixels(x,y,width,height,format,type,pixels)
   use f90gl_kinds
   integer(f90glint) x, y
   integer(f90glsizei) width, height
   integer(f90glenum) format, type
   real(f90glfloat) pixels
   end subroutine
   module procedure f9xglreadpixels
end interface

interface f90gldrawpixels                
   subroutine f9y0gldrawpixels(width,height,format,type,pixels)
   use f90gl_kinds
   integer(f90glsizei) width, height
   integer(f90glenum) format, type
   integer(f90glint) pixels(*)
   end subroutine
   subroutine f9y1gldrawpixels(width,height,format,type,pixels)
   use f90gl_kinds
   integer(f90glsizei) width, height
   integer(f90glenum) format, type
   real(f90glfloat) pixels(*)
   end subroutine
   subroutine f9y2gldrawpixels(width,height,format,type,pixels)
   use f90gl_kinds
   integer(f90glsizei) width, height
   integer(f90glenum) format, type
   integer(f90glint) pixels
   end subroutine
   subroutine f9y3gldrawpixels(width,height,format,type,pixels)
   use f90gl_kinds
   integer(f90glsizei) width, height
   integer(f90glenum) format, type
   real(f90glfloat) pixels
   end subroutine
   module procedure f9xgldrawpixels
end interface

interface f90glcopypixels                
   subroutine fglcopypixels(x,y,width,height,type)
   use f90gl_kinds
   integer(f90glint) x, y
   integer(f90glsizei) width, height
   integer(f90glenum) type
   end subroutine
end interface

interface f90glstencilfunc               
   subroutine fglstencilfunc(func,ref,mask)
   use f90gl_kinds
   integer(f90glenum) func
   integer(f90glint) ref
   integer(f90gluint) mask
   end subroutine
end interface

interface f90glstencilmask               
   subroutine fglstencilmask(mask)
   use f90gl_kinds
   integer(f90gluint) mask
   end subroutine
end interface

interface f90glstencilop                 
   subroutine fglstencilop(fail,zfail,zpass)
   use f90gl_kinds
   integer(f90glenum) fail, zfail, zpass
   end subroutine
end interface

interface f90glclearstencil              
   subroutine fglclearstencil(s)
   use f90gl_kinds
   integer(f90glint) s
   end subroutine
end interface

interface f90gltexgend                   
   subroutine fgltexgend(coord,pname,param)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   real(f90gldouble) param
   end subroutine
end interface

interface f90gltexgenf                   
   subroutine fgltexgenf(coord,pname,param)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90gltexgeni                   
   subroutine fgltexgeni(coord,pname,param)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   integer(f90glint) param
   end subroutine
end interface

interface f90gltexgendv                  
   subroutine fgltexgendv(coord,pname,params)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   real(f90gldouble) params(*)
   end subroutine
end interface

interface f90gltexgenfv                  
   subroutine fgltexgenfv(coord,pname,params)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90gltexgeniv                  
   subroutine fgltexgeniv(coord,pname,params)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glgettexgendv               
   subroutine fglgettexgendv(coord,pname,params)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   real(f90gldouble) params(*)
   end subroutine
end interface

interface f90glgettexgenfv               
   subroutine fglgettexgenfv(coord,pname,params)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glgettexgeniv               
   subroutine fglgettexgeniv(coord,pname,params)
   use f90gl_kinds
   integer(f90glenum) coord, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90gltexenvf                   
   subroutine fgltexenvf(target,pname,param)
   use f90gl_kinds
   integer(f90glenum) target, pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90gltexenvi                   
   subroutine fgltexenvi(target,pname,param)
   use f90gl_kinds
   integer(f90glenum) target, pname
   integer(f90glint) param
   end subroutine
end interface

interface f90gltexenvfv                  
   subroutine fgltexenvfv(target,pname,params)
   use f90gl_kinds
   integer(f90glenum) target, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90gltexenviv                  
   subroutine fgltexenviv(target,pname,params)
   use f90gl_kinds
   integer(f90glenum) target, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glgettexenvfv               
   subroutine fglgettexenvfv(target,pname,params)
   use f90gl_kinds
   integer(f90glenum) target, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glgettexenviv               
   subroutine fglgettexenviv(target,pname,params)
   use f90gl_kinds
   integer(f90glenum) target, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90gltexparameterf             
   subroutine fgltexparameterf(target,pname,param)
   use f90gl_kinds
   integer(f90glenum) target, pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90gltexparameteri             
   subroutine fgltexparameteri(target,pname,param)
   use f90gl_kinds
   integer(f90glenum) target, pname
   integer(f90glint) param
   end subroutine
end interface

interface f90gltexparameterfv            
   subroutine fgltexparameterfv(target,pname,params)
   use f90gl_kinds
   integer(f90glenum) target, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90gltexparameteriv            
   subroutine fgltexparameteriv(target,pname,params)
   use f90gl_kinds
   integer(f90glenum) target, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glgettexparameterfv         
   subroutine fglgettexparameterfv(target,pname,params)
   use f90gl_kinds
   integer(f90glenum) target, pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glgettexparameteriv         
   subroutine fglgettexparameteriv(target,pname,params)
   use f90gl_kinds
   integer(f90glenum) target, pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glgettexlevelparameterfv    
   subroutine fglgettexlevelparameterfv(target,level,pname,params)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level
   integer(f90glenum) pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glgettexlevelparameteriv    
   subroutine fglgettexlevelparameteriv(target,level,pname,params)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level
   integer(f90glenum) pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glteximage1d                
   subroutine f9y0glteximage1d(target,level,components,width,border,format,type, &
   pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level, components
   integer(f90glsizei) width
   integer(f90glint) border
   integer(f90glenum) format, type
   integer(f90glint) pixels(*)
   end subroutine
   subroutine f9y1glteximage1d(target,level,components,width,border,format, &
   type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level, components
   integer(f90glsizei) width
   integer(f90glint) border
   integer(f90glenum) format, type
   real(f90glfloat) pixels(*)
   end subroutine
   subroutine f9y2glteximage1d(target,level,components,width,border,format,type, &
   pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level, components
   integer(f90glsizei) width
   integer(f90glint) border
   integer(f90glenum) format, type
   integer(f90glint) pixels
   end subroutine
   subroutine f9y3glteximage1d(target,level,components,width,border,format, &
   type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level, components
   integer(f90glsizei) width
   integer(f90glint) border
   integer(f90glenum) format, type
   real(f90glfloat) pixels
   end subroutine
   module procedure f9xglteximage1d
end interface

interface f90glteximage2d                
   subroutine f9y0glteximage2d(target,level,components,width,height,border, &
   format,type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level, components
   integer(f90glsizei) width, height
   integer(f90glint) border
   integer(f90glenum) format, type
   integer(f90glint) pixels(*)
   end subroutine
   subroutine f9y1glteximage2d(target,level,components,width,height,border, &
   format,type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level, components
   integer(f90glsizei) width, height
   integer(f90glint) border
   integer(f90glenum) format, type
   real(f90glfloat) pixels(*)
   end subroutine
   subroutine f9y2glteximage2d(target,level,components,width,height,border, &
   format,type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level, components
   integer(f90glsizei) width, height
   integer(f90glint) border
   integer(f90glenum) format, type
   integer(f90glint) pixels
   end subroutine
   subroutine f9y3glteximage2d(target,level,components,width,height,border, &
   format,type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level, components
   integer(f90glsizei) width, height
   integer(f90glint) border
   integer(f90glenum) format, type
   real(f90glfloat) pixels
   end subroutine
   module procedure f9xglteximage2d
end interface

interface f90glgetteximage               
   subroutine f9y0glgetteximage(target,level,format,type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level
   integer(f90glenum) format, type
   integer(f90glint) pixels(*)
   end subroutine
   subroutine f9y1glgetteximage(target,level,format,type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level
   integer(f90glenum) format, type
   real(f90glfloat) pixels(*)
   end subroutine
   subroutine f9y2glgetteximage(target,level,format,type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level
   integer(f90glenum) format, type
   integer(f90glint) pixels
   end subroutine
   subroutine f9y3glgetteximage(target,level,format,type,pixels)
   use f90gl_kinds
   integer(f90glenum) target
   integer(f90glint) level
   integer(f90glenum) format, type
   real(f90glfloat) pixels
   end subroutine
   module procedure f9xglgetteximage
end interface

interface f90glmap1d                     
   subroutine fglmap1d(target,u1,u2,stride,order,points)
   use f90gl_kinds
   integer(f90glenum) target
   real(f90gldouble) u1, u2
   integer(f90glint) stride, order
   real(f90gldouble) points(*)
   end subroutine
end interface

interface f90glmap1f                     
   subroutine fglmap1f(target,u1,u2,stride,order,points)
   use f90gl_kinds
   integer(f90glenum) target
   real(f90glfloat) u1, u2
   integer(f90glint) stride, order
   real(f90glfloat) points(*)
   end subroutine
end interface

interface f90glmap2d                     
   subroutine fglmap2d(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder, &
   points)
   use f90gl_kinds
   integer(f90glenum) target
   real(f90gldouble) u1, u2
   integer(f90glint) ustride, uorder
   real(f90gldouble) v1, v2
   integer(f90glint) vstride, vorder
   real(f90gldouble) points(*)
   end subroutine
end interface

interface f90glmap2f                     
   subroutine fglmap2f(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder, &
   points)
   use f90gl_kinds
   integer(f90glenum) target
   real(f90glfloat) u1, u2
   integer(f90glint) ustride, uorder
   real(f90glfloat) v1, v2
   integer(f90glint) vstride, vorder
   real(f90glfloat) points(*)
   end subroutine
end interface

interface f90glgetmapdv                  
   subroutine fglgetmapdv(target,query,v)
   use f90gl_kinds
   integer(f90glenum) target, query
   real(f90gldouble) v(*)
   end subroutine
end interface

interface f90glgetmapfv                  
   subroutine fglgetmapfv(target,query,v)
   use f90gl_kinds
   integer(f90glenum) target, query
   real(f90glfloat) v(*)
   end subroutine
end interface

interface f90glgetmapiv                  
   subroutine fglgetmapiv(target,query,v)
   use f90gl_kinds
   integer(f90glenum) target, query
   integer(f90glint) v(*)
   end subroutine
end interface

interface f90glevalcoord1d               
   subroutine fglevalcoord1d(u)
   use f90gl_kinds
   real(f90gldouble) u
   end subroutine
end interface

interface f90glevalcoord1f               
   subroutine fglevalcoord1f(u)
   use f90gl_kinds
   real(f90glfloat) u
   end subroutine
end interface

interface f90glevalcoord1dv              
   subroutine fglevalcoord1dv(u)
   use f90gl_kinds
   real(f90gldouble) u(*)
   end subroutine
end interface

interface f90glevalcoord1fv              
   subroutine fglevalcoord1fv(u)
   use f90gl_kinds
   real(f90glfloat) u(*)
   end subroutine
end interface

interface f90glevalcoord2d               
   subroutine fglevalcoord2d(u,v)
   use f90gl_kinds
   real(f90gldouble) u, v
   end subroutine
end interface

interface f90glevalcoord2f               
   subroutine fglevalcoord2f(u,v)
   use f90gl_kinds
   real(f90glfloat) u, v
   end subroutine
end interface

interface f90glevalcoord2dv              
   subroutine fglevalcoord2dv(u)
   use f90gl_kinds
   real(f90gldouble) u(*)
   end subroutine
end interface

interface f90glevalcoord2fv              
   subroutine fglevalcoord2fv(u)
   use f90gl_kinds
   real(f90glfloat) u(*)
   end subroutine
end interface

interface f90glmapgrid1d                 
   subroutine fglmapgrid1d(un,u1,u2)
   use f90gl_kinds
   integer(f90glint) un
   real(f90gldouble) u1, u2
   end subroutine
end interface

interface f90glmapgrid1f                 
   subroutine fglmapgrid1f(un,u1,u2)
   use f90gl_kinds
   integer(f90glint) un
   real(f90glfloat) u1, u2
   end subroutine
end interface

interface f90glmapgrid2d                 
   subroutine fglmapgrid2d(un,u1,u2,vn,v1,v2)
   use f90gl_kinds
   integer(f90glint) un
   real(f90gldouble) u1, u2
   integer(f90glint) vn
   real(f90gldouble) v1, v2
   end subroutine
end interface

interface f90glmapgrid2f                 
   subroutine fglmapgrid2f(un,u1,u2,vn,v1,v2)
   use f90gl_kinds
   integer(f90glint) un
   real(f90glfloat) u1, u2
   integer(f90glint) vn
   real(f90glfloat) v1, v2
   end subroutine
end interface

interface f90glevalpoint1                
   subroutine fglevalpoint1(i)
   use f90gl_kinds
   integer(f90glint) i
   end subroutine
end interface

interface f90glevalpoint2                
   subroutine fglevalpoint2(i,j)
   use f90gl_kinds
   integer(f90glint) i, j
   end subroutine
end interface

interface f90glevalmesh1                 
   subroutine fglevalmesh1(mode,i1,i2)
   use f90gl_kinds
   integer(f90glenum) mode
   integer(f90glint) i1, i2
   end subroutine
end interface

interface f90glevalmesh2                 
   subroutine fglevalmesh2(mode,i1,i2,j1,j2)
   use f90gl_kinds
   integer(f90glenum) mode
   integer(f90glint) i1, i2, j1, j2
   end subroutine
end interface

interface f90glfogf                      
   subroutine fglfogf(pname,param)
   use f90gl_kinds
   integer(f90glenum) pname
   real(f90glfloat) param
   end subroutine
end interface

interface f90glfogi                      
   subroutine fglfogi(pname,param)
   use f90gl_kinds
   integer(f90glenum) pname
   integer(f90glint) param
   end subroutine
end interface

interface f90glfogfv                     
   subroutine fglfogfv(pname,params)
   use f90gl_kinds
   integer(f90glenum) pname
   real(f90glfloat) params(*)
   end subroutine
end interface

interface f90glfogiv                     
   subroutine fglfogiv(pname,params)
   use f90gl_kinds
   integer(f90glenum) pname
   integer(f90glint) params(*)
   end subroutine
end interface

interface f90glfeedbackbuffer            
   subroutine fglfeedbackbuffer(size,type,buffer)
   use f90gl_kinds
   integer(f90glsizei) size
   integer(f90glenum) type
   real(f90glfloat) buffer(*)
   end subroutine
end interface

interface f90glpassthrough               
   subroutine fglpassthrough(token)
   use f90gl_kinds
   real(f90glfloat) token
   end subroutine
end interface

interface f90glselectbuffer              
   subroutine fglselectbuffer(size,buffer)
   use f90gl_kinds
   integer(f90glsizei) size
   integer(f90gluint) buffer(*)
   end subroutine
end interface

interface f90glinitnames                 
   subroutine fglinitnames()
   use f90gl_kinds
   end subroutine
end interface

interface f90glloadname                  
   subroutine fglloadname(name)
   use f90gl_kinds
   integer(f90gluint) name
   end subroutine
end interface

interface f90glpushname                  
   subroutine fglpushname(name)
   use f90gl_kinds
   integer(f90gluint) name
   end subroutine
end interface

interface f90glpopname                   
   subroutine fglpopname()
   use f90gl_kinds
   end subroutine
end interface

interface f90glblendequationext          
   subroutine fglblendequationext(mode)
   use f90gl_kinds
   integer(f90glenum) mode
   end subroutine
end interface

interface f90glblendcolorext             
   subroutine fglblendcolorext(red,green,blue,alpha)
   use f90gl_kinds
   real(f90glclampf) red, green, blue, alpha
   end subroutine
end interface

!interface f90glpolygonoffsetext          
!   subroutine fglpolygonoffsetext(factor,bias)
!   use f90gl_kinds
!   real(f90glfloat) factor, bias
!   end subroutine
!end interface

interface f90glwindowpos2imesa
   subroutine fglwindowpos2imesa(x,y)
   use f90gl_kinds
   integer(f90glint) x, y
   end subroutine
end interface

interface f90glwindowpos2smesa
   module procedure f9xglwindowpos2smesa
end interface

interface f90glwindowpos2fmesa
   subroutine fglwindowpos2fmesa(x,y)
   use f90gl_kinds
   real(f90glfloat) x, y
   end subroutine
end interface

interface f90glwindowpos2dmesa
   subroutine fglwindowpos2dmesa(x,y)
   use f90gl_kinds
   real(f90gldouble) x, y
   end subroutine
end interface

interface f90glwindowpos2ivmesa
   subroutine fglwindowpos2ivmesa(p)
   use f90gl_kinds
   integer(f90glint) p(*)
   end subroutine
end interface

interface f90glwindowpos2svmesa
   module procedure f9xglwindowpos2svmesa
end interface

interface f90glwindowpos2fvmesa
   subroutine fglwindowpos2fvmesa(p)
   use f90gl_kinds
   real(f90glfloat) p(*)
   end subroutine
end interface

interface f90glwindowpos2dvmesa
   subroutine fglwindowpos2dvmesa(p)
   use f90gl_kinds
   real(f90gldouble) p(*)
   end subroutine
end interface

interface f90glwindowpos3imesa
   subroutine fglwindowpos3imesa(x,y,z)
   use f90gl_kinds
   integer(f90glint) x, y, z
   end subroutine
end interface

interface f90glwindowpos3smesa
   module procedure f9xglwindowpos3smesa
end interface

interface f90glwindowpos3fmesa
   subroutine fglwindowpos3fmesa(x,y,z)
   use f90gl_kinds
   real(f90glfloat) x, y, z
   end subroutine
end interface

interface f90glwindowpos3dmesa
   subroutine fglwindowpos3dmesa(x,y,z)
   use f90gl_kinds
   real(f90gldouble) x, y, z
   end subroutine
end interface

interface f90glwindowpos3ivmesa
   subroutine fglwindowpos3ivmesa(p)
   use f90gl_kinds
   integer(f90glint) p(*)
   end subroutine
end interface

interface f90glwindowpos3svmesa
   module procedure f9xglwindowpos3svmesa
end interface

interface f90glwindowpos3fvmesa
   subroutine fglwindowpos3fvmesa(p)
   use f90gl_kinds
   real(f90glfloat) p(*)
   end subroutine
end interface

interface f90glwindowpos3dvmesa
   subroutine fglwindowpos3dvmesa(p)
   use f90gl_kinds
   real(f90gldouble) p(*)
   end subroutine
end interface

interface f90glwindowpos4imesa
   subroutine fglwindowpos4imesa(x,y,z,w)
   use f90gl_kinds
   integer(f90glint) x, y, z, w
   end subroutine
end interface

interface f90glwindowpos4smesa
   module procedure f9xglwindowpos4smesa
end interface

interface f90glwindowpos4fmesa
   subroutine fglwindowpos4fmesa(x,y,z,w)
   use f90gl_kinds
   real(f90glfloat) x, y, z, w
   end subroutine
end interface

interface f90glwindowpos4dmesa
   subroutine fglwindowpos4dmesa(x,y,z,w)
   use f90gl_kinds
   real(f90gldouble) x, y, z, w
   end subroutine
end interface

interface f90glwindowpos4ivmesa
   subroutine fglwindowpos4ivmesa(p)
   use f90gl_kinds
   integer(f90glint) p(*)
   end subroutine
end interface

interface f90glwindowpos4svmesa
   module procedure f9xglwindowpos4svmesa
end interface

interface f90glwindowpos4fvmesa
   subroutine fglwindowpos4fvmesa(p)
   use f90gl_kinds
   real(f90glfloat) p(*)
   end subroutine
end interface

interface f90glwindowpos4dvmesa
   subroutine fglwindowpos4dvmesa(p)
   use f90gl_kinds
   real(f90gldouble) p(*)
   end subroutine
end interface

contains

! fortran 90 wrappers for procedures that might have the wrong KIND of argument

subroutine f9xglcolormask(red,green,blue,alpha)
logical(f90glboolean) red, green, blue, alpha
integer(f90glint) int_red, int_green, int_blue, int_alpha
if (f90glone_byte_logical) then
   call fglcolormask(red,green,blue,alpha)
else
   if (red) then; int_red = 1; else; int_red = 0; endif
   if (green) then; int_green = 1; else; int_green = 0; endif
   if (blue) then; int_blue = 1; else; int_blue = 0; endif
   if (alpha) then; int_alpha = 1; else; int_alpha = 0; endif
   call f9eglcolormask(int_red,int_green,int_blue,int_alpha)
endif
end subroutine f9xglcolormask

subroutine f9xgllinestipple(factor,pattern)
integer(f90glint) factor
integer(f90glushort) pattern
if (f90glshort_is_int) then
   call f9agllinestipple(factor,pattern)
else
   call fgllinestipple(factor,pattern)
endif
end subroutine f9xgllinestipple

subroutine f9xglpolygonstipple(mask)
integer(f90glubyte) mask(*)
if (f90glbyte_is_int) then
   call f9bglpolygonstipple(mask)
elseif (f90glbyte_is_short) then
   call f9cglpolygonstipple(mask)
else
   call fglpolygonstipple(mask)
endif
end subroutine f9xglpolygonstipple

subroutine f9xglgetpolygonstipple(mask)
integer(f90glubyte) mask(*)
if (f90glbyte_is_int) then
   call f9bglgetpolygonstipple(mask)
elseif (f90glbyte_is_short) then
   call f9cglgetpolygonstipple(mask)
else
   call fglgetpolygonstipple(mask)
endif
end subroutine f9xglgetpolygonstipple

subroutine f9xgledgeflag(flag)
logical(f90glboolean) flag
integer(f90glint) int_flag
if (f90glone_byte_logical) then
   call fgledgeflag(flag)
else
   if (flag) then; int_flag = 1; else; int_flag = 0; endif
   call f9egledgeflag(int_flag)
endif
end subroutine f9xgledgeflag

subroutine f9xgledgeflagv(flag)
logical(f90glboolean) flag(*)
integer(f90glint) int_flag(1)
if (f90glone_byte_logical) then
   call fgledgeflagv(flag)
else
   if (flag(1)) then; int_flag(1) = 1; else; int_flag(1) = 0; endif
   call f9egledgeflagv(int_flag)
endif
end subroutine f9xgledgeflagv

function f9xglisenabled(cap)
logical(f90glboolean) f9xglisenabled
integer(f90glenum) cap
logical(f90glboolean), external :: fglisenabled
integer(f90glint) temp
if (f90glone_byte_logical) then
   f9xglisenabled = fglisenabled(cap)
else
   temp = f9eglisenabled(cap)
   if (temp==0) then
      f9xglisenabled = .false.
   else
      f9xglisenabled = .true.
   endif
endif
end function f9xglisenabled

subroutine f9xglgetbooleanv(pname,params)
integer(f90glenum) pname
logical(f90glboolean) params(*)
integer(f90glint) int_params(1)
if (f90glone_byte_logical) then
   call fglgetbooleanv(pname,params)
else
   call f9eglgetbooleanv(pname,int_params)
   params(1) = (int_params(1)/=0)
endif
end subroutine f9xglgetbooleanv

function f9xglgetstring(name)
character(len=256) f9xglgetstring
integer(f90glenum) name
integer(f90gluint) temp(256)
integer(f90glint) length
integer i
call f9yglgetstring(temp,length,name)
f9xglgetstring = ''
do i=1,length
   f9xglgetstring(i:i) = char(temp(i))
end do
end function f9xglgetstring

subroutine f9xgldepthmask(flag)
logical(f90glboolean) flag
integer(f90glint) int_flag
if (f90glone_byte_logical) then
   call fgldepthmask(flag)
else
   if (flag) then; int_flag = 1; else; int_flag = 0; endif
   call f9egldepthmask(int_flag)
endif
end subroutine f9xgldepthmask

function f9xglislist(list)
logical(f90glboolean) f9xglislist
integer(f90gluint) list
logical(f90glboolean), external :: fglislist
integer(f90glint) temp
if (f90glone_byte_logical) then
   f9xglislist = fglislist(list)
else
   temp = f9eglislist(list)
   if (temp==0) then
      f9xglislist = .false.
   else
      f9xglislist = .true.
   endif
endif
end function f9xglislist

subroutine f9xglcalllists(n,type,lists)
integer(f90glsizei) n
integer(f90glenum) type
character(f90glcptr) lists
integer(f90gluint) temp(f90glcptr)
integer i
do i=1,f90glcptr
   temp(i) = ichar(lists(i:i))
end do
call f9y4glcalllists(n,type,temp,f90glcptr)
end subroutine f9xglcalllists

subroutine f90glcalllistsbyte(n,type,lists)
integer(f90glsizei) n
integer(f90glenum) type
integer(f90glbyte) lists(*)
call f9y5glcalllists(n,type,lists)
end subroutine f90glcalllistsbyte

subroutine f90glcalllistsshort(n,type,lists)
integer(f90glsizei) n
integer(f90glenum) type
integer(f90glshort) lists(*)
call f9y6glcalllists(n,type,lists)
end subroutine f90glcalllistsshort

subroutine f9xglvertex2s(x,y)
integer(f90glshort) x, y
if (f90glshort_is_int) then
   call f9aglvertex2s(x,y)
else
   call fglvertex2s(x,y)
endif
end subroutine f9xglvertex2s

subroutine f9xglvertex3s(x,y,z)
integer(f90glshort) x, y, z
if (f90glshort_is_int) then
   call f9aglvertex3s(x,y,z)
else
   call fglvertex3s(x,y,z)
endif
end subroutine f9xglvertex3s

subroutine f9xglvertex4s(x,y,z,w)
integer(f90glshort) x, y, z, w
if (f90glshort_is_int) then
   call f9aglvertex4s(x,y,z,w)
else
   call fglvertex4s(x,y,z,w)
endif
end subroutine f9xglvertex4s

subroutine f9xglvertex2sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglvertex2sv(v)
else
   call fglvertex2sv(v)
endif
end subroutine f9xglvertex2sv

subroutine f9xglvertex3sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglvertex3sv(v)
else
   call fglvertex3sv(v)
endif
end subroutine f9xglvertex3sv

subroutine f9xglvertex4sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglvertex4sv(v)
else
   call fglvertex4sv(v)
endif
end subroutine f9xglvertex4sv

subroutine f9xglnormal3b(nx,ny,nz)
integer(f90glbyte) nx, ny, nz
if (f90glbyte_is_int) then
   call f9bglnormal3b(nx,ny,nz)
elseif (f90glbyte_is_short) then
   call f9cglnormal3b(nx,ny,nz)
else
   call fglnormal3b(nx,ny,nz)
endif
end subroutine f9xglnormal3b

subroutine f9xglnormal3s(nx,ny,nz)
integer(f90glshort) nx, ny, nz
if (f90glshort_is_int) then
   call f9aglnormal3s(nx,ny,nz)
else
   call fglnormal3s(nx,ny,nz)
endif
end subroutine f9xglnormal3s

subroutine f9xglnormal3bv(v)
integer(f90glbyte) v(*)
if (f90glbyte_is_int) then
   call f9bglnormal3bv(v)
elseif (f90glbyte_is_short) then
   call f9cglnormal3bv(v)
else
   call fglnormal3bv(v)
endif
end subroutine f9xglnormal3bv

subroutine f9xglnormal3sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglnormal3sv(v)
else
   call fglnormal3sv(v)
endif
end subroutine f9xglnormal3sv

subroutine f9xglindexs(c)
integer(f90glshort) c
if (f90glshort_is_int) then
   call f9aglindexs(c)
else
   call fglindexs(c)
endif
end subroutine f9xglindexs

subroutine f9xglindexsv(c)
integer(f90glshort) c(*)
if (f90glshort_is_int) then
   call f9aglindexsv(c)
else
   call fglindexsv(c)
endif
end subroutine f9xglindexsv

subroutine f9xglcolor3b(red,green,blue)
integer(f90glbyte) red, green, blue
if (f90glbyte_is_int) then
   call f9bglcolor3b(red,green,blue)
elseif (f90glbyte_is_short) then
   call f9cglcolor3b(red,green,blue)
else
   call fglcolor3b(red,green,blue)
endif
end subroutine f9xglcolor3b

subroutine f9xglcolor3s(red,green,blue)
integer(f90glshort) red, green, blue
if (f90glshort_is_int) then
   call f9aglcolor3s(red,green,blue)
else
   call fglcolor3s(red,green,blue)
endif
end subroutine f9xglcolor3s

subroutine f9xglcolor3ub(red,green,blue)
integer(f90glubyte) red, green, blue
if (f90glbyte_is_int) then
   call f9bglcolor3ub(red,green,blue)
elseif (f90glbyte_is_short) then
   call f9cglcolor3ub(red,green,blue)
else
   call fglcolor3ub(red,green,blue)
endif
end subroutine f9xglcolor3ub

subroutine f9xglcolor3us(red,green,blue)
integer(f90glushort) red, green, blue
if (f90glshort_is_int) then
   call f9aglcolor3us(red,green,blue)
else
   call fglcolor3us(red,green,blue)
endif
end subroutine f9xglcolor3us

subroutine f9xglcolor4b(red,green,blue,alpha)
integer(f90glbyte) red, green, blue, alpha
if (f90glbyte_is_int) then
   call f9bglcolor4b(red,green,blue,alpha)
elseif (f90glbyte_is_short) then
   call f9cglcolor4b(red,green,blue,alpha)
else
   call fglcolor4b(red,green,blue,alpha)
endif
end subroutine f9xglcolor4b

subroutine f9xglcolor4s(red,green,blue,alpha)
integer(f90glshort) red, green, blue, alpha
if (f90glshort_is_int) then
   call f9aglcolor4s(red,green,blue,alpha)
else
   call fglcolor4s(red,green,blue,alpha)
endif
end subroutine f9xglcolor4s

subroutine f9xglcolor4ub(red,green,blue,alpha)
integer(f90glubyte) red, green, blue, alpha
if (f90glbyte_is_int) then
   call f9bglcolor4ub(red,green,blue,alpha)
elseif (f90glbyte_is_short) then
   call f9cglcolor4ub(red,green,blue,alpha)
else
   call fglcolor4ub(red,green,blue,alpha)
endif
end subroutine f9xglcolor4ub

subroutine f9xglcolor4us(red,green,blue,alpha)
integer(f90glushort) red, green, blue, alpha
if (f90glshort_is_int) then
   call f9aglcolor4us(red,green,blue,alpha)
else
   call fglcolor4us(red,green,blue,alpha)
endif
end subroutine f9xglcolor4us

subroutine f9xglcolor3bv(v)
integer(f90glbyte) v(*)
if (f90glbyte_is_int) then
   call f9bglcolor3bv(v)
elseif (f90glbyte_is_short) then
   call f9cglcolor3bv(v)
else
   call fglcolor3bv(v)
endif
end subroutine f9xglcolor3bv

subroutine f9xglcolor3sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglcolor3sv(v)
else
   call fglcolor3sv(v)
endif
end subroutine f9xglcolor3sv

subroutine f9xglcolor3ubv(v)
integer(f90glubyte) v(*)
if (f90glbyte_is_int) then
   call f9bglcolor3ubv(v)
elseif (f90glbyte_is_short) then
   call f9cglcolor3ubv(v)
else
   call fglcolor3ubv(v)
endif
end subroutine f9xglcolor3ubv

subroutine f9xglcolor3usv(v)
integer(f90glushort) v(*)
if (f90glshort_is_int) then
   call f9aglcolor3usv(v)
else
   call fglcolor3usv(v)
endif
end subroutine f9xglcolor3usv

subroutine f9xglcolor4bv(v)
integer(f90glbyte) v(*)
if (f90glbyte_is_int) then
   call f9bglcolor4bv(v)
elseif (f90glbyte_is_short) then
   call f9cglcolor4bv(v)
else
   call fglcolor4bv(v)
endif
end subroutine f9xglcolor4bv

subroutine f9xglcolor4sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglcolor4sv(v)
else
   call fglcolor4sv(v)
endif
end subroutine f9xglcolor4sv

subroutine f9xglcolor4ubv(v)
integer(f90glubyte) v(*)
if (f90glbyte_is_int) then
   call f9bglcolor4ubv(v)
elseif (f90glbyte_is_short) then
   call f9cglcolor4ubv(v)
else
   call fglcolor4ubv(v)
endif
end subroutine f9xglcolor4ubv

subroutine f9xglcolor4usv(v)
integer(f90glushort) v(*)
if (f90glshort_is_int) then
   call f9aglcolor4usv(v)
else
   call fglcolor4usv(v)
endif
end subroutine f9xglcolor4usv

subroutine f9xgltexcoord1s(s)
integer(f90glshort) s
if (f90glshort_is_int) then
   call f9agltexcoord1s(s)
else
   call fgltexcoord1s(s)
endif
end subroutine f9xgltexcoord1s

subroutine f9xgltexcoord2s(s,t)
integer(f90glshort) s, t
if (f90glshort_is_int) then
   call f9agltexcoord2s(s,t)
else
   call fgltexcoord2s(s,t)
endif
end subroutine f9xgltexcoord2s

subroutine f9xgltexcoord3s(s,t,r)
integer(f90glshort) s, t, r
if (f90glshort_is_int) then
   call f9agltexcoord3s(s,t,r)
else
   call fgltexcoord3s(s,t,r)
endif
end subroutine f9xgltexcoord3s

subroutine f9xgltexcoord4s(s,t,r,q)
integer(f90glshort) s, t, r, q
if (f90glshort_is_int) then
   call f9agltexcoord4s(s,t,r,q)
else
   call fgltexcoord4s(s,t,r,q)
endif
end subroutine f9xgltexcoord4s

subroutine f9xgltexcoord1sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9agltexcoord1sv(v)
else
   call fgltexcoord1sv(v)
endif
end subroutine f9xgltexcoord1sv

subroutine f9xgltexcoord2sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9agltexcoord2sv(v)
else
   call fgltexcoord2sv(v)
endif
end subroutine f9xgltexcoord2sv

subroutine f9xgltexcoord3sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9agltexcoord3sv(v)
else
   call fgltexcoord3sv(v)
endif
end subroutine f9xgltexcoord3sv

subroutine f9xgltexcoord4sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9agltexcoord4sv(v)
else
   call fgltexcoord4sv(v)
endif
end subroutine f9xgltexcoord4sv

subroutine f9xglrasterpos2s(x,y)
integer(f90glshort) x, y
if (f90glshort_is_int) then
   call f9aglrasterpos2s(x,y)
else
   call fglrasterpos2s(x,y)
endif
end subroutine f9xglrasterpos2s

subroutine f9xglrasterpos3s(x,y,z)
integer(f90glshort) x, y, z
if (f90glshort_is_int) then
   call f9aglrasterpos3s(x,y,z)
else
   call fglrasterpos3s(x,y,z)
endif
end subroutine f9xglrasterpos3s

subroutine f9xglrasterpos4s(x,y,z,w)
integer(f90glshort) x, y, z, w
if (f90glshort_is_int) then
   call f9aglrasterpos4s(x,y,z,w)
else
   call fglrasterpos4s(x,y,z,w)
endif
end subroutine f9xglrasterpos4s

subroutine f9xglrasterpos2sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglrasterpos2sv(v)
else
   call fglrasterpos2sv(v)
endif
end subroutine f9xglrasterpos2sv

subroutine f9xglrasterpos3sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglrasterpos3sv(v)
else
   call fglrasterpos3sv(v)
endif
end subroutine f9xglrasterpos3sv

subroutine f9xglrasterpos4sv(v)
integer(f90glshort) v(*)
if (f90glshort_is_int) then
   call f9aglrasterpos4sv(v)
else
   call fglrasterpos4sv(v)
endif
end subroutine f9xglrasterpos4sv

subroutine f9xglrects(x1,y1,x2,y2)
integer(f90glshort) x1, y1, x2, y2
if (f90glshort_is_int) then
   call f9aglrects(x1,y1,x2,y2)
else
   call fglrects(x1,y1,x2,y2)
endif
end subroutine f9xglrects

subroutine f9xglrectsv(v1,v2)
integer(f90glshort) v1(*), v2(*)
if (f90glshort_is_int) then
   call f9aglrectsv(v1,v2)
else
   call fglrectsv(v1,v2)
endif
end subroutine f9xglrectsv

subroutine f9xglpixelmapusv(map,mapsize,values)
integer(f90glenum) map
integer(f90glint) mapsize
integer(f90glushort) values(*)
if (f90glshort_is_int) then
   call f9aglpixelmapusv(map,mapsize,values)
else
   call fglpixelmapusv(map,mapsize,values)
endif
end subroutine f9xglpixelmapusv

subroutine f9xglgetpixelmapusv(map,values)
integer(f90glenum) map
integer(f90glushort) values(*)
if (f90glshort_is_int) then
   call f9aglgetpixelmapusv(map,values)
else
   call fglgetpixelmapusv(map,values)
endif
end subroutine f9xglgetpixelmapusv

subroutine f9xglbitmap(width,height,xorig,yorig,xmove,ymove,bitmap)
integer(f90glsizei) width, height
real(f90glfloat) xorig, yorig, xmove, ymove
integer(f90glubyte) bitmap(*)
if (f90glbyte_is_int) then
   call f9bglbitmap(width,height,xorig,yorig,xmove,ymove,bitmap)
elseif (f90glbyte_is_short) then
   call f9cglbitmap(width,height,xorig,yorig,xmove,ymove,bitmap)
else
   call fglbitmap(width,height,xorig,yorig,xmove,ymove,bitmap)
endif
end subroutine f9xglbitmap

subroutine f9xglreadpixels(x,y,width,height,format,type,pixels)
integer(f90glint) x, y
integer(f90glsizei) width, height
integer(f90glenum) format, type
character(f90glcptr) pixels
integer(f90gluint) temp(f90glcptr) 
integer i 
do i=1,f90glcptr 
   temp(i) = ichar(pixels(i:i)) 
end do
call f9y4glreadpixels(x,y,width,height,format,type,temp,f90glcptr)
end subroutine f9xglreadpixels

subroutine f90glreadpixelsbyte(x,y,width,height,format,type,pixels)
integer(f90glint) x, y
integer(f90glsizei) width, height
integer(f90glenum) format, type
integer(f90glbyte) pixels(*)
call f9y5glreadpixels(x,y,width,height,format,type,pixels)
end subroutine f90glreadpixelsbyte

subroutine f90glreadpixelsshort(x,y,width,height,format,type,pixels)
integer(f90glint) x, y
integer(f90glsizei) width, height
integer(f90glenum) format, type
integer(f90glshort) pixels(*)
call f9y6glreadpixels(x,y,width,height,format,type,pixels)
end subroutine f90glreadpixelsshort

subroutine f9xgldrawpixels(width,height,format,type,pixels)
integer(f90glsizei) width, height
integer(f90glenum) format, type
character(f90glcptr) pixels
integer(f90gluint) temp(f90glcptr) 
integer i 
do i=1,f90glcptr 
   temp(i) = ichar(pixels(i:i)) 
end do
call f9y4gldrawpixels(width,height,format,type,temp,f90glcptr)
end subroutine f9xgldrawpixels

subroutine f90gldrawpixelsbyte(width,height,format,type,pixels)
integer(f90glsizei) width, height
integer(f90glenum) format, type
integer(f90glbyte) pixels(*)
call f9y5gldrawpixels(width,height,format,type,pixels)
end subroutine f90gldrawpixelsbyte

subroutine f90gldrawpixelsshort(width,height,format,type,pixels)
integer(f90glsizei) width, height
integer(f90glenum) format, type
integer(f90glshort) pixels(*)
call f9y6gldrawpixels(width,height,format,type,pixels)
end subroutine f90gldrawpixelsshort

subroutine f9xglteximage1d(target,level,components,width,border,format, &
   type,pixels)
integer(f90glenum) target
integer(f90glint) level, components
integer(f90glsizei) width
integer(f90glint) border
integer(f90glenum) format, type
character(f90glcptr) pixels
integer(f90gluint) temp(f90glcptr) 
integer i 
do i=1,f90glcptr 
   temp(i) = ichar(pixels(i:i))
end do
call f9y4glteximage1d(target,level,components,width,border,format, &
   type,temp,f90glcptr)
end subroutine f9xglteximage1d

subroutine f90glteximage1dbyte(target,level,components,width,border,format, &
   type,pixels)
integer(f90glenum) target
integer(f90glint) level, components
integer(f90glsizei) width
integer(f90glint) border
integer(f90glenum) format, type
integer(f90glbyte) pixels(*)
call f9y5glteximage1d(target,level,components,width,border,format, &
   type,pixels)
end subroutine f90glteximage1dbyte

subroutine f90glteximage1dshort(target,level,components,width,border,format, &
   type,pixels)
integer(f90glenum) target
integer(f90glint) level, components
integer(f90glsizei) width
integer(f90glint) border
integer(f90glenum) format, type
integer(f90glshort) pixels(*)
call f9y6glteximage1d(target,level,components,width,border,format, &
   type,pixels)
end subroutine f90glteximage1dshort

subroutine f9xglteximage2d(target,level,components,width,height,border, &
   format,type,pixels)
integer(f90glenum) target
integer(f90glint) level, components
integer(f90glsizei) width, height
integer(f90glint) border
integer(f90glenum) format, type
character(f90glcptr) pixels
integer(f90gluint) temp(f90glcptr) 
integer i 
do i=1,f90glcptr 
   temp(i) = ichar(pixels(i:i))
end do
call f9y4glteximage2d(target,level,components,width,height,border, &
   format,type,temp,f90glcptr)
end subroutine f9xglteximage2d

subroutine f90glteximage2dbyte(target,level,components,width,height,border, &
   format,type,pixels)
integer(f90glenum) target
integer(f90glint) level, components
integer(f90glsizei) width, height
integer(f90glint) border
integer(f90glenum) format, type
integer(f90glbyte) pixels(*)
call f9y5glteximage2d(target,level,components,width,height,border, &
   format,type,pixels)
end subroutine f90glteximage2dbyte

subroutine f90glteximage2dshort(target,level,components,width,height,border, &
   format,type,pixels)
integer(f90glenum) target
integer(f90glint) level, components
integer(f90glsizei) width, height
integer(f90glint) border
integer(f90glenum) format, type
integer(f90glshort) pixels(*)
call f9y6glteximage2d(target,level,components,width,height,border, &
   format,type,pixels)
end subroutine f90glteximage2dshort

subroutine f9xglgetteximage(target,level,format,type,pixels)
integer(f90glenum) target
integer(f90glint) level
integer(f90glenum) format, type
character(f90glcptr) pixels
integer(f90gluint) temp(f90glcptr) 
integer i 
do i=1,f90glcptr 
   temp(i) = ichar(pixels(i:i))
end do 
call f9y4glgetteximage(target,level,format,type,temp,f90glcptr)
end subroutine f9xglgetteximage

subroutine f90glgetteximagebyte(target,level,format,type,pixels)
integer(f90glenum) target
integer(f90glint) level
integer(f90glenum) format, type
integer(f90glbyte) pixels(*)
call f9y5glgetteximage(target,level,format,type,pixels)
end subroutine f90glgetteximagebyte

subroutine f90glgetteximageshort(target,level,format,type,pixels)
integer(f90glenum) target
integer(f90glint) level
integer(f90glenum) format, type
integer(f90glshort) pixels(*)
call f9y6glgetteximage(target,level,format,type,pixels)
end subroutine f90glgetteximageshort

subroutine f9xglwindowpos2smesa(x,y)
integer(f90glshort) x, y
if (f90glshort_is_int) then
   call f9aglwindowpos2smesa(x,y)
else
   call fglwindowpos2smesa(x,y)
endif
end subroutine f9xglwindowpos2smesa

subroutine f9xglwindowpos2svmesa(p)
integer(f90glshort) p(*)
if (f90glshort_is_int) then
   call f9aglwindowpos2svmesa(p)
else
   call fglwindowpos2svmesa(p)
endif
end subroutine f9xglwindowpos2svmesa

subroutine f9xglwindowpos3smesa(x,y,z)
integer(f90glshort) x, y, z
if (f90glshort_is_int) then
   call f9aglwindowpos3smesa(x,y,z)
else
   call fglwindowpos3smesa(x,y,z)
endif
end subroutine f9xglwindowpos3smesa

subroutine f9xglwindowpos3svmesa(p)
integer(f90glshort) p(*)
if (f90glshort_is_int) then
   call f9aglwindowpos3svmesa(p)
else
   call fglwindowpos3svmesa(p)
endif
end subroutine f9xglwindowpos3svmesa

subroutine f9xglwindowpos4smesa(x,y,z,w)
integer(f90glshort) x, y, z, w
if (f90glshort_is_int) then
   call f9aglwindowpos4smesa(x,y,z,w)
else
   call fglwindowpos4smesa(x,y,z,w)
endif
end subroutine f9xglwindowpos4smesa

subroutine f9xglwindowpos4svmesa(p)
integer(f90glshort) p(*)
if (f90glshort_is_int) then
   call f9aglwindowpos4svmesa(p)
else
   call fglwindowpos4svmesa(p)
endif
end subroutine f9xglwindowpos4svmesa

end module f90gl
