/*-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------*/

#ifdef FBIND


#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>

/* equalence of types

 OpenGL          description              C     extended fortan 77

GLboolean   8-bit unsigned integer  unsigned char  logical*1
GLbyte      8-bit integer           signed char    integer*1
GLubyte     8-bit unsigned integer  unsigned char  integer*1
GLshort    16-bit integer           short          integer*2
GLushort   16-bit unsigned integer  unsigned short integer*2
GLint      32-bit integer           long           integer*4
GLuint     32-bit unsigned integer  unsigned long  integer*4
GLenum     32-bit unsigned integer  unsigned long  integer*4
GLbitfield 32-bit unsigned integer  unsigned long  integer*4
GLsizei    32-bit integer           long           integer*4
GLfloat    32-bit floating point    float          real*4
GLclampf   32-bit floating point    float          real*4
GLdouble   64-bit floating point    double         real*8
GLclampd   64-bit floating point    double         real*8
GLvoid     generic pointer GLvoid*  void           any array


   f90gl            fortran 90

f90glboolean    logical(kind=k) where k gives a 1 byte logical, if possible
f90glbyte       selected_int_kind(2)
f90glubyte      selected_int_kind(2)
f90glshort      selected_int_kind(4)
f90glushort     selected_int_kind(4)
f90glint        selected_int_kind(9)
f90gluint       selected_int_kind(9)
f90glenum       selected_int_kind(9)
f90glbitfield   selected_int_kind(9)
f90glsizei      selected_int_kind(9)
f90glfloat      selected_real_kind(6)
f90glclampf     selected_real_kind(6)
f90gldouble     selected_real_kind(15)
f90glclampd     selected_real_kind(15)
f90glvoid       any array

*/

/*
 * Mapping of Fortran types to C types:
 */

#define f90glboolean  unsigned char *
#define f90glbyte     signed char *
#define f90glubyte    unsigned char *
#define f90glshort    short *
#define f90glushort   unsigned short *
#define f90glint      long *
#define f90gluint     unsigned long *
#define f90glenum     unsigned long *
#define f90glbitfield unsigned long *
#define f90glsizei    long *
#define f90glfloat    float *
#define f90glclampf   float *
#define f90gldouble   double *
#define f90glclampd   double *
#define f90glvoid     long *

#define f90gluquadricobj      GLUquadricObj **
#define f90glunurbsobj        GLUnurbsObj **
#define f90glutriangulatorobj GLUtriangulatorObj **

/* types needed for GLU callback functions */

typedef void (*f90glTessBeginFunc) (GLenum *);
typedef void (*f90glTessEdge_FlagFunc) (GLint *);
typedef void (*f90glTessVertexFunc) (void *);
typedef void (*f90glTessEndFunc) (void);
typedef void (*f90glTessErrorFunc) (GLenum *);
typedef void (*f90glQuadErrorFunc) (GLenum *);
typedef void (*f90glNurbErrorFunc) (GLenum *);
struct {
   GLUtriangulatorObj* tess;
   f90glTessBeginFunc begin;
   f90glTessEdge_FlagFunc edge_flag;
   f90glTessVertexFunc vertex;
   f90glTessEndFunc end;
   f90glTessErrorFunc error;
} CurrentTess;
struct {
   GLUquadricObj* quad;
   f90glQuadErrorFunc error;
} CurrentQuadric;
struct {
   GLUnurbsObj* nurb;
   f90glNurbErrorFunc error;
} CurrentNurb;


/* procedure name mangling (more to follow) */

#if FBIND==1
#define f9ygluErrorString              f9ygluerrorstring
#define f9ygluNewQuadric               f9yglunewquadric
#define f9ygluDeleteQuadric            f9ygludeletequadric
#define f9ygluNewNurbsRenderer         f9yglunewnurbsrenderer
#define f9ygluNewTess                  f9yglunewtess
#define f9ygluGetString                f9yglugetstring
#define fgluGluNull                    glunull
#define f9ygluTessCallback             f9yglutesscallback
#define f9ygluBeginPolygon             f9yglubeginpolygon
#define f9ygluEndPolygon               f9ygluendpolygon
#define f9ygluNextContour              f9yglunextcontour
#define f9y0gluTessVertex              f9y0glutessvertex
#define f9y1gluTessVertex              f9y1glutessvertex
#define f9y2gluTessVertex              f9y2glutessvertex
#define f9y3gluTessVertex              f9y3glutessvertex
#define f9y4gluTessVertex              f9y4glutessvertex
#define f9y5gluTessVertex              f9y5glutessvertex
#define f9y6gluTessVertex              f9y6glutessvertex
#define f9ygluQuadricCallback          f9ygluquadriccallback
#define f9ygluQuadricDrawStyle         f9ygluquadricdrawstyle
#define f9ygluQuadricOrientation       f9ygluquadricorientation
#define f9ygluQuadricNormals           f9ygluquadricnormals
#define f9ygluQuadricTexture           f9ygluquadrictexture
#define f9ygluCylinder                 f9yglucylinder
#define f9ygluSphere                   f9yglusphere
#define f9ygluDisk                     f9ygludisk
#define f9ygluPartialDisk              f9yglupartialdisk
#define f9ygluNurbsCallback            f9yglunurbscallback
#define f9ygluLoadSamplingMatrices     f9ygluloadsamplingmatrices
#define f9ygluNurbsProperty            f9yglunurbsproperty
#define f9ygluGetNurbsProperty         f9yglugetnurbsproperty
#define f9ygluBeginCurve               f9yglubegincurve
#define f9ygluEndCurve                 f9ygluendcurve
#define f9ygluNurbsCurve               f9yglunurbscurve
#define f9ygluBeginSurface             f9yglubeginsurface
#define f9ygluEndSurface               f9ygluendsurface
#define f9ygluNurbsSurface             f9yglunurbssurface
#define f9ygluBeginTrim                f9yglubegintrim
#define f9ygluEndTrim                  f9ygluendtrim
#define f9ygluPwlCurve                 f9yglupwlcurve
#elif FBIND==2
#define f9ygluErrorString              f9ygluerrorstring_
#define f9ygluNewQuadric               f9yglunewquadric_
#define f9ygluDeleteQuadric            f9ygludeletequadric_
#define f9ygluNewNurbsRenderer         f9yglunewnurbsrenderer_
#define f9ygluNewTess                  f9yglunewtess_
#define f9ygluGetString                f9yglugetstring_
#define fgluGluNull                    glunull_
#define f9ygluTessCallback             f9yglutesscallback_
#define f9ygluBeginPolygon             f9yglubeginpolygon_
#define f9ygluEndPolygon               f9ygluendpolygon_
#define f9ygluNextContour              f9yglunextcontour_
#define f9y0gluTessVertex              f9y0glutessvertex_
#define f9y1gluTessVertex              f9y1glutessvertex_
#define f9y2gluTessVertex              f9y2glutessvertex_
#define f9y3gluTessVertex              f9y3glutessvertex_
#define f9y4gluTessVertex              f9y4glutessvertex_
#define f9y5gluTessVertex              f9y5glutessvertex_
#define f9y6gluTessVertex              f9y6glutessvertex_
#define f9ygluQuadricCallback          f9ygluquadriccallback_
#define f9ygluQuadricDrawStyle         f9ygluquadricdrawstyle_
#define f9ygluQuadricOrientation       f9ygluquadricorientation_
#define f9ygluQuadricNormals           f9ygluquadricnormals_
#define f9ygluQuadricTexture           f9ygluquadrictexture_
#define f9ygluCylinder                 f9yglucylinder_
#define f9ygluSphere                   f9yglusphere_
#define f9ygluDisk                     f9ygludisk_
#define f9ygluPartialDisk              f9yglupartialdisk_
#define f9ygluNurbsCallback            f9yglunurbscallback_
#define f9ygluLoadSamplingMatrices     f9ygluloadsamplingmatrices_
#define f9ygluNurbsProperty            f9yglunurbsproperty_
#define f9ygluGetNurbsProperty         f9yglugetnurbsproperty_
#define f9ygluBeginCurve               f9yglubegincurve_
#define f9ygluEndCurve                 f9ygluendcurve_
#define f9ygluNurbsCurve               f9yglunurbscurve_
#define f9ygluBeginSurface             f9yglubeginsurface_
#define f9ygluEndSurface               f9ygluendsurface_
#define f9ygluNurbsSurface             f9yglunurbssurface_
#define f9ygluBeginTrim                f9yglubegintrim_
#define f9ygluEndTrim                  f9ygluendtrim_
#define f9ygluPwlCurve                 f9yglupwlcurve_
#elif FBIND==3
#define f9ygluErrorString              F9YGLUERRORSTRING
#define f9ygluNewQuadric               F9YGLUNEWQUADRIC
#define f9ygluDeleteQuadric            F9YGLUDELETEQUADRIC
#define f9ygluNewNurbsRenderer         F9YGLUNEWNURBSRENDERER
#define f9ygluNewTess                  F9YBLUNEWTESS
#define f9ygluGetString                F9YGLUGETSTRING
#define fgluGluNull                    GLUNULL
#define f9ygluTessCallback             F9YGLUTESSCALLBACK
#define f9ygluBeginPolygon             F9YGLUBEGINPOLYGON
#define f9ygluEndPolygon               F9YGLUENDPOLYGON
#define f9ygluNextContour              F9YGLUNEXTCONTOUR
#define f9y0gluTessVertex              F9Y0GLUTESSVERTEX
#define f9y1gluTessVertex              F9Y1GLUTESSVERTEX
#define f9y2gluTessVertex              F9Y2GLUTESSVERTEX
#define f9y3gluTessVertex              F9Y3GLUTESSVERTEX
#define f9y4gluTessVertex              F9Y4GLUTESSVERTEX
#define f9y5gluTessVertex              F9Y5GLUTESSVERTEX
#define f9y6gluTessVertex              F9Y6GLUTESSVERTEX
#define f9ygluQuadricCallback          F9YGLUQUADRICCALLBACK
#define f9ygluQuadricDrawStyle         F9YGLUQUADRICDRAWSTYLE
#define f9ygluQuadricOrientation       F9YGLUQUADRICORIENTATION
#define f9ygluQuadricNormals           F9YGLUQUADRICNORMALS
#define f9ygluQuadricTexture           F9YGLUQUADRICTEXTURE
#define f9ygluCylinder                 F9YGLUCYLINDER
#define f9ygluSphere                   F9YGLUSPHERE
#define f9ygluDisk                     F9YGLUDISK
#define f9ygluPartialDisk              F9YGLUPARTIALDISK
#define f9ygluNurbsCallback            F9YGLUNURBSCALLBACK
#define f9ygluLoadSamplingMatrices     F9YGLULOADSAMPLINGMATRICES
#define f9ygluNurbsProperty            F9YGLUNURBSPROPERTY
#define f9ygluGetNurbsProperty         F9YGLUGETNURBSPROPERTY
#define f9ygluBeginCurve               F9YGLUBEGINCURVE
#define f9ygluEndCurve                 F9YGLUENDCURVE
#define f9ygluNurbsCurve               F9YGLUNURBSCURVE
#define f9ygluBeginSurface             F9YGLUBEGINSURFACE
#define f9ygluEndSurface               F9YGLUENDSURFACE
#define f9ygluNurbsSurface             F9YGLUNURBSSURFACE
#define f9ygluBeginTrim                F9YGLUBEGINTRIM
#define f9ygluEndTrim                  F9YGLUENDTRIM
#define f9ygluPwlCurve                 F9YGLUPWLCURVE
#endif


/* procedure name mangling */

#if FBIND==1
#define f9ygluErrorString              f9ygluerrorstring
#define f9egluQuadricTexture           f9egluquadrictexture
#define f9ygluNewNurbsRenderer         f9yglunewnurbsrenderer
#define f9ygluGetString                f9yglugetstring
#define f9y0gluScaleImage              f9y0gluscaleimage
#define f9y1gluScaleImage              f9y1gluscaleimage
#define f9y2gluScaleImage              f9y2gluscaleimage
#define f9y3gluScaleImage              f9y3gluscaleimage
#define f9y4gluScaleImage              f9y4gluscaleimage
#define f9y5gluScaleImage              f9y5gluscaleimage
#define f9y6gluScaleImage              f9y6gluscaleimage
#define f9y0gluBuild0DMipmaps          f9y1glubuild1dmipmaps
#define f9y1gluBuild1DMipmaps          f9y1glubuild1dmipmaps
#define f9y2gluBuild1DMipmaps          f9y2glubuild1dmipmaps
#define f9y3gluBuild1DMipmaps          f9y3glubuild1dmipmaps
#define f9y4gluBuild1DMipmaps          f9y4glubuild1dmipmaps
#define f9y5gluBuild1DMipmaps          f9y5glubuild1dmipmaps
#define f9y6gluBuild1DMipmaps          f9y6glubuild1dmipmaps
#define f9y0gluBuild2DMipmaps          f9y0glubuild2dmipmaps
#define f9y1gluBuild2DMipmaps          f9y1glubuild2dmipmaps
#define f9y2gluBuild2DMipmaps          f9y2glubuild2dmipmaps
#define f9y3gluBuild2DMipmaps          f9y3glubuild2dmipmaps
#define f9y4gluBuild2DMipmaps          f9y4glubuild2dmipmaps
#define f9y5gluBuild2DMipmaps          f9y5glubuild2dmipmaps
#define f9y6gluBuild2DMipmaps          f9y6glubuild2dmipmaps
#elif FBIND==2
#define f9ygluErrorString              f9ygluerrorstring_
#define f9egluQuadricTexture           f9egluquadrictexture_
#define f9ygluNewNurbsRenderer         f9yglunewnurbsrenderer_
#define f9ygluGetString                f9yglugetstring_
#define f9y0gluScaleImage              f9y0gluscaleimage_
#define f9y1gluScaleImage              f9y1gluscaleimage_
#define f9y2gluScaleImage              f9y2gluscaleimage_
#define f9y3gluScaleImage              f9y3gluscaleimage_
#define f9y4gluScaleImage              f9y4gluscaleimage_
#define f9y5gluScaleImage              f9y5gluscaleimage_
#define f9y6gluScaleImage              f9y6gluscaleimage_
#define f9y0gluBuild0DMipmaps          f9y1glubuild1dmipmaps_
#define f9y1gluBuild1DMipmaps          f9y1glubuild1dmipmaps_
#define f9y2gluBuild1DMipmaps          f9y2glubuild1dmipmaps_
#define f9y3gluBuild1DMipmaps          f9y3glubuild1dmipmaps_
#define f9y4gluBuild1DMipmaps          f9y4glubuild1dmipmaps_
#define f9y5gluBuild1DMipmaps          f9y5glubuild1dmipmaps_
#define f9y6gluBuild1DMipmaps          f9y6glubuild1dmipmaps_
#define f9y0gluBuild2DMipmaps          f9y0glubuild2dmipmaps_
#define f9y1gluBuild2DMipmaps          f9y1glubuild2dmipmaps_
#define f9y2gluBuild2DMipmaps          f9y2glubuild2dmipmaps_
#define f9y3gluBuild2DMipmaps          f9y3glubuild2dmipmaps_
#define f9y4gluBuild2DMipmaps          f9y4glubuild2dmipmaps_
#define f9y5gluBuild2DMipmaps          f9y5glubuild2dmipmaps_
#define f9y6gluBuild2DMipmaps          f9y6glubuild2dmipmaps_
#elif FBIND==3
#define f9ygluErrorString              F9YGLUERRORSTRING
#define f9egluQuadricTexture           F9EGLUQUADRICTEXTURE
#define f9ygluNewNurbsRenderer         F9YGLUNEWNURBSRENDERER
#define f9ygluGetString                F9YGLUGETSTRING
#define f9y0gluScaleImage              F9Y0GLUSCALEIMAGE
#define f9y1gluScaleImage              F9Y1GLUSCALEIMAGE
#define f9y2gluScaleImage              F9Y2GLUSCALEIMAGE
#define f9y3gluScaleImage              F9Y3GLUSCALEIMAGE
#define f9y4gluScaleImage              F9Y4GLUSCALEIMAGE
#define f9y5gluScaleImage              F9Y5GLUSCALEIMAGE
#define f9y6gluScaleImage              F9Y6GLUSCALEIMAGE
#define f9y0gluBuild1DMipmaps          F9Y0GLUBUILD1DMIPMAPS
#define f9y1gluBuild1DMipmaps          F9Y1GLUBUILD1DMIPMAPS
#define f9y2gluBuild1DMipmaps          F9Y2GLUBUILD1DMIPMAPS
#define f9y3gluBuild1DMipmaps          F9Y3GLUBUILD1DMIPMAPS
#define f9y4gluBuild1DMipmaps          F9Y4GLUBUILD1DMIPMAPS
#define f9y5gluBuild1DMipmaps          F9Y5GLUBUILD1DMIPMAPS
#define f9y6gluBuild1DMipmaps          F9Y6GLUBUILD1DMIPMAPS
#define f9y0gluBuild2DMipmaps          F9Y0GLUBUILD2DMIPMAPS
#define f9y1gluBuild2DMipmaps          F9Y1GLUBUILD2DMIPMAPS
#define f9y2gluBuild2DMipmaps          F9Y2GLUBUILD2DMIPMAPS
#define f9y3gluBuild2DMipmaps          F9Y3GLUBUILD2DMIPMAPS
#define f9y4gluBuild2DMipmaps          F9Y4GLUBUILD2DMIPMAPS
#define f9y5gluBuild2DMipmaps          F9Y5GLUBUILD2DMIPMAPS
#define f9y6gluBuild2DMipmaps          F9Y6GLUBUILD2DMIPMAPS
#endif

/* wrapper functions that change types */

void f9ygluErrorString(f90gluint temp, f90glint length, f90glenum errorCode)
{
   int i;
   unsigned char *str;
   str = (unsigned char *) gluErrorString( (GLenum) *errorCode);
   *length = 0;
   if (str) {
      *length = strlen(str);
      if (*length > 256) *length = 256;
      for (i=0;i<*length;i++) temp[i] = (GLuint) str[i];
   }
}

void fgluGluNull(void)
{
}

void f90fcbQuadError(GLenum errno)
{
   CurrentQuadric.error(&errno);
}

void f90gluiSetCurrentQuadric(f90gluquadricobj quadObject)
{
   CurrentQuadric.quad = (GLUquadricObj *) quadObject[0];
   CurrentQuadric.error = (f90glQuadErrorFunc) quadObject[1];
   gluQuadricCallback(CurrentQuadric.quad, GLU_ERROR, f90fcbQuadError);
}

void f9ygluNewQuadric(f90gluint temp, f90glint nbytes)
{
   GLUquadricObj *quadObject[2];
   unsigned char *p;
   int i;
   quadObject[0] = (GLUquadricObj *) gluNewQuadric();
   quadObject[1] = (GLUquadricObj *) fgluGluNull;
   f90gluiSetCurrentQuadric((f90gluquadricobj)quadObject);
   p = (unsigned char *) quadObject;
   for (i=0; i<2*(*nbytes); i++) {temp[i]=(GLuint)*p; p++;}
}

void f9ygluDeleteQuadric(f90gluint temp, f90glint nbytes)
{
   GLUquadricObj *quadObject[2];
   unsigned char *p;
   int i;
   p = (unsigned char *) quadObject;
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   gluDeleteQuadric(quadObject[0]);
}

void f9ygluQuadricCallback(f90gluint temp, f90glint nbytes, f90glenum which, void (*fn)(GLenum))
{
   GLUquadricObj *quadObject[2];
   unsigned char *p;
   int i;
   p = (unsigned char *) quadObject;
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (*which == GLU_ERROR) {
      quadObject[1] = (GLUquadricObj *) fn;
   }
   f90gluiSetCurrentQuadric(quadObject);
   gluQuadricCallback(CurrentQuadric.quad, (GLenum) *which, fn);

   p = (unsigned char *) quadObject;
   for (i=0; i<2*(*nbytes); i++) {temp[i]=(GLuint)*p; p++;}
}

void f9ygluQuadricDrawStyle( f90gluint temp, f90glint nbytes, f90glenum drawStyle )
{
   GLUquadricObj *quadObject[2];  
   unsigned char *p; 
   int i; 
   p = (unsigned char *) quadObject; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentQuadric.quad != (GLUquadricObj *) quadObject[0]) {
      f90gluiSetCurrentQuadric(quadObject);
   }
   gluQuadricDrawStyle( CurrentQuadric.quad, (GLenum) *drawStyle );
}
 
void f9ygluQuadricOrientation( f90gluint temp, f90glint nbytes,
    f90glenum orientation )
{
   GLUquadricObj *quadObject[2];  
   unsigned char *p; 
   int i; 
   p = (unsigned char *) quadObject; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentQuadric.quad != (GLUquadricObj *) quadObject[0]) {
      f90gluiSetCurrentQuadric(quadObject);
   }
   gluQuadricOrientation( CurrentQuadric.quad, (GLenum) *orientation );
}
 
void f9ygluQuadricNormals( f90gluint temp, f90glint nbytes, f90glenum normals )
{
   GLUquadricObj *quadObject[2];  
   unsigned char *p; 
   int i; 
   p = (unsigned char *) quadObject; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentQuadric.quad != (GLUquadricObj *) quadObject[0]) {
      f90gluiSetCurrentQuadric(quadObject);
   }
   gluQuadricNormals( CurrentQuadric.quad, (GLenum) *normals );
}
 
void f9ygluQuadricTexture( f90gluint temp, f90glint nbytes,
    f90glboolean textureCoords )
{
   GLUquadricObj *quadObject[2];  
   unsigned char *p; 
   int i; 
   p = (unsigned char *) quadObject; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentQuadric.quad != (GLUquadricObj *) quadObject[0]) {
      f90gluiSetCurrentQuadric(quadObject);
   }
   gluQuadricTexture( CurrentQuadric.quad, (GLboolean) *textureCoords );
}
 
void f9egluQuadricTexture( f90gluint temp, f90glint nbytes,
    f90glint textureCoords )
{
   GLUquadricObj *quadObject[2];  
   unsigned char *p; 
   int i; 
   p = (unsigned char *) quadObject; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentQuadric.quad != (GLUquadricObj *) quadObject[0]) {
      f90gluiSetCurrentQuadric(quadObject);
   }
   gluQuadricTexture( CurrentQuadric.quad, (GLboolean) *textureCoords );
}
 
void f9ygluCylinder( f90gluint temp, f90glint nbytes, f90gldouble baseRadius,
    f90gldouble topRadius, f90gldouble height, f90glint slices,
    f90glint stacks )
{
   GLUquadricObj *qobj[2];  
   unsigned char *p; 
   int i; 
   p = (unsigned char *) qobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentQuadric.quad != (GLUquadricObj *) qobj[0]) {
      f90gluiSetCurrentQuadric(qobj);
   }
   gluCylinder( CurrentQuadric.quad, (GLdouble) *baseRadius,
    (GLdouble) *topRadius, (GLdouble) *height, (GLint) *slices,
    (GLint) *stacks );
}

void f9ygluSphere( f90gluint temp, f90glint nbytes, f90gldouble radius, f90glint slices,
    f90glint stacks )
{
   GLUquadricObj *qobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) qobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentQuadric.quad != (GLUquadricObj *) qobj[0]) {
      f90gluiSetCurrentQuadric(qobj);
   }
   gluSphere( CurrentQuadric.quad, (GLdouble) *radius, (GLint) *slices,
    (GLint) *stacks );
}

void f9ygluDisk( f90gluint temp, f90glint nbytes, f90gldouble innerRadius,
    f90gldouble outerRadius, f90glint slices, f90glint loops )
{
   GLUquadricObj *qobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) qobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
 
   if (CurrentQuadric.quad != (GLUquadricObj *) qobj[0]) {
      f90gluiSetCurrentQuadric(qobj);
   }
   gluDisk( CurrentQuadric.quad, (GLdouble) *innerRadius,
    (GLdouble) *outerRadius, (GLint) *slices, (GLint) *loops );
}

void f9ygluPartialDisk( f90gluint temp, f90glint nbytes, f90gldouble innerRadius,
    f90gldouble outerRadius, f90glint slices, f90glint loops,
    f90gldouble startAngle, f90gldouble sweepAngle )
{
   GLUquadricObj *qobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) qobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
 
   if (CurrentQuadric.quad != (GLUquadricObj *) qobj[0]) {
      f90gluiSetCurrentQuadric(qobj);
   }
   gluPartialDisk( CurrentQuadric.quad, (GLdouble) *innerRadius,
    (GLdouble) *outerRadius, (GLint) *slices, (GLint) *loops,
    (GLdouble) *startAngle, (GLdouble) *sweepAngle );
}

void f90fcbNurbError(GLenum errno)
{
   CurrentNurb.error(&errno);
}

void f90gluiSetCurrentNurb(f90glunurbsobj nobj)
{
   CurrentNurb.nurb = (GLUnurbsObj *) nobj[0];
   CurrentNurb.error = (f90glNurbErrorFunc) nobj[1];
   gluNurbsCallback(CurrentNurb.nurb, GLU_ERROR, f90fcbNurbError);
}

void f9ygluNewNurbsRenderer(f90gluint temp, f90glint nbytes)
{
   GLUnurbsObj *nobj[2];
   unsigned char *p;
   int i;
   nobj[0] = (GLUnurbsObj *) gluNewNurbsRenderer();
   nobj[1] = (GLUnurbsObj *) fgluGluNull;
   f90gluiSetCurrentNurb(nobj);
   p = (unsigned char *) nobj;
   for (i=0; i<2*(*nbytes); i++) {temp[i]=(GLuint)*p; p++;}
}

void f9ygluNurbsCallback(f90gluint temp, f90glint nbytes, f90glenum which, void (*fn)(GLenum))
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (*which == GLU_ERROR) {
      nobj[1] = (GLUnurbsObj *) fn;
   }
   f90gluiSetCurrentNurb(nobj);
   gluNurbsCallback(CurrentNurb.nurb, (GLenum) *which, fn);
   p = (unsigned char *) nobj;
   for (i=0; i<2*(*nbytes); i++) {temp[i]=(GLuint)*p; p++;}
}

void f9ygluLoadSamplingMatrices( f90gluint temp, f90glint nbytes, f90glfloat modelMatrix,
    f90glfloat projMatrix, f90glint viewport )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluLoadSamplingMatrices( CurrentNurb.nurb, (GLfloat *) modelMatrix,
    (GLfloat *) projMatrix, (GLint *) viewport );
}

void f9ygluNurbsProperty( f90gluint temp, f90glint nbytes, f90glenum property,
    f90glfloat value )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluNurbsProperty( CurrentNurb.nurb, (GLenum) *property,
    (GLfloat) *value );
}

void f9ygluGetNurbsProperty( f90gluint temp, f90glint nbytes, f90glenum property,
    f90glfloat value )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluGetNurbsProperty( CurrentNurb.nurb, (GLenum) *property,
    (GLfloat *) value );
}

void f9ygluBeginCurve( f90gluint temp, f90glint nbytes )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluBeginCurve( CurrentNurb.nurb );
}

void f9ygluEndCurve( f90gluint temp, f90glint nbytes )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluEndCurve( CurrentNurb.nurb );
}

void f9ygluNurbsCurve( f90gluint temp, f90glint nbytes, f90glint nknots, f90glfloat knot,
    f90glint stride, f90glfloat ctlarray, f90glint order, f90glenum type )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluNurbsCurve( CurrentNurb.nurb, (GLint) *nknots, (GLfloat *) knot,
    (GLint) *stride, (GLfloat *) ctlarray, (GLint) *order, (GLenum) *type );
}

void f9ygluBeginSurface( f90gluint temp, f90glint nbytes )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluBeginSurface( CurrentNurb.nurb );
}

void f9ygluEndSurface( f90gluint temp, f90glint nbytes )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluEndSurface( CurrentNurb.nurb );
}

void f9ygluNurbsSurface( f90gluint temp, f90glint nbytes, f90glint sknot_count,
    f90glfloat sknot, f90glint tknot_count, f90glfloat tknot,
    f90glint s_stride, f90glint t_stride, f90glfloat ctlarray, f90glint sorder,
    f90glint torder, f90glenum type )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluNurbsSurface( CurrentNurb.nurb, (GLint) *sknot_count,
    (GLfloat *) sknot, (GLint) *tknot_count, (GLfloat *) tknot,
    (GLint) *s_stride, (GLint) *t_stride, (GLfloat *) ctlarray,
    (GLint) *sorder, (GLint) *torder, (GLenum) *type );
}

void f9ygluBeginTrim( f90gluint temp, f90glint nbytes )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluBeginTrim( CurrentNurb.nurb );
}

void f9ygluEndTrim( f90gluint temp, f90glint nbytes )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluEndTrim( CurrentNurb.nurb );
}

void f9ygluPwlCurve( f90gluint temp, f90glint nbytes, f90glint count, f90glfloat array,
    f90glint stride, f90glenum type )
{
   GLUnurbsObj *nobj[2]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) nobj; 
   for (i=0; i<2*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentNurb.nurb != (GLUnurbsObj *) nobj[0]) {
      f90gluiSetCurrentNurb(nobj);
   }
   gluPwlCurve( CurrentNurb.nurb, (GLint) *count, (GLfloat *) array,
    (GLint) *stride, (GLenum) *type );
}

void f90fcbTessBegin(GLenum type)
{
   CurrentTess.begin(&type);
}

void f90fcbTessEdge_Flag(GLboolean flag)
{
   CurrentTess.edge_flag((GLint *) &flag);
}

void f90fcbTessVertex(void *data)
{
   CurrentTess.vertex(data);
}

void f90fcbTessEnd(void)
{
   CurrentTess.end();
}

void f90fcbTessError(GLenum errno)
{
   CurrentTess.error(&errno);
}

void f90gluiSetCurrentTess(f90glutriangulatorobj tobj)
{
   CurrentTess.tess = (GLUtriangulatorObj *) tobj[0];
   CurrentTess.begin = (f90glTessBeginFunc) tobj[1];
   CurrentTess.edge_flag = (f90glTessEdge_FlagFunc) tobj[2];
   CurrentTess.vertex = (f90glTessVertexFunc) tobj[3];
   CurrentTess.end = (f90glTessEndFunc) tobj[4];
   CurrentTess.error = (f90glTessErrorFunc) tobj[5];
   gluTessCallback(CurrentTess.tess, GLU_BEGIN, f90fcbTessBegin);
   gluTessCallback(CurrentTess.tess, GLU_EDGE_FLAG, f90fcbTessEdge_Flag);
   gluTessCallback(CurrentTess.tess, GLU_VERTEX, f90fcbTessVertex);
   gluTessCallback(CurrentTess.tess, GLU_END, f90fcbTessEnd);
   gluTessCallback(CurrentTess.tess, GLU_ERROR, f90fcbTessError);
}

void f9ygluNewTess(f90gluint temp, f90glint nbytes)
{
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i;
   tobj[0] = (GLUtriangulatorObj *) gluNewTess();
   tobj[1] = tobj[2] = tobj[3] = tobj[4] = tobj[5] = (GLUtriangulatorObj *) fgluGluNull;
   f90gluiSetCurrentTess(tobj);
   p = (unsigned char *) tobj;
   for (i=0; i<6*(*nbytes); i++) {temp[i]=(GLuint)*p; p++;}
}

void f9ygluTessCallback(f90gluint temp, f90glint nbytes, f90glenum which, void (*fn)())
{
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   switch (*which) {
   case GLU_BEGIN:
      tobj[1] = (GLUtriangulatorObj *) fn;
      break;
   case GLU_EDGE_FLAG:
      tobj[2] = (GLUtriangulatorObj *) fn;
      break;
   case GLU_VERTEX:
      tobj[3] = (GLUtriangulatorObj *) fn;
      break;
   case GLU_END:
      tobj[4] = (GLUtriangulatorObj *) fn;
      break;
   case GLU_ERROR:
      tobj[5] = (GLUtriangulatorObj *) fn;
      break;
   }
   f90gluiSetCurrentTess(tobj);
   gluTessCallback( CurrentTess.tess, (GLenum) *which, fn );
   p = (unsigned char *) tobj;
   for (i=0; i<6*(*nbytes); i++) {temp[i]=(GLuint)*p; p++;}
}

void f9ygluBeginPolygon(f90gluint temp, f90glint nbytes)
{
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluBeginPolygon(CurrentTess.tess);
}

void f9ygluEndPolygon(f90gluint temp, f90glint nbytes)
{
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluEndPolygon(CurrentTess.tess);
}

void f9ygluNextContour(f90gluint temp, f90glint nbytes, f90glenum type)
{
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluNextContour(CurrentTess.tess, (GLenum) *type);
}

void f9y0gluTessVertex(f90gluint temp, f90glint nbytes, f90gldouble v, f90glvoid data)
{
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluTessVertex(CurrentTess.tess, (GLdouble *) v, (GLvoid *) data);
}

void f9ygluGetString(f90gluint temp, f90glint length, f90glenum name)
{
   int i;
   unsigned char *str;
   str = (unsigned char *) gluGetString( (GLenum) *name);
   *length = 0;
   if (str) {
      *length = strlen(str);
      if (*length > 256) *length = 256;
      for (i=0;i<*length;i++) temp[i] = (GLuint) str[i];
   }
}

GLint f9y0gluScaleImage( f90glenum format, f90glint widthin, f90glint heightin,
    f90glenum typein, f90glvoid datain, f90glint widthout,
    f90glint heightout, f90glenum typeout, f90glvoid dataout )
{

GLint result;

switch (*typein) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newdatain, *newdataout;
   int i;
   newdatain = (GLubyte *) malloc((*widthin)*(*heightin)*sizeof(GLubyte));
   newdataout= (GLubyte *) malloc((*widthout)*(*heightout)*sizeof(GLubyte));
   for (i=0;i<(*widthin)*(*heightin);i++) newdatain[i]=(GLubyte)datain[i];
   result = (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) newdatain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) newdataout );
   free(newdatain);
   for (i=0;i<(*widthout)*(*heightout);i++) dataout[i]=(GLint)newdataout[i];
   free(newdataout);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newdatain, *newdataout;
   int i;
   newdatain = (GLbyte *) malloc((*widthin)*(*heightin)*sizeof(GLbyte));
   newdataout = (GLbyte *) malloc((*widthout)*(*heightout)*sizeof(GLbyte));
   for (i=0;i<(*widthin)*(*heightin);i++) newdatain[i]=(GLbyte)datain[i];
   result = (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) newdatain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) newdataout );
   free(newdatain);
   for (i=0;i<(*widthout)*(*heightout);i++) dataout[i]=(GLint)newdataout[i];
   free(newdataout);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newdatain, *newdataout;
   int i;
   newdatain = (GLushort *) malloc((*widthin)*(*heightin)*sizeof(GLushort));
   newdataout = (GLushort *) malloc((*widthout)*(*heightout)*sizeof(GLushort));
   for (i=0;i<(*widthin)*(*heightin);i++) newdatain[i]=(GLushort)datain[i];
   result = (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) newdatain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) newdataout );
   free(newdatain);
   for (i=0;i<(*widthout)*(*heightout);i++) dataout[i]=(GLint)newdataout[i];
   free(newdataout);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newdatain, *newdataout;
   int i;
   newdatain = (GLshort *) malloc((*widthin)*(*heightin)*sizeof(GLshort));
   newdataout = (GLshort *) malloc((*widthout)*(*heightout)*sizeof(GLshort));
   for (i=0;i<(*widthin)*(*heightin);i++) newdatain[i]=(GLshort)datain[i];
   result = (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) newdatain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) newdataout );
   free(newdatain);
   for (i=0;i<(*widthout)*(*heightout);i++) dataout[i]=(GLint)newdataout[i];
   free(newdataout);
   break;
  }
 default:
   result = (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) datain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) dataout );
   break;
}
return result;
}
 
GLint f9y1gluScaleImage( f90glenum format, f90glint widthin, f90glint heightin,
    f90glenum typein, f90glvoid datain, f90glint widthout,
    f90glint heightout, f90glenum typeout, f90glvoid dataout )
{
   return (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) datain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) dataout );
}
 
GLint f9y2gluScaleImage( f90glenum format, f90glint widthin, f90glint heightin,
    f90glenum typein, f90glvoid datain, f90glint widthout,
    f90glint heightout, f90glenum typeout, f90glvoid dataout )
{
   return (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) datain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) dataout );
}
 
GLint f9y3gluScaleImage( f90glenum format, f90glint widthin, f90glint heightin,
    f90glenum typein, f90glvoid datain, f90glint widthout,
    f90glint heightout, f90glenum typeout, f90glvoid dataout )
{
   return (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) datain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) dataout );
}

GLint f9y4gluScaleImage( f90glenum format, f90glint widthin, f90glint heightin,
    f90glenum typein, f90gluint temp1, f90glint widthout,
    f90glint heightout, f90glenum typeout, f90gluint temp2, f90glint nbytes)
{
   GLvoid *datain, *dataout;
   unsigned char *p; 
   int i;
   p = (unsigned char *) &datain;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp1[i]; p++;}
   p = (unsigned char *) &dataout;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp2[i]; p++;}
   return (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) datain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) dataout );
}

GLint f9y5gluScaleImage( f90glenum format, f90glint widthin, f90glint heightin,
    f90glenum typein, f90glvoid datain, f90glint widthout,
    f90glint heightout, f90glenum typeout, f90glvoid dataout )
{
   return (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) datain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) dataout );
}

GLint f9y6gluScaleImage( f90glenum format, f90glint widthin, f90glint heightin,
    f90glenum typein, f90glvoid datain, f90glint widthout,
    f90glint heightout, f90glenum typeout, f90glvoid dataout )
{

GLint result;

switch (*typein) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newdatain, *newdataout;
   int i;
   newdatain = (GLubyte *) malloc((*widthin)*(*heightin)*sizeof(GLubyte));
   newdataout = (GLubyte *) malloc((*widthout)*(*heightout)*sizeof(GLubyte));
   for (i=0;i<(*widthin)*(*heightin);i++) newdatain[i]=(GLubyte)datain[i];
   result = (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) newdatain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) newdataout );
   free(newdatain);
   for (i=0;i<(*widthout)*(*heightout);i++) dataout[i]=(GLshort)newdataout[i];
   free(newdataout);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newdatain, *newdataout;
   int i;
   newdatain = (GLbyte *) malloc((*widthin)*(*heightin)*sizeof(GLbyte));
   newdataout = (GLbyte *) malloc((*widthout)*(*heightout)*sizeof(GLbyte));
   for (i=0;i<(*widthin)*(*heightin);i++) newdatain[i]=(GLubyte)datain[i];
   result = (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) newdatain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) newdataout );
   free(newdatain);
   for (i=0;i<(*widthout)*(*heightout);i++) dataout[i]=(GLshort)newdataout[i];
   free(newdataout);
   break;
  }
 default:
   result = (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) datain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) dataout );
   break;
}
return result;
}

GLint f9y0gluBuild1DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glenum format, f90glenum type, f90glvoid data )
{

GLint result;

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newdata;
   int i;
   newdata = (GLubyte *) malloc((*width)*sizeof(GLubyte));
   for (i=0;i<(*width);i++) newdata[i]=(GLubyte)data[i];
   result = (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) newdata );
   free(newdata);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newdata;
   int i;
   newdata = (GLbyte *) malloc((*width)*sizeof(GLbyte));
   for (i=0;i<(*width);i++) newdata[i]=(GLubyte)data[i];
   result = (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) newdata );
   free(newdata);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newdata;
   int i;
   newdata = (GLushort *) malloc((*width)*sizeof(GLushort));
   for (i=0;i<(*width);i++) newdata[i]=(GLushort)data[i];
   result = (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) newdata );
   free(newdata);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newdata;
   int i;
   newdata = (GLshort *) malloc((*width)*sizeof(GLshort));
   for (i=0;i<(*width);i++) newdata[i]=(GLshort)data[i];
   result = (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) newdata );
   free(newdata);
   break;
  }
 default:
   result = (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) data );
   break;
}
return result;
}

GLint f9y1gluBuild1DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glenum format, f90glenum type, f90glvoid data )
{
   return (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) data );
}

GLint f9y2gluBuild1DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glenum format, f90glenum type, f90glvoid data )
{
   return (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) data );
}

GLint f9y3gluBuild1DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glenum format, f90glenum type, f90glvoid data )
{
   return (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) data );
}

GLint f9y4gluBuild1DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glenum format, f90glenum type, f90gluint temp, f90glint nbytes)
{
   GLvoid *data;
   unsigned char *p; 
   int i;
   p = (unsigned char *) &data;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   return (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) data );
}

GLint f9y5gluBuild1DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glenum format, f90glenum type, f90glvoid data )
{
   return (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) data );
}

GLint f9y6gluBuild1DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glenum format, f90glenum type, f90glvoid data )
{

GLint result;

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newdata;
   int i;
   newdata = (GLubyte *) malloc((*width)*sizeof(GLubyte));
   for (i=0;i<(*width);i++) newdata[i]=(GLubyte)data[i];
   result = (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) newdata );
   free(newdata);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newdata;
   int i;
   newdata = (GLbyte *) malloc((*width)*sizeof(GLbyte));
   for (i=0;i<(*width);i++) newdata[i]=(GLubyte)data[i];
   result = (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) newdata );
   free(newdata);
   break;
  }
 default:
   result = (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) data );
   break;
}
return result;
}

GLint f9y0gluBuild2DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glint height, f90glenum format, f90glenum type,
    f90glvoid data )
{

GLint result;

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newdata;
   int i;
   newdata = (GLubyte *) malloc((*width)*(*height)*sizeof(GLubyte));
   for (i=0;i<(*width)*(*height);i++) newdata[i]=(GLubyte)data[i];
   result = (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newdata );
   free(newdata);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newdata;
   int i;
   newdata = (GLbyte *) malloc((*width)*(*height)*sizeof(GLbyte));
   for (i=0;i<(*width)*(*height);i++) newdata[i]=(GLubyte)data[i];
   result = (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newdata );
   free(newdata);
   break;
  }
 case GL_UNSIGNED_SHORT:
  {
   GLushort *newdata;
   int i;
   newdata = (GLushort *) malloc((*width)*(*height)*sizeof(GLushort));
   for (i=0;i<(*width)*(*height);i++) newdata[i]=(GLushort)data[i];
   result = (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newdata );
   free(newdata);
   break;
  }
 case GL_SHORT:
  {
   GLshort *newdata;
   int i;
   newdata = (GLshort *) malloc((*width)*(*height)*sizeof(GLshort));
   for (i=0;i<(*width)*(*height);i++) newdata[i]=(GLshort)data[i];
   result = (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newdata );
   free(newdata);
   break;
  }
 default:
   result = (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) data );
   break;
}
return result;
}

GLint f9y1gluBuild2DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glint height, f90glenum format, f90glenum type,
    f90glvoid data )
{
   return (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) data );
}

GLint f9y2gluBuild2DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glint height, f90glenum format, f90glenum type,
    f90glvoid data )
{
   return (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) data );
}

GLint f9y3gluBuild2DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glint height, f90glenum format, f90glenum type,
    f90glvoid data )
{
   return (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) data );
}

GLint f9y4gluBuild2DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glint height, f90glenum format, f90glenum type,
    f90gluint temp, f90glint nbytes)
{
   GLvoid *data;
   unsigned char *p; 
   int i;
   p = (unsigned char *) &data;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   return (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) data );
}

GLint f9y5gluBuild2DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glint height, f90glenum format, f90glenum type,
    f90glvoid data )
{
   return (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) data );
}

GLint f9y6gluBuild2DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glint height, f90glenum format, f90glenum type,
    f90glvoid data )
{

GLint result;

switch (*type) {

 case GL_UNSIGNED_BYTE: case GL_BITMAP:
  {
   GLubyte *newdata;
   int i;
   newdata = (GLubyte *) malloc((*width)*(*height)*sizeof(GLubyte));
   for (i=0;i<(*width)*(*height);i++) newdata[i]=(GLubyte)data[i];
   result = (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newdata );
   free(newdata);
   break;
  }
 case GL_BYTE:
  {
   GLbyte *newdata;
   int i;
   newdata = (GLbyte *) malloc((*width)*(*height)*sizeof(GLbyte));
   for (i=0;i<(*width)*(*height);i++) newdata[i]=(GLubyte)data[i];
   result = (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) newdata );
   free(newdata);
   break;
  }
 default:
   result = (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) data );
   break;
}
return result;
}

void f9y1gluTessVertex(f90gluint temp, f90glint nbytes, f90gldouble v, f90glvoid data){
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluTessVertex(CurrentTess.tess, (GLdouble *) v, (GLvoid *) data);
}

void f9y2gluTessVertex(f90gluint temp, f90glint nbytes, f90gldouble v, f90glvoid data){
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluTessVertex(CurrentTess.tess, (GLdouble *) v, (GLvoid *) data);
}

void f9y3gluTessVertex(f90gluint temp, f90glint nbytes, f90gldouble v, f90glvoid data){
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluTessVertex(CurrentTess.tess, (GLdouble *) v, (GLvoid *) data);
}

void f9y4gluTessVertex(f90gluint temp, f90glint nbytes, f90gldouble v, f90gluint temp2){
   GLUtriangulatorObj *tobj[6]; 
   GLvoid *data;
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}
   p = (unsigned char *) &data;
   for (i=0; i<(*nbytes); i++) { *p = (unsigned char)temp2[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluTessVertex(CurrentTess.tess, (GLdouble *) v, (GLvoid *) data);
}

void f9y5gluTessVertex(f90gluint temp, f90glint nbytes, f90gldouble v, f90glvoid data){
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluTessVertex(CurrentTess.tess, (GLdouble *) v, (GLvoid *) data);
}

void f9y6gluTessVertex(f90gluint temp, f90glint nbytes, f90gldouble v, f90glvoid data){
   GLUtriangulatorObj *tobj[6]; 
   unsigned char *p; 
   int i; 
   p = (unsigned char *) tobj; 
   for (i=0; i<6*(*nbytes); i++) { *p = (unsigned char)temp[i]; p++;}

   if (CurrentTess.tess != (GLUtriangulatorObj *) tobj[0]) {
      f90gluiSetCurrentTess(tobj);
   }
   gluTessVertex(CurrentTess.tess, (GLdouble *) v, (GLvoid *) data);
}

#else /*ifdef FBIND*/



/* If FBIND is not defined, Fortran bindings aren't made.  Need this
 * dummy function for some picky compilers.
 */
static void dummy()
{
   return;
}

 
 
#endif /*ifdef FBIND*/
